

#define  ELECTRON_CHARGE        1.602191770e-19         /* C */
#define  BOLTZMANN              1.38062259e-23          /* J/oK */

/* arithmetics */
#define EXP90 1.220403294317841e+039
#define m00_hypot(v00,x,y)      v00 = sqrt((x)*(x)+(y)*(y));
#define m10_hypot(v10,v00,x,y)  v10 = (x)/(v00);
#define m11_hypot(v11,v00,x,y)  v11 = (y)/(v00);
#define m00_max(v00,x,y)        v00 = ((x)>(y))?(x):(y);
#define m10_max(v10,v00,x,y)    v10 = ((x)>(y))?1.0:0.0;
#define m11_max(v11,v00,x,y)    v11 = ((x)>(y))?0.0:1.0;
#define m00_min(v00,x,y)        v00 = ((x)<(y))?(x):(y);
#define m10_min(v10,v00,x,y)    v10 = ((x)<(y))?1.0:0.0;
#define m11_min(v11,v00,x,y)    v11 = ((x)<(y))?0.0:1.0;
#define m00_pow(v00,x,y)        v00 = pow(x,y);
#define m10_pow(v10,v00,x,y)    v10 = (x==0.0)?0.0:(v00)*(y)/(x);
#define m11_pow(v11,v00,x,y)    v11 = (x==0.0)?0.0:(log(x)*(v00));
#define m00_div(v00,v10,x,y)    double v10=1/(y); double v00=(x)*v10;
#define m10_div(v10,v00,vv,x,y)
#define m11_div(v11,v00,vv,x,y) double v11 = -v00*vv;
#define m00_mult(v00,v10,v11,x,y) double v10=(x); double v11=(y); double v00=v10*v11;
#define m00_add(v00,x,y)        double v00=(x)+(y);
#define m00_cos(v00,x)          v00 = cos(x);
#define m10_cos(v10,v00,x)      v10 = (-sin(x));
#define m00_sin(v00,x)          v00 = sin(x);
#define m10_sin(v10,v00,x)      v10 = (cos(x));
#define m00_tan(v00,x)          v00 = tan(x);
#define m10_tan(v10,v00,x)      v10 = (1.0/cos(x)/cos(x));
#define m00_cosh(v00,x)         v00 = cosh(x);
#define m10_cosh(v10,v00,x)     v10 = (sinh(x));
#define m00_sinh(v00,x)         v00 = sinh(x);
#define m10_sinh(v10,v00,x)     v10 = (cosh(x));
#define m00_tanh(v00,x)         v00 = tanh(x);
#define m10_tanh(v10,v00,x)     v10 = (1.0/cosh(x)/cosh(x));
#define m00_acos(v00,x)         v00 = acos(x);
#define m10_acos(v10,v00,x)     v10 = (-1.0/sqrt(1-x*x));
#define m00_asin(v00,x)         v00 = asin(x);
#define m10_asin(v10,v00,x)     v10 = (+1.0/sqrt(1-x*x));
#define m00_atan(v00,x)         v00 = atan(x);
#define m10_atan(v10,v00,x)     v10 = (+1.0/(1+x*x));
#define m00_logE(v00,x)         v00 = log(x);
#define m10_logE(v10,v00,x)     v10 = (1.0/x);
#define m00_log10(v00,x)        v00 = log10(x);
#define m10_log10(v10,v00,x)    v10 = (1.0/x/log(10));
#define m00_sqrt(v00,x)         v00 = sqrt(x);
#define m10_sqrt(v10,v00,x)     v10 = (0.5/v00);
#define m00_fabs(v00,x)         v00 = fabs(x);
#define m10_fabs(v10,v00,x)     v10 = (((x)>=0)?(+1.0):(-1.0));
#define m00_exp(v00,x)          v00 = exp(x);
#define m10_exp(v10,v00,x)      v10 = v00;
#define m00_abs(v00)            ((v00)<(0)?(-(v00)):(v00))
#define m00_floor(v00,x)        v00 = floor(x);
#define m00_ceil(v00,x)         v00 = ceil(x);
#define m00_limexp(v00,x)       v00 = ((x)<90.0?exp(x):EXP90*(x-89.0));
#define m10_limexp(v10,v00,x)   v10 = ((x)<90.0?(v00):EXP90);
#define m00_atan2(v00,x,y)      v00 = atan2(x,y);
#define m10_atan2(v10,x,y)      v10 = (-(y)/((x)*(x)+(y)*(y)));
#define m11_atan2(v11,x,y)      v11 = ((x)/((x)*(x)+(y)*(y)));
#define m00_acosh(v00,x)        v00 = acosh(x);
#define m10_acosh(v10,v00,x)    v10 = (1.0/(sqrt(x-1)*sqrt(x+1)));
#define m00_asinh(v00,x)        v00 = asinh(x);
#define m10_asinh(v10,v00,x)    v10 = (1.0/(sqrt(x*x+1)));
#define m00_atanh(v00,x)        v00 = atanh(x);
#define m10_atanh(v10,v00,x)    v10 = (1.0/(1-x*x));

#define m20_logE(v00)         (-1.0/v00/v00)
#define m20_exp(v00)          exp(v00)
#define m20_limexp(v00)       ((v00)<90.0?exp(v00):0.0)
#define m20_sqrt(v00)         (-0.25/(v00)/sqrt(v00))
#define m20_fabs(v00)         0.0

/*wrapper*/
#define pModel model
#define pInst here
#define mint_get_circuit_tempK() _circuit_temp
#define voltages(n) NP(n)
#define _DDT(q) q
#define _DDX
#define _DERIVATEFORDDX
pInst->fpnoise0=0.0; pInst->fenoise0=0.0;
pInst->wnoise0=0.0;
double r_ac;
double g_ac;
double drfdv;
double power;
double fn;
#if defined(_DERIVATE)
double fn_Vn1_n2;
#endif
double wn;
#if defined(_DERIVATE)
double wn_Vn1_n2;
#endif
#if defined(_DERIVATE)
double i_Vn1_n2;
#endif
double v;
#if defined(_DERIVATE)
double v_Vn1_n2;
#endif
double r_dc;
#if defined(_DERIVATE)
double r_dc_Vn1_n2;
#endif
#if defined(_DERIVATE)
double rFactor_Vn1_n2;
#endif
double cbrf;
#if defined(_DERIVATE)
double cbrf_Vn1_n2;
#endif
double q3E;
#if defined(_DERIVATE)
double q3E_Vn1_n2;
#endif
double sqrf;
#if defined(_DERIVATE)
double sqrf_Vn1_n2;
#endif
double q2E;
#if defined(_DERIVATE)
double q2E_Vn1_n2;
#endif
double E;
#if defined(_DERIVATE)
double E_Vn1_n2;
#endif
double vin;
#if defined(_DERIVATE)
double vin_Vn1_n2;
#endif
{
#if defined(_DERIVATE) /* probe=V(n1,n2) ddxprobe= */
vin_Vn1_n2=1.0;
#endif
vin=(NP(n1)-NP(n2));
EXIT_IF_ISNAN((NP(n1)-NP(n2)))
if
(((pInst->r0>0.0)&&((pModel->p2>0.0)||(pModel->p3>0.0))))
{
#if defined(_DERIVATE) /* probe=V(n1,n2) ddxprobe= */
E_Vn1_n2=(vin_Vn1_n2/pInst->l_umForE);
#endif
E=(vin/pInst->l_umForE);
EXIT_IF_ISNAN((vin/pInst->l_umForE))
#if defined(_DERIVATE) /* probe=V(n1,n2) ddxprobe= */
q2E_Vn1_n2=(pModel->q2*E_Vn1_n2);
#endif
q2E=(pModel->q2*E);
EXIT_IF_ISNAN((pModel->q2*E))
{
double m00_sqrt(d00_sqrt0,(1.0+(q2E*q2E)))
#if defined(_DERIVATE)
double m10_sqrt(d10_sqrt0,d00_sqrt0,(1.0+(q2E*q2E)))
#endif
#if defined(_DERIVATE) /* probe=V(n1,n2) ddxprobe= */
sqrf_Vn1_n2=((q2E_Vn1_n2*q2E)+(q2E*q2E_Vn1_n2))*d10_sqrt0;
#endif
sqrf=d00_sqrt0;
EXIT_IF_ISNAN(d00_sqrt0)
}
{
double m00_fabs(d00_fabs0,E)
#if defined(_DERIVATE)
double m10_fabs(d10_fabs0,d00_fabs0,E)
#endif
#if defined(_DERIVATE) /* probe=V(n1,n2) ddxprobe= */
q3E_Vn1_n2=(pModel->q3*E_Vn1_n2*d10_fabs0);
#endif
q3E=(pModel->q3*d00_fabs0);
EXIT_IF_ISNAN((pModel->q3*d00_fabs0))
}
{
double m00_pow(d00_pow0,(1.0+((q3E*q3E)*q3E)),3.3333333333333333e-01)
#if defined(_DERIVATE)
double m10_pow(d10_pow0,d00_pow0,(1.0+((q3E*q3E)*q3E)),3.3333333333333333e-01)
#endif
#if defined(_DERIVATE) /* probe=V(n1,n2) ddxprobe= */
cbrf_Vn1_n2=(d10_pow0*((((q3E_Vn1_n2*q3E)+(q3E*q3E_Vn1_n2))*q3E)+((q3E*q3E)*q3E_Vn1_n2)));
#endif
cbrf=d00_pow0;
EXIT_IF_ISNAN(d00_pow0)
}
#if defined(_DERIVATE) /* probe=V(n1,n2) ddxprobe= */
rFactor_Vn1_n2=((pModel->p2*sqrf_Vn1_n2)+(pModel->p3*cbrf_Vn1_n2));
#endif
pInst->rFactor=((((1.0-pModel->p2)-pModel->p3)+(pModel->p2*sqrf))+(pModel->p3*cbrf));
EXIT_IF_ISNAN(((((1.0-pModel->p2)-pModel->p3)+(pModel->p2*sqrf))+(pModel->p3*cbrf)))
}
else
{
#if defined(_DERIVATE) /* probe=V(n1,n2) ddxprobe= */
rFactor_Vn1_n2=0.0;
#endif
pInst->rFactor=1.0;
EXIT_IF_ISNAN(1.0)
}
#if defined(_DERIVATE) /* probe=V(n1,n2) ddxprobe= */
r_dc_Vn1_n2=(pInst->r0_t*rFactor_Vn1_n2);
#endif
r_dc=(pInst->r0_t*pInst->rFactor);
EXIT_IF_ISNAN((pInst->r0_t*pInst->rFactor))
#if defined(_DERIVATE) /* probe=V(n1,n2) ddxprobe= */
v_Vn1_n2=vin_Vn1_n2;
#endif
v=vin;
EXIT_IF_ISNAN(vin)
#if defined(_DERIVATE) /* probe=V(n1,n2) ddxprobe= */
i_Vn1_n2=((v_Vn1_n2*r_dc-v*r_dc_Vn1_n2)/r_dc/r_dc);
#endif
pInst->i=(v/r_dc);
EXIT_IF_ISNAN((v/r_dc))
if
((pInst->weff_um>0.0))
{
{
double m00_fabs(d00_fabs0,(pInst->i/pInst->weff_um))
if
((d00_fabs0>pModel->jmax))
{
printf("WARNING: current density is greater than specified by jmax");
printf("\n");
}
}
}
}
{
}
{
  _load_static_residual2(n1,n2,(pInst->i*pModel->m))
  _load_static_jacobian4(n1,n2,n1,n2,i_Vn1_n2*pModel->m)
}
{
}
{
if
(((pInst->isnoisy&&(pInst->r0>0.0))&&(pInst->g0>0.0)))
{
#if defined(_DERIVATE) /* probe=V(n1,n2) ddxprobe= */
wn_Vn1_n2=(-(((4.0*1.38065050e-23)*pInst->tdevK)*pInst->g0_t)*rFactor_Vn1_n2/pInst->rFactor/pInst->rFactor);
#endif
wn=((((4.0*1.38065050e-23)*pInst->tdevK)*pInst->g0_t)/pInst->rFactor);
EXIT_IF_ISNAN(((((4.0*1.38065050e-23)*pInst->tdevK)*pInst->g0_t)/pInst->rFactor))
if
(((pModel->sw_fngeo&&(pInst->leff_um>0.0))&&(pInst->weff_um>0.0)))
{
{
double m00_fabs(d00_fabs0,(pInst->i/pInst->weff_um))
double m00_pow(d00_pow1,d00_fabs0,pModel->afn)
#if defined(_DERIVATE)
double m10_fabs(d10_fabs0,d00_fabs0,(pInst->i/pInst->weff_um))
double m10_pow(d10_pow1,d00_pow1,d00_fabs0,pModel->afn)
#endif
#if defined(_DERIVATE) /* probe=V(n1,n2) ddxprobe= */
fn_Vn1_n2=((pInst->kfn_t*(d10_pow1*(i_Vn1_n2/pInst->weff_um)*d10_fabs0))*pInst->weff_um/pInst->leff_um);
#endif
fn=(((pInst->kfn_t*d00_pow1)*pInst->weff_um)/pInst->leff_um);
EXIT_IF_ISNAN((((pInst->kfn_t*d00_pow1)*pInst->weff_um)/pInst->leff_um))
}
}
else
{
if
(((pInst->l_um>0.0)&&(pInst->w_um>0.0)))
{
{
double m00_fabs(d00_fabs0,(pInst->i/pInst->w_um))
double m00_pow(d00_pow1,d00_fabs0,pModel->afn)
#if defined(_DERIVATE)
double m10_fabs(d10_fabs0,d00_fabs0,(pInst->i/pInst->w_um))
double m10_pow(d10_pow1,d00_pow1,d00_fabs0,pModel->afn)
#endif
#if defined(_DERIVATE) /* probe=V(n1,n2) ddxprobe= */
fn_Vn1_n2=((pInst->kfn_t*(d10_pow1*(i_Vn1_n2/pInst->w_um)*d10_fabs0))*pInst->w_um/pInst->l_um);
#endif
fn=(((pInst->kfn_t*d00_pow1)*pInst->w_um)/pInst->l_um);
EXIT_IF_ISNAN((((pInst->kfn_t*d00_pow1)*pInst->w_um)/pInst->l_um))
}
}
else
{
#if defined(_DERIVATE) /* probe=V(n1,n2) ddxprobe= */
fn_Vn1_n2=0.0;
#endif
fn=0.0;
EXIT_IF_ISNAN(0.0)
}
}
}
else
{
#if defined(_DERIVATE) /* probe=V(n1,n2) ddxprobe= */
wn_Vn1_n2=0.0;
#endif
wn=0.0;
EXIT_IF_ISNAN(0.0)
#if defined(_DERIVATE) /* probe=V(n1,n2) ddxprobe= */
fn_Vn1_n2=0.0;
#endif
fn=0.0;
EXIT_IF_ISNAN(0.0)
}
#if defined(_DERIVATE) /* probe=V(n1,n2) ddxprobe= */
wn_Vn1_n2=wn_Vn1_n2*pModel->m;
#endif
wn=(wn*pModel->m);
EXIT_IF_ISNAN((wn*pModel->m))
#if defined(_DERIVATE) /* probe=V(n1,n2) ddxprobe= */
fn_Vn1_n2=fn_Vn1_n2*pModel->m;
#endif
fn=(fn*pModel->m);
EXIT_IF_ISNAN((fn*pModel->m))
pInst->wnoise0=wn;
pInst->fpnoise0=fn;
pInst->fenoise0=pModel->bfn;
}
{
#if defined(_DYNAMIC)
power=(pInst->i*v);
EXIT_IF_ISNAN((pInst->i*v))
#endif
#ifdef _DYNAMIC
if
(((pInst->r0>0.0)&&(pInst->g0>0.0)))
{
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(n1,n2) ddxprobe= */
r_dc_Vn1_n2=(pInst->r0_t*rFactor_Vn1_n2);
#endif
r_dc=(pInst->r0_t*pInst->rFactor);
EXIT_IF_ISNAN((pInst->r0_t*pInst->rFactor))
#endif
#ifdef _DYNAMIC
if
(((pModel->p2>0.0)||(pModel->p3>0.0)))
{
#ifdef _DYNAMIC
if
((vin>=0.0))
{
#if defined(_DYNAMIC)
drfdv=(((((pModel->p2*pModel->q2)*q2E)/sqrf)+((((pModel->p3*pModel->q3)*q3E)*q3E)/(cbrf*cbrf)))/pInst->l_umForE);
EXIT_IF_ISNAN((((((pModel->p2*pModel->q2)*q2E)/sqrf)+((((pModel->p3*pModel->q3)*q3E)*q3E)/(cbrf*cbrf)))/pInst->l_umForE))
#endif
}
else
{
#if defined(_DYNAMIC)
drfdv=(((((pModel->p2*pModel->q2)*q2E)/sqrf)-((((pModel->p3*pModel->q3)*q3E)*q3E)/(cbrf*cbrf)))/pInst->l_umForE);
EXIT_IF_ISNAN((((((pModel->p2*pModel->q2)*q2E)/sqrf)-((((pModel->p3*pModel->q3)*q3E)*q3E)/(cbrf*cbrf)))/pInst->l_umForE))
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
g_ac=((pInst->g0_t-(pInst->i*drfdv))/pInst->rFactor);
EXIT_IF_ISNAN(((pInst->g0_t-(pInst->i*drfdv))/pInst->rFactor))
#endif
}
else
{
#if defined(_DYNAMIC)
g_ac=(1.0/r_dc);
EXIT_IF_ISNAN((1.0/r_dc))
#endif
}
#endif /* if(...) */
#ifdef _DYNAMIC
if
((g_ac!=0.0))
{
#if defined(_DYNAMIC)
r_ac=(1.0/g_ac);
EXIT_IF_ISNAN((1.0/g_ac))
#endif
}
else
{
#if defined(_DYNAMIC)
r_ac=1.0e99;
EXIT_IF_ISNAN(1.0e99)
#endif
}
#endif /* if(...) */
}
else
{
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(n1,n2) ddxprobe= */
r_dc_Vn1_n2=0.0;
#endif
r_dc=pInst->r0;
EXIT_IF_ISNAN(pInst->r0)
#endif
#if defined(_DYNAMIC)
r_ac=pInst->r0;
EXIT_IF_ISNAN(pInst->r0)
#endif
}
#endif /* if(...) */
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(n1,n2) ddxprobe= */
i_Vn1_n2=(pModel->m*i_Vn1_n2);
#endif
pInst->i=(pModel->m*pInst->i);
EXIT_IF_ISNAN((pModel->m*pInst->i))
#endif
#if defined(_DYNAMIC)
power=(pModel->m*power);
EXIT_IF_ISNAN((pModel->m*power))
#endif
#if defined(_DYNAMIC)
#if defined(_DERIVATE) /* probe=V(n1,n2) ddxprobe= */
r_dc_Vn1_n2=(r_dc_Vn1_n2/pModel->m);
#endif
r_dc=(r_dc/pModel->m);
EXIT_IF_ISNAN((r_dc/pModel->m))
#endif
#if defined(_DYNAMIC)
r_ac=(r_ac/pModel->m);
EXIT_IF_ISNAN((r_ac/pModel->m))
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_power_OP]=power;
EXIT_IF_ISNAN(power)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_v_OP]=v;
EXIT_IF_ISNAN(v)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_i_OP]=pInst->i;
EXIT_IF_ISNAN(pInst->i)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_r0_OP]=pInst->r0;
EXIT_IF_ISNAN(pInst->r0)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_weff]=pInst->weff_um;
EXIT_IF_ISNAN(pInst->weff_um)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_leff]=pInst->leff_um;
EXIT_IF_ISNAN(pInst->leff_um)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_r_dc_OP]=r_dc;
EXIT_IF_ISNAN(r_dc)
#endif
#if defined(_DYNAMIC)
ckt->CKTstate0[((GENinstance*)here)->GENstate + hide_r_ac_OP]=r_ac;
EXIT_IF_ISNAN(r_ac)
#endif
}
