/***
*** Interface: ngspice 1.0.0.0
 *** created by: admsXml-2.3.7 ***/


#include "ngspice/ngspice.h"
#include "ngspice/cktdefs.h"
#include "ngspice/smpdefs.h"
#include "bsimbulkdefs.h"
#include "ngspice/const.h"
#include "ngspice/sperror.h"
#include "ngspice/ifsim.h"
#include "ngspice/suffix.h"

#define  ELECTRON_CHARGE        1.602191770e-19         /* C */
#define  BOLTZMANN              1.38062259e-23          /* J/oK */

#define jacobian(a,b) here->PTR_J_##a##_##b##_required=1;
#define static_jacobian4(p,q,r,s)  jacobian(p,r) jacobian(p,s) jacobian(q,r) jacobian(q,s)
#define static_jacobian2s(p,q,r)   jacobian(p,r) jacobian(q,r)
#define static_jacobian2p(p,r,s)   jacobian(p,r) jacobian(p,s)
#define static_jacobian1(p,r)      jacobian(p,r)
#define dynamic_jacobian4(p,q,r,s) jacobian(p,r) jacobian(p,s) jacobian(q,r) jacobian(q,s)
#define dynamic_jacobian2s(p,q,r)  jacobian(p,r) jacobian(q,r)
#define dynamic_jacobian2p(p,r,s)  jacobian(p,r) jacobian(p,s)
#define dynamic_jacobian1(p,r)     jacobian(p,r)
#define whitenoise_jacobian4(p,q,r,s)
#define whitenoise_jacobian2s(p,q,r)
#define whitenoise_jacobian2p(p,r,s)
#define whitenoise_jacobian1(p)
#define flickernoise_jacobian4(p,q,r,s)
#define flickernoise_jacobian2s(p,q,r)
#define flickernoise_jacobian2p(p,r,s)
#define flickernoise_jacobian1(p)


int bsimbulkguesstopology (SMPmatrix *matrix, CKTcircuit *ckt, bsimbulkmodel *model, bsimbulkinstance *here)
     /* guess topology */
{
  NG_IGNOREABLE(matrix);
  NG_IGNOREABLE(ckt);
double DGAMMAEDGE_i=0.0/0.0;
double Cgdof=0.0/0.0;
double Cgsof=0.0/0.0;
double DPD=0.0/0.0;
double Leffnoisq=0.0/0.0;
double Leffnoi=0.0/0.0;
double LeffnoiH=0.0/0.0;
double LINTNOI_i=0.0/0.0;
double czbdswg_p2=0.0/0.0;
double czbdswg_p1=0.0/0.0;
double czbdsw_p2=0.0/0.0;
double czbdsw_p1=0.0/0.0;
double czbd_p2=0.0/0.0;
double czbd_p1=0.0/0.0;
double czbsswg_p2=0.0/0.0;
double czbsswg_p1=0.0/0.0;
double czbssw_p2=0.0/0.0;
double czbssw_p1=0.0/0.0;
double czbs_p2=0.0/0.0;
double czbs_p1=0.0/0.0;
double WeffWRFactor=0.0/0.0;
double EeffFactor=0.0/0.0;
double q_vth=0.0/0.0;
double Wdrn=0.0/0.0;
double Inv_odref=0.0/0.0;
double Inv_sbref=0.0/0.0;
double Inv_saref=0.0/0.0;
int i;
double W_tmp_stress=0.0/0.0;
double ADmer=0.0/0.0;
double ASmer=0.0/0.0;
double ADsha=0.0/0.0;
double ASsha=0.0/0.0;
double PDmer=0.0/0.0;
double PSmer=0.0/0.0;
double eta_mu=0.0/0.0;
double litl=0.0/0.0;
double T1DEP=0.0/0.0;
double Eg0=0.0/0.0;
double Vtm0=0.0/0.0;
double Tnom=0.0/0.0;
double cth=0.0/0.0;
double gth=0.0/0.0;
double Weff_SH=0.0/0.0;
double BechvbEdge=0.0/0.0;
double AechvbEdge=0.0/0.0;
double Bechvb=0.0/0.0;
double Aechvb=0.0/0.0;
double ToxRatioEdge=0.0/0.0;
double ToxRatio=0.0/0.0;
double T2y=0.0/0.0;
double Grgeltd=0.0/0.0;
double Rbpby=0.0/0.0;
double Rbpbx=0.0/0.0;
double Rbdby=0.0/0.0;
double Rbdbx=0.0/0.0;
double Rbsby=0.0/0.0;
double Rbsbx=0.0/0.0;
double Rbsb=0.0/0.0;
double Rbdb=0.0/0.0;
double Rbps=0.0/0.0;
double Rbpd=0.0/0.0;
double Rbpb=0.0/0.0;
double Bodymode=0.0/0.0;
double Lnnf=0.0/0.0;
double Lnw=0.0/0.0;
double Lnl=0.0/0.0;
double Grbpd=0.0/0.0;
double Grbps=0.0/0.0;
double Grbpb=0.0/0.0;
double Grbdb=0.0/0.0;
double Grbsb=0.0/0.0;
double RDrainGeo=0.0/0.0;
double RSourceGeo=0.0/0.0;
double DMDGeff=0.0/0.0;
double DMCIeff=0.0/0.0;
double DMCGeff=0.0/0.0;
double Rint=0.0/0.0;
double Rend=0.0/0.0;
double nuIntS=0.0/0.0;
double nuIntD=0.0/0.0;
double nuEndS=0.0/0.0;
double nuEndD=0.0/0.0;
double PIGCD_i=0.0/0.0;
double T1y=0.0/0.0;
double T0y=0.0/0.0;
double NFACTOREDGE_i=0.0/0.0;
double A21_i=0.0/0.0;
double A2_i=0.0/0.0;
double A11_i=0.0/0.0;
double A1_i=0.0/0.0;
double PSATB_i=0.0/0.0;
double KT2_i=0.0/0.0;
double KT1_i=0.0/0.0;
double NTOX_i=0.0/0.0;
double DLCIGD_i=0.0/0.0;
double DLCIG_i=0.0/0.0;
double POXEDGE_i=0.0/0.0;
double CIGD_i=0.0/0.0;
double BIGD_i=0.0/0.0;
double AIGD_i=0.0/0.0;
double CIGS_i=0.0/0.0;
double BIGS_i=0.0/0.0;
double AIGS_i=0.0/0.0;
double CIGC_i=0.0/0.0;
double BIGC_i=0.0/0.0;
double AIGC_i=0.0/0.0;
double NIGBACC_i=0.0/0.0;
double CIGBACC_i=0.0/0.0;
double BIGBACC_i=0.0/0.0;
double AIGBACC_i=0.0/0.0;
double NIGBINV_i=0.0/0.0;
double EIGBINV_i=0.0/0.0;
double CIGBINV_i=0.0/0.0;
double BIGBINV_i=0.0/0.0;
double AIGBINV_i=0.0/0.0;
double IGT_i=0.0/0.0;
double TGIDL_i=0.0/0.0;
double IIT_i=0.0/0.0;
double PTWGT_i=0.0/0.0;
double AT_i=0.0/0.0;
double PRT_i=0.0/0.0;
double UCSTE_i=0.0/0.0;
double UD1_i=0.0/0.0;
double UC1_i=0.0/0.0;
double UA1_i=0.0/0.0;
double UTE_i=0.0/0.0;
double EGISL_i=0.0/0.0;
double CGISL_i=0.0/0.0;
double BGISL_i=0.0/0.0;
double AGISL_i=0.0/0.0;
double EGIDL_i=0.0/0.0;
double CGIDL_i=0.0/0.0;
double BGIDL_i=0.0/0.0;
double AGIDL_i=0.0/0.0;
double KU0WE_i=0.0/0.0;
double K2WE_i=0.0/0.0;
double KVTH0WE_i=0.0/0.0;
double BETA0_i=0.0/0.0;
double ALPHA0_i=0.0/0.0;
double CKAPPAD_i=0.0/0.0;
double CKAPPAS_i=0.0/0.0;
double CGDL_i=0.0/0.0;
double CGSL_i=0.0/0.0;
double CF_i=0.0/0.0;
double VSATCV_i=0.0/0.0;
double PSAT_i=0.0/0.0;
double VSAT_i=0.0/0.0;
double PVAG_i=0.0/0.0;
double FPROUT_i=0.0/0.0;
double PDITSD_i=0.0/0.0;
double PDITS_i=0.0/0.0;
double PSCBE2_i=0.0/0.0;
double PSCBE1_i=0.0/0.0;
double PDIBLCB_i=0.0/0.0;
double PDIBLC_i=0.0/0.0;
double PTWG_i=0.0/0.0;
double RDSWMIN_i=0.0/0.0;
double RDSW_i=0.0/0.0;
double RDWMIN_i=0.0/0.0;
double RSWMIN_i=0.0/0.0;
double WR_i=0.0/0.0;
double PRWB_i=0.0/0.0;
double PRWG_i=0.0/0.0;
double RDW_i=0.0/0.0;
double RSW_i=0.0/0.0;
double PCLMCV_i=0.0/0.0;
double PCLM_i=0.0/0.0;
double UC_i=0.0/0.0;
double UCS_i=0.0/0.0;
double EU_i=0.0/0.0;
double UD_i=0.0/0.0;
double UA_i=0.0/0.0;
double U0_i=0.0/0.0;
double DELTA_i=0.0/0.0;
double ETAB_i=0.0/0.0;
double ETA0_i=0.0/0.0;
double PHIN_i=0.0/0.0;
double XJ_i=0.0/0.0;
double K1_i=0.0/0.0;
double DVTP5_i=0.0/0.0;
double DVTP4_i=0.0/0.0;
double DVTP3_i=0.0/0.0;
double DVTP2_i=0.0/0.0;
double DVTP1_i=0.0/0.0;
double DVTP0_i=0.0/0.0;
double CDSCB_i=0.0/0.0;
double CDSCD_i=0.0/0.0;
double NFACTOR_i=0.0/0.0;
double CIT_i=0.0/0.0;
double NGATE_i=0.0/0.0;
double NDEPCV_i=0.0/0.0;
double NDEP_i=0.0/0.0;
double NSD_i=0.0/0.0;
double VFBCV_i=0.0/0.0;
double VFB_i=0.0/0.0;
double BIN_WL=0.0/0.0;
double BIN_W=0.0/0.0;
double BIN_L=0.0/0.0;
double Weff1=0.0/0.0;
double Leff1=0.0/0.0;
double dWB=0.0/0.0;
double LW_WLN_WWN1=0.0/0.0;
double dLB=0.0/0.0;
double LW_LLN_LWN1=0.0/0.0;
double Inv_WL=0.0/0.0;
double Inv_Wwide=0.0/0.0;
double Inv_Llong=0.0/0.0;
double Inv_Wact=0.0/0.0;
double Inv_Lact=0.0/0.0;
double Inv_W=0.0/0.0;
double Inv_L=0.0/0.0;
double Weffcj=0.0/0.0;
double dWJ=0.0/0.0;
double Wact=0.0/0.0;
double Lact=0.0/0.0;
double dWCV=0.0/0.0;
double dLCV=0.0/0.0;
double Weff=0.0/0.0;
double Leff=0.0/0.0;
double dWIV=0.0/0.0;
double LW_WLN_WWN=0.0/0.0;
double W_WWN=0.0/0.0;
double L_WLN=0.0/0.0;
double dLIV=0.0/0.0;
double LW_LLN_LWN=0.0/0.0;
double W_LWN=0.0/0.0;
double L_LLN=0.0/0.0;
double Wnew=0.0/0.0;
double W_by_NF=0.0/0.0;
double Lnew=0.0/0.0;
double W_mult=0.0/0.0;
double L_mult=0.0/0.0;
double BSIMBULKTOXP=0.0/0.0;
double epsratio=0.0/0.0;
double Cox=0.0/0.0;
double epsox=0.0/0.0;
double epssi=0.0/0.0;
int devsign;
double STETA0EDGE_i=0.0/0.0;
double STK2EDGE_i=0.0/0.0;
double KVTH0EDGE_i=0.0/0.0;
double K2EDGE_i=0.0/0.0;
double TETA0EDGE_i=0.0/0.0;
double TNFACTOREDGE_i=0.0/0.0;
double KT1EXPEDGE_i=0.0/0.0;
double KT2EDGE_i=0.0/0.0;
double KT1LEDGE_i=0.0/0.0;
double KT1EDGE_i=0.0/0.0;
double ETABEDGE_i=0.0/0.0;
double ETA0EDGE_i=0.0/0.0;
double CDSCBEDGE_i=0.0/0.0;
double CDSCDEDGE_i=0.0/0.0;
double CITEDGE_i=0.0/0.0;
double M01_i=0.0/0.0;
double K01_i=0.0/0.0;
double M0_i=0.0/0.0;
double K0_i=0.0/0.0;
double W_WWN1=0.0/0.0;
double W_LWN1=0.0/0.0;
double VSATR_i=0.0/0.0;
double UDR_i=0.0/0.0;
double UCSR_i=0.0/0.0;
double UCR_i=0.0/0.0;
double UAR_i=0.0/0.0;
double U0R_i=0.0/0.0;
double PTWGR_i=0.0/0.0;
double PSATR_i=0.0/0.0;
double PDIBLCR_i=0.0/0.0;
double PCLMR_i=0.0/0.0;
double L_WLN1=0.0/0.0;
double L_LLN1=0.0/0.0;
double ETA0R_i=0.0/0.0;
double CDSCDR_i=0.0/0.0;
CDSCDR_i=0.0;
ETA0R_i=0.0;
L_LLN1=0.0;
L_WLN1=0.0;
PCLMR_i=0.0;
PDIBLCR_i=0.0;
PSATR_i=0.0;
PTWGR_i=0.0;
U0R_i=0.0;
UAR_i=0.0;
UCR_i=0.0;
UCSR_i=0.0;
UDR_i=0.0;
VSATR_i=0.0;
W_LWN1=0.0;
W_WWN1=0.0;
K0_i=0.0;
M0_i=0.0;
K01_i=0.0;
M01_i=0.0;
CITEDGE_i=0.0;
CDSCDEDGE_i=0.0;
CDSCBEDGE_i=0.0;
ETA0EDGE_i=0.0;
ETABEDGE_i=0.0;
KT1EDGE_i=0.0;
KT1LEDGE_i=0.0;
KT2EDGE_i=0.0;
KT1EXPEDGE_i=0.0;
TNFACTOREDGE_i=0.0;
TETA0EDGE_i=0.0;
K2EDGE_i=0.0;
KVTH0EDGE_i=0.0;
STK2EDGE_i=0.0;
STETA0EDGE_i=0.0;
if
((model->TYPE==1))
{
devsign=1;
}
else
{
devsign=(-1);
}
epssi=(model->EPSRSUB*8.85418e-12);
epsox=(model->EPSROX*8.85418e-12);
Cox=((model->EPSROX*8.85418e-12)/model->TOXE);
epsratio=(model->EPSRSUB/model->EPSROX);
if
((!model->TOXP_Given))
{
BSIMBULKTOXP=(((model->TOXE*model->EPSROX)/3.9)-model->DTOX);
}
else
{
BSIMBULKTOXP=model->TOXP;
}
L_mult=(here->L*model->LMLT);
W_mult=(here->W*model->WMLT);
Lnew=(L_mult+model->XL);
if
((Lnew<=0.0))
{
}
W_by_NF=(W_mult/here->NF);
Wnew=(W_by_NF+model->XW);
if
((Wnew<=0.0))
{
}
L_LLN=pow(Lnew,(-model->LLN));
W_LWN=pow(Wnew,(-model->LWN));
LW_LLN_LWN=(L_LLN*W_LWN);
dLIV=(((model->LINT+(model->LL*L_LLN))+(model->LW*W_LWN))+(model->LWL*LW_LLN_LWN));
L_WLN=pow(Lnew,(-model->WLN));
W_WWN=pow(Wnew,(-model->WWN));
LW_WLN_WWN=(L_WLN*W_WWN);
dWIV=(((model->WINT+(model->WL*L_WLN))+(model->WW*W_WWN))+(model->WWL*LW_WLN_WWN));
Leff=(Lnew-(2.0*dLIV));
if
((Leff<=0.0))
{
}
else
{
if
((Leff<=1.0e-9))
{
}
}
Weff=(Wnew-(2.0*dWIV));
if
((Weff<=0.0))
{
}
else
{
if
((Weff<=1.0e-9))
{
}
}
dLCV=(((model->DLC+(model->LLC*L_LLN))+(model->LWC*W_LWN))+(model->LWLC*LW_LLN_LWN));
dWCV=(((model->DWC+(model->WLC*L_WLN))+(model->WWC*W_WWN))+(model->WWLC*LW_WLN_WWN));
Lact=(Lnew-(2.0*dLCV));
if
((Lact<=0.0))
{
}
else
{
if
((Lact<=1.0e-9))
{
}
}
Wact=(Wnew-(2.0*dWCV));
if
((Wact<=0.0))
{
}
else
{
if
((Wact<=1.0e-9))
{
}
}
dWJ=(((model->DWJ+(model->WLC/pow(Lnew,model->WLN)))+(model->WWC/pow(Wnew,model->WWN)))+((model->WWLC/pow(Lnew,model->WLN))/pow(Wnew,model->WWN)));
Weffcj=(Wnew-(2.0*dWJ));
if
((Weffcj<=0.0))
{
}
Inv_L=(1.0e-6/Leff);
Inv_W=(1.0e-6/Weff);
Inv_Lact=(1.0e-6/Lact);
Inv_Wact=(1.0e-6/Wact);
Inv_Llong=(1.0e-6/model->LLONG);
Inv_Wwide=(1.0e-6/model->WWIDE);
Inv_WL=(Inv_L*Inv_W);
L_LLN1=L_LLN;
L_WLN1=L_WLN;
if
((model->DLBIN!=0.0))
{
if
((model->DLBIN<=(-Lnew)))
{
}
else
{
L_LLN1=pow((Lnew+model->DLBIN),(-model->LLN));
L_WLN1=pow((Lnew+model->DLBIN),(-model->WLN));
}
}
W_LWN1=W_LWN;
W_WWN1=W_WWN;
if
((model->DWBIN!=0.0))
{
if
((model->DWBIN<=(-Wnew)))
{
}
else
{
W_LWN1=pow((Wnew+model->DWBIN),(-model->LWN));
W_WWN1=pow((Wnew+model->DWBIN),(-model->WWN));
}
}
LW_LLN_LWN1=(L_LLN1*W_LWN1);
dLB=(((model->LINT+(model->LL*L_LLN1))+(model->LW*W_LWN1))+(model->LWL*LW_LLN_LWN1));
LW_WLN_WWN1=(L_WLN1*W_WWN1);
dWB=(((model->WINT+(model->WL*L_WLN1))+(model->WW*W_WWN1))+(model->WWL*LW_WLN_WWN1));
Leff1=((Lnew-(2.0*dLB))+model->DLBIN);
if
((Leff1<=0.0))
{
}
Weff1=((Wnew-(2.0*dWB))+model->DWBIN);
if
((Weff1<=0.0))
{
}
if
((model->BINUNIT==1))
{
BIN_L=(1.0e-6/Leff1);
BIN_W=(1.0e-6/Weff1);
}
else
{
BIN_L=(1.0/Leff1);
BIN_W=(1.0/Weff1);
}
BIN_WL=(BIN_L*BIN_W);
VFB_i=(((model->VFB+(BIN_L*model->LVFB))+(BIN_W*model->WVFB))+(BIN_WL*model->PVFB));
VFBCV_i=(((model->VFBCV+(BIN_L*model->LVFBCV))+(BIN_W*model->WVFBCV))+(BIN_WL*model->PVFBCV));
NSD_i=(((model->NSD+(BIN_L*model->LNSD))+(BIN_W*model->WNSD))+(BIN_WL*model->PNSD));
NDEP_i=(((model->NDEP+(BIN_L*model->LNDEP))+(BIN_W*model->WNDEP))+(BIN_WL*model->PNDEP));
NDEPCV_i=(((model->NDEPCV+(BIN_L*model->LNDEPCV))+(BIN_W*model->WNDEPCV))+(BIN_WL*model->PNDEPCV));
NGATE_i=(((model->NGATE+(BIN_L*model->LNGATE))+(BIN_W*model->WNGATE))+(BIN_WL*model->PNGATE));
CIT_i=(((model->CIT+(BIN_L*model->LCIT))+(BIN_W*model->WCIT))+(BIN_WL*model->PCIT));
NFACTOR_i=(((model->NFACTOR+(BIN_L*model->LNFACTOR))+(BIN_W*model->WNFACTOR))+(BIN_WL*model->PNFACTOR));
CDSCD_i=(((model->CDSCD+(BIN_L*model->LCDSCD))+(BIN_W*model->WCDSCD))+(BIN_WL*model->PCDSCD));
CDSCB_i=(((model->CDSCB+(BIN_L*model->LCDSCB))+(BIN_W*model->WCDSCB))+(BIN_WL*model->PCDSCB));
DVTP0_i=(((model->DVTP0+(BIN_L*model->LDVTP0))+(BIN_W*model->WDVTP0))+(BIN_WL*model->PDVTP0));
DVTP1_i=(((model->DVTP1+(BIN_L*model->LDVTP1))+(BIN_W*model->WDVTP1))+(BIN_WL*model->PDVTP1));
DVTP2_i=(((model->DVTP2+(BIN_L*model->LDVTP2))+(BIN_W*model->WDVTP2))+(BIN_WL*model->PDVTP2));
DVTP3_i=(((model->DVTP3+(BIN_L*model->LDVTP3))+(BIN_W*model->WDVTP3))+(BIN_WL*model->PDVTP3));
DVTP4_i=(((model->DVTP4+(BIN_L*model->LDVTP4))+(BIN_W*model->WDVTP4))+(BIN_WL*model->PDVTP4));
DVTP5_i=(((model->DVTP5+(BIN_L*model->LDVTP5))+(BIN_W*model->WDVTP5))+(BIN_WL*model->PDVTP5));
K1_i=(((model->K1+(BIN_L*model->LK1))+(BIN_W*model->WK1))+(BIN_WL*model->PK1));
XJ_i=(((model->XJ+(BIN_L*model->LXJ))+(BIN_W*model->WXJ))+(BIN_WL*model->PXJ));
PHIN_i=(((model->PHIN+(BIN_L*model->LPHIN))+(BIN_W*model->WPHIN))+(BIN_WL*model->PPHIN));
ETA0_i=(((model->ETA0+(BIN_L*model->LETA0))+(BIN_W*model->WETA0))+(BIN_WL*model->PETA0));
ETAB_i=(((model->ETAB+(BIN_L*model->LETAB))+(BIN_W*model->WETAB))+(BIN_WL*model->PETAB));
DELTA_i=(((model->DELTA+(BIN_L*model->LDELTA))+(BIN_W*model->WDELTA))+(BIN_WL*model->PDELTA));
U0_i=(((model->U0+(BIN_L*model->LU0))+(BIN_W*model->WU0))+(BIN_WL*model->PU0));
UA_i=(((model->UA+(BIN_L*model->LUA))+(BIN_W*model->WUA))+(BIN_WL*model->PUA));
UD_i=(((model->UD+(BIN_L*model->LUD))+(BIN_W*model->WUD))+(BIN_WL*model->PUD));
EU_i=(((model->EU+(BIN_L*model->LEU))+(BIN_W*model->WEU))+(BIN_WL*model->PEU));
UCS_i=(((model->UCS+(BIN_L*model->LUCS))+(BIN_W*model->WUCS))+(BIN_WL*model->PUCS));
UC_i=(((model->UC+(BIN_L*model->LUC))+(BIN_W*model->WUC))+(BIN_WL*model->PUC));
PCLM_i=(((model->PCLM+(BIN_L*model->LPCLM))+(BIN_W*model->WPCLM))+(BIN_WL*model->PPCLM));
PCLMCV_i=(((model->PCLMCV+(BIN_L*model->LPCLMCV))+(BIN_W*model->WPCLMCV))+(BIN_WL*model->PPCLMCV));
RSW_i=(((model->RSW+(BIN_L*model->LRSW))+(BIN_W*model->WRSW))+(BIN_WL*model->PRSW));
RDW_i=(((model->RDW+(BIN_L*model->LRDW))+(BIN_W*model->WRDW))+(BIN_WL*model->PRDW));
PRWG_i=(((model->PRWG+(BIN_L*model->LPRWG))+(BIN_W*model->WPRWG))+(BIN_WL*model->PPRWG));
PRWB_i=(((model->PRWB+(BIN_L*model->LPRWB))+(BIN_W*model->WPRWB))+(BIN_WL*model->PPRWB));
WR_i=(((model->WR+(BIN_L*model->LWR))+(BIN_W*model->WWR))+(BIN_WL*model->PWR));
RSWMIN_i=(((model->RSWMIN+(BIN_L*model->LRSWMIN))+(BIN_W*model->WRSWMIN))+(BIN_WL*model->PRSWMIN));
RDWMIN_i=(((model->RDWMIN+(BIN_L*model->LRDWMIN))+(BIN_W*model->WRDWMIN))+(BIN_WL*model->PRDWMIN));
RDSW_i=(((model->RDSW+(BIN_L*model->LRDSW))+(BIN_W*model->WRDSW))+(BIN_WL*model->PRDSW));
RDSWMIN_i=(((model->RDSWMIN+(BIN_L*model->LRDSWMIN))+(BIN_W*model->WRDSWMIN))+(BIN_WL*model->PRDSWMIN));
PTWG_i=(((model->PTWG+(BIN_L*model->LPTWG))+(BIN_W*model->WPTWG))+(BIN_WL*model->PPTWG));
PDIBLC_i=(((model->PDIBLC+(BIN_L*model->LPDIBLC))+(BIN_W*model->WPDIBLC))+(BIN_WL*model->PPDIBLC));
PDIBLCB_i=(((model->PDIBLCB+(BIN_L*model->LPDIBLCB))+(BIN_W*model->WPDIBLCB))+(BIN_WL*model->PPDIBLCB));
PSCBE1_i=(((model->PSCBE1+(BIN_L*model->LPSCBE1))+(BIN_W*model->WPSCBE1))+(BIN_WL*model->PPSCBE1));
PSCBE2_i=(((model->PSCBE2+(BIN_L*model->LPSCBE2))+(BIN_W*model->WPSCBE2))+(BIN_WL*model->PPSCBE2));
PDITS_i=(((model->PDITS+(BIN_L*model->LPDITS))+(BIN_W*model->WPDITS))+(BIN_WL*model->PPDITS));
PDITSD_i=(((model->PDITSD+(BIN_L*model->LPDITSD))+(BIN_W*model->WPDITSD))+(BIN_WL*model->PPDITSD));
FPROUT_i=(((model->FPROUT+(BIN_L*model->LFPROUT))+(BIN_W*model->WFPROUT))+(BIN_WL*model->PFPROUT));
PVAG_i=(((model->PVAG+(BIN_L*model->LPVAG))+(BIN_W*model->WPVAG))+(BIN_WL*model->PPVAG));
VSAT_i=(((model->VSAT+(BIN_L*model->LVSAT))+(BIN_W*model->WVSAT))+(BIN_WL*model->PVSAT));
PSAT_i=(((model->PSAT+(BIN_L*model->LPSAT))+(BIN_W*model->WPSAT))+(BIN_WL*model->PPSAT));
VSATCV_i=(((model->VSATCV+(BIN_L*model->LVSATCV))+(BIN_W*model->WVSATCV))+(BIN_WL*model->PVSATCV));
CF_i=(((model->CF+(BIN_L*model->LCF))+(BIN_W*model->WCF))+(BIN_WL*model->PCF));
CGSL_i=(((model->CGSL+(BIN_L*model->LCGSL))+(BIN_W*model->WCGSL))+(BIN_WL*model->PCGSL));
CGDL_i=(((model->CGDL+(BIN_L*model->LCGDL))+(BIN_W*model->WCGDL))+(BIN_WL*model->PCGDL));
CKAPPAS_i=(((model->CKAPPAS+(BIN_L*model->LCKAPPAS))+(BIN_W*model->WCKAPPAS))+(BIN_WL*model->PCKAPPAS));
CKAPPAD_i=(((model->CKAPPAD+(BIN_L*model->LCKAPPAD))+(BIN_W*model->WCKAPPAD))+(BIN_WL*model->PCKAPPAD));
ALPHA0_i=(((model->ALPHA0+(BIN_L*model->LALPHA0))+(BIN_W*model->WALPHA0))+(BIN_WL*model->PALPHA0));
BETA0_i=(((model->BETA0+(BIN_L*model->LBETA0))+(BIN_W*model->WBETA0))+(BIN_WL*model->PBETA0));
KVTH0WE_i=(((model->KVTH0WE+(BIN_L*model->LKVTH0WE))+(BIN_W*model->WKVTH0WE))+(BIN_WL*model->PKVTH0WE));
K2WE_i=(((model->K2WE+(BIN_L*model->LK2WE))+(BIN_W*model->WK2WE))+(BIN_WL*model->PK2WE));
KU0WE_i=(((model->KU0WE+(BIN_L*model->LKU0WE))+(BIN_W*model->WKU0WE))+(BIN_WL*model->PKU0WE));
AGIDL_i=(((model->AGIDL+(BIN_L*model->LAGIDL))+(BIN_W*model->WAGIDL))+(BIN_WL*model->PAGIDL));
BGIDL_i=(((model->BGIDL+(BIN_L*model->LBGIDL))+(BIN_W*model->WBGIDL))+(BIN_WL*model->PBGIDL));
CGIDL_i=(((model->CGIDL+(BIN_L*model->LCGIDL))+(BIN_W*model->WCGIDL))+(BIN_WL*model->PCGIDL));
EGIDL_i=(((model->EGIDL+(BIN_L*model->LEGIDL))+(BIN_W*model->WEGIDL))+(BIN_WL*model->PEGIDL));
AGISL_i=(((model->AGISL+(BIN_L*model->LAGISL))+(BIN_W*model->WAGISL))+(BIN_WL*model->PAGISL));
BGISL_i=(((model->BGISL+(BIN_L*model->LBGISL))+(BIN_W*model->WBGISL))+(BIN_WL*model->PBGISL));
CGISL_i=(((model->CGISL+(BIN_L*model->LCGISL))+(BIN_W*model->WCGISL))+(BIN_WL*model->PCGISL));
EGISL_i=(((model->EGISL+(BIN_L*model->LEGISL))+(BIN_W*model->WEGISL))+(BIN_WL*model->PEGISL));
UTE_i=(((model->UTE+(BIN_L*model->LUTE))+(BIN_W*model->WUTE))+(BIN_WL*model->PUTE));
UA1_i=(((model->UA1+(BIN_L*model->LUA1))+(BIN_W*model->WUA1))+(BIN_WL*model->PUA1));
UC1_i=(((model->UC1+(BIN_L*model->LUC1))+(BIN_W*model->WUC1))+(BIN_WL*model->PUC1));
UD1_i=(((model->UD1+(BIN_L*model->LUD1))+(BIN_W*model->WUD1))+(BIN_WL*model->PUD1));
UCSTE_i=(((model->UCSTE+(BIN_L*model->LUCSTE))+(BIN_W*model->WUCSTE))+(BIN_WL*model->PUCSTE));
PRT_i=(((model->PRT+(BIN_L*model->LPRT))+(BIN_W*model->WPRT))+(BIN_WL*model->PPRT));
AT_i=(((model->AT+(BIN_L*model->LAT))+(BIN_W*model->WAT))+(BIN_WL*model->PAT));
PTWGT_i=(((model->PTWGT+(BIN_L*model->LPTWGT))+(BIN_W*model->WPTWGT))+(BIN_WL*model->PPTWGT));
IIT_i=(((model->IIT+(BIN_L*model->LIIT))+(BIN_W*model->WIIT))+(BIN_WL*model->PIIT));
TGIDL_i=(((model->TGIDL+(BIN_L*model->LTGIDL))+(BIN_W*model->WTGIDL))+(BIN_WL*model->PTGIDL));
IGT_i=(((model->IGT+(BIN_L*model->LIGT))+(BIN_W*model->WIGT))+(BIN_WL*model->PIGT));
AIGBINV_i=(((model->AIGBINV+(BIN_L*model->LAIGBINV))+(BIN_W*model->WAIGBINV))+(BIN_WL*model->PAIGBINV));
BIGBINV_i=(((model->BIGBINV+(BIN_L*model->LBIGBINV))+(BIN_W*model->WBIGBINV))+(BIN_WL*model->PBIGBINV));
CIGBINV_i=(((model->CIGBINV+(BIN_L*model->LCIGBINV))+(BIN_W*model->WCIGBINV))+(BIN_WL*model->PCIGBINV));
EIGBINV_i=(((model->EIGBINV+(BIN_L*model->LEIGBINV))+(BIN_W*model->WEIGBINV))+(BIN_WL*model->PEIGBINV));
NIGBINV_i=(((model->NIGBINV+(BIN_L*model->LNIGBINV))+(BIN_W*model->WNIGBINV))+(BIN_WL*model->PNIGBINV));
AIGBACC_i=(((model->AIGBACC+(BIN_L*model->LAIGBACC))+(BIN_W*model->WAIGBACC))+(BIN_WL*model->PAIGBACC));
BIGBACC_i=(((model->BIGBACC+(BIN_L*model->LBIGBACC))+(BIN_W*model->WBIGBACC))+(BIN_WL*model->PBIGBACC));
CIGBACC_i=(((model->CIGBACC+(BIN_L*model->LCIGBACC))+(BIN_W*model->WCIGBACC))+(BIN_WL*model->PCIGBACC));
NIGBACC_i=(((model->NIGBACC+(BIN_L*model->LNIGBACC))+(BIN_W*model->WNIGBACC))+(BIN_WL*model->PNIGBACC));
AIGC_i=(((model->AIGC+(BIN_L*model->LAIGC))+(BIN_W*model->WAIGC))+(BIN_WL*model->PAIGC));
BIGC_i=(((model->BIGC+(BIN_L*model->LBIGC))+(BIN_W*model->WBIGC))+(BIN_WL*model->PBIGC));
CIGC_i=(((model->CIGC+(BIN_L*model->LCIGC))+(BIN_W*model->WCIGC))+(BIN_WL*model->PCIGC));
AIGS_i=(((model->AIGS+(BIN_L*model->LAIGS))+(BIN_W*model->WAIGS))+(BIN_WL*model->PAIGS));
BIGS_i=(((model->BIGS+(BIN_L*model->LBIGS))+(BIN_W*model->WBIGS))+(BIN_WL*model->PBIGS));
CIGS_i=(((model->CIGS+(BIN_L*model->LCIGS))+(BIN_W*model->WCIGS))+(BIN_WL*model->PCIGS));
AIGD_i=(((model->AIGD+(BIN_L*model->LAIGD))+(BIN_W*model->WAIGD))+(BIN_WL*model->PAIGD));
BIGD_i=(((model->BIGD+(BIN_L*model->LBIGD))+(BIN_W*model->WBIGD))+(BIN_WL*model->PBIGD));
CIGD_i=(((model->CIGD+(BIN_L*model->LCIGD))+(BIN_W*model->WCIGD))+(BIN_WL*model->PCIGD));
POXEDGE_i=(((model->POXEDGE+(BIN_L*model->LPOXEDGE))+(BIN_W*model->WPOXEDGE))+(BIN_WL*model->PPOXEDGE));
DLCIG_i=(((model->DLCIG+(BIN_L*model->LDLCIG))+(BIN_W*model->WDLCIG))+(BIN_WL*model->PDLCIG));
DLCIGD_i=(((model->DLCIGD+(BIN_L*model->LDLCIGD))+(BIN_W*model->WDLCIGD))+(BIN_WL*model->PDLCIGD));
NTOX_i=(((model->NTOX+(BIN_L*model->LNTOX))+(BIN_W*model->WNTOX))+(BIN_WL*model->PNTOX));
KT1_i=(((model->KT1+(BIN_L*model->LKT1))+(BIN_W*model->WKT1))+(BIN_WL*model->PKT1));
KT2_i=(((model->KT2+(BIN_L*model->LKT2))+(BIN_W*model->WKT2))+(BIN_WL*model->PKT2));
PSATB_i=(((model->PSATB+(BIN_L*model->LPSATB))+(BIN_W*model->WPSATB))+(BIN_WL*model->PPSATB));
A1_i=(((model->A1+(BIN_L*model->LA1))+(BIN_W*model->WA1))+(BIN_WL*model->PA1));
A11_i=(((model->A11+(BIN_L*model->LA11))+(BIN_W*model->WA11))+(BIN_WL*model->PA11));
A2_i=(((model->A2+(BIN_L*model->LA2))+(BIN_W*model->WA2))+(BIN_WL*model->PA2));
A21_i=(((model->A21+(BIN_L*model->LA21))+(BIN_W*model->WA21))+(BIN_WL*model->PA21));
K0_i=(((model->K0+(BIN_L*model->LK0))+(BIN_W*model->WK0))+(BIN_WL*model->PK0));
M0_i=(((model->M0+(BIN_L*model->LM0))+(BIN_W*model->WM0))+(BIN_WL*model->PM0));
K01_i=(((model->K01+(BIN_L*model->LK01))+(BIN_W*model->WK01))+(BIN_WL*model->PK01));
M01_i=(((model->M01+(BIN_L*model->LM01))+(BIN_W*model->WM01))+(BIN_WL*model->PM01));
NFACTOREDGE_i=(((model->NFACTOREDGE+(BIN_L*model->LNFACTOREDGE))+(BIN_W*model->WNFACTOREDGE))+(BIN_WL*model->PNFACTOREDGE));
CITEDGE_i=(((model->CITEDGE+(BIN_L*model->LCITEDGE))+(BIN_W*model->WCITEDGE))+(BIN_WL*model->PCITEDGE));
CDSCDEDGE_i=(((model->CDSCDEDGE+(BIN_L*model->LCDSCDEDGE))+(BIN_W*model->WCDSCDEDGE))+(BIN_WL*model->PCDSCDEDGE));
CDSCBEDGE_i=(((model->CDSCBEDGE+(BIN_L*model->LCDSCBEDGE))+(BIN_W*model->WCDSCBEDGE))+(BIN_WL*model->PCDSCBEDGE));
ETA0EDGE_i=(((model->ETA0EDGE+(BIN_L*model->LETA0EDGE))+(BIN_W*model->WETA0EDGE))+(BIN_WL*model->PETA0EDGE));
ETABEDGE_i=(((model->ETABEDGE+(BIN_L*model->LETABEDGE))+(BIN_W*model->WETABEDGE))+(BIN_WL*model->PETABEDGE));
KT1EDGE_i=(((model->KT1EDGE+(BIN_L*model->LKT1EDGE))+(BIN_W*model->WKT1EDGE))+(BIN_WL*model->PKT1EDGE));
KT1LEDGE_i=(((model->KT1LEDGE+(BIN_L*model->LKT1LEDGE))+(BIN_W*model->WKT1LEDGE))+(BIN_WL*model->PKT1LEDGE));
KT2EDGE_i=(((model->KT2EDGE+(BIN_L*model->LKT2EDGE))+(BIN_W*model->WKT2EDGE))+(BIN_WL*model->PKT2EDGE));
KT1EXPEDGE_i=(((model->KT1EXPEDGE+(BIN_L*model->LKT1EXPEDGE))+(BIN_W*model->WKT1EXPEDGE))+(BIN_WL*model->PKT1EXPEDGE));
TNFACTOREDGE_i=(((model->TNFACTOREDGE+(BIN_L*model->LTNFACTOREDGE))+(BIN_W*model->WTNFACTOREDGE))+(BIN_WL*model->PTNFACTOREDGE));
TETA0EDGE_i=(((model->TETA0EDGE+(BIN_L*model->LTETA0EDGE))+(BIN_W*model->WTETA0EDGE))+(BIN_WL*model->PTETA0EDGE));
K2EDGE_i=(((model->K2EDGE+(BIN_L*model->LK2EDGE))+(BIN_W*model->WK2EDGE))+(BIN_WL*model->PK2EDGE));
KVTH0EDGE_i=(((model->KVTH0EDGE+(BIN_L*model->LKVTH0EDGE))+(BIN_W*model->WKVTH0EDGE))+(BIN_WL*model->PKVTH0EDGE));
STK2EDGE_i=(((model->STK2EDGE+(BIN_L*model->LSTK2EDGE))+(BIN_W*model->WSTK2EDGE))+(BIN_WL*model->PSTK2EDGE));
STETA0EDGE_i=(((model->STETA0EDGE+(BIN_L*model->LSTETA0EDGE))+(BIN_W*model->WSTETA0EDGE))+(BIN_WL*model->PSTETA0EDGE));
if
((model->ASYMMOD!=0))
{
CDSCDR_i=(((model->CDSCDR+(BIN_L*model->LCDSCDR))+(BIN_W*model->WCDSCDR))+(BIN_WL*model->PCDSCDR));
ETA0R_i=(((model->ETA0R+(BIN_L*model->LETA0R))+(BIN_W*model->WETA0R))+(BIN_WL*model->PETA0R));
U0R_i=(((model->U0R+(BIN_L*model->LU0R))+(BIN_W*model->WU0R))+(BIN_WL*model->PU0R));
UAR_i=(((model->UAR+(BIN_L*model->LUAR))+(BIN_W*model->WUAR))+(BIN_WL*model->PUAR));
UDR_i=(((model->UDR+(BIN_L*model->LUDR))+(BIN_W*model->WUDR))+(BIN_WL*model->PUDR));
UCSR_i=(((model->UCSR+(BIN_L*model->LUCSR))+(BIN_W*model->WUCSR))+(BIN_WL*model->PUCSR));
UCR_i=(((model->UCR+(BIN_L*model->LUCR))+(BIN_W*model->WUCR))+(BIN_WL*model->PUCR));
PCLMR_i=(((model->PCLMR+(BIN_L*model->LPCLMR))+(BIN_W*model->WPCLMR))+(BIN_WL*model->PPCLMR));
PDIBLCR_i=(((model->PDIBLCR+(BIN_L*model->LPDIBLCR))+(BIN_W*model->WPDIBLCR))+(BIN_WL*model->PPDIBLCR));
VSATR_i=(((model->VSATR+(BIN_L*model->LVSATR))+(BIN_W*model->WVSATR))+(BIN_WL*model->PVSATR));
PSATR_i=(((model->PSATR+(BIN_L*model->LPSATR))+(BIN_W*model->WPSATR))+(BIN_WL*model->PPSATR));
PTWGR_i=(((model->PTWGR+(BIN_L*model->LPTWGR))+(BIN_W*model->WPTWGR))+(BIN_WL*model->PPTWGR));
}
T0y=((model->NDEPL1*max((pow(Inv_L,model->NDEPLEXP1)-pow(Inv_Llong,model->NDEPLEXP1)),0.0))+(model->NDEPL2*max((pow(Inv_L,model->NDEPLEXP2)-pow(Inv_Llong,model->NDEPLEXP2)),0.0)));
T1y=((model->NDEPW*max((pow(Inv_W,model->NDEPWEXP)-pow(Inv_Wwide,model->NDEPWEXP)),0.0))+(model->NDEPWL*pow((Inv_W*Inv_L),model->NDEPWLEXP)));
NDEP_i=(NDEP_i*((1.0+T0y)+T1y));
T0y=(model->NFACTORL*max((pow(Inv_L,model->NFACTORLEXP)-pow(Inv_Llong,model->NFACTORLEXP)),0.0));
T1y=((model->NFACTORW*max((pow(Inv_W,model->NFACTORWEXP)-pow(Inv_Wwide,model->NFACTORWEXP)),0.0))+(model->NFACTORWL*pow(Inv_WL,model->NFACTORWLEXP)));
NFACTOR_i=(NFACTOR_i*((1.0+T0y)+T1y));
T0y=(1.0+(model->CDSCDL*max((pow(Inv_L,model->CDSCDLEXP)-pow(Inv_Llong,model->CDSCDLEXP)),0.0)));
CDSCD_i=(CDSCD_i*T0y);
if
((model->ASYMMOD!=0))
{
CDSCDR_i=(CDSCDR_i*T0y);
}
CDSCB_i=(CDSCB_i*(1.0+(model->CDSCBL*max((pow(Inv_L,model->CDSCBLEXP)-pow(Inv_Llong,model->CDSCBLEXP)),0.0))));
U0_i=(here->MULU0*U0_i);
if
((model->MOBSCALE!=1))
{
if
((model->U0LEXP>0.0))
{
U0_i=(U0_i*(1.0-(model->U0L*max((pow(Inv_L,model->U0LEXP)-pow(Inv_Llong,model->U0LEXP)),0.0))));
if
((model->ASYMMOD!=0))
{
U0R_i=(U0R_i*(1.0-(model->U0L*max((pow(Inv_L,model->U0LEXP)-pow(Inv_Llong,model->U0LEXP)),0.0))));
}
}
else
{
U0_i=(U0_i*(1.0-model->U0L));
if
((model->ASYMMOD!=0))
{
U0R_i=(U0R_i*(1.0-model->U0L));
}
}
}
else
{
U0_i=(U0_i*((1.0-(model->UP1*bsimbulk_lexp(((-Leff)/model->LP1))))-(model->UP2*bsimbulk_lexp(((-Leff)/model->LP2)))));
if
((model->ASYMMOD!=0))
{
U0R_i=(U0R_i*((1.0-(model->UP1*bsimbulk_lexp(((-Leff)/model->LP1))))-(model->UP2*bsimbulk_lexp(((-Leff)/model->LP2)))));
}
}
T0y=(model->UAL*max((pow(Inv_L,model->UALEXP)-pow(Inv_Llong,model->UALEXP)),0.0));
T1y=((model->UAW*max((pow(Inv_W,model->UAWEXP)-pow(Inv_Wwide,model->UAWEXP)),0.0))+(model->UAWL*pow(Inv_WL,model->UAWLEXP)));
UA_i=(UA_i*((1.0+T0y)+T1y));
if
((model->ASYMMOD!=0))
{
UAR_i=(UAR_i*((1.0+T0y)+T1y));
}
T0y=(model->EUL*max((pow(Inv_L,model->EULEXP)-pow(Inv_Llong,model->EULEXP)),0.0));
T1y=((model->EUW*max((pow(Inv_W,model->EUWEXP)-pow(Inv_Wwide,model->EUWEXP)),0.0))+(model->EUWL*pow(Inv_WL,model->EUWLEXP)));
EU_i=(EU_i*((1.0+T0y)+T1y));
T0y=(1.0+(model->UDL*max((pow(Inv_L,model->UDLEXP)-pow(Inv_Llong,model->UDLEXP)),0.0)));
UD_i=(UD_i*T0y);
if
((model->ASYMMOD!=0))
{
UDR_i=(UDR_i*T0y);
}
T0y=(model->UCL*max((pow(Inv_L,model->UCLEXP)-pow(Inv_Llong,model->UCLEXP)),0.0));
T1y=((model->UCW*max((pow(Inv_W,model->UCWEXP)-pow(Inv_Wwide,model->UCWEXP)),0.0))+(model->UCWL*pow(Inv_WL,model->UCWLEXP)));
UC_i=(UC_i*((1.0+T0y)+T1y));
if
((model->ASYMMOD!=0))
{
UCR_i=(UCR_i*((1.0+T0y)+T1y));
}
T0y=max((pow(Inv_L,model->DSUB)-pow(Inv_Llong,model->DSUB)),0.0);
ETA0_i=(ETA0_i*T0y);
if
((model->ASYMMOD!=0))
{
ETA0R_i=(ETA0R_i*T0y);
}
ETAB_i=(ETAB_i*max((pow(Inv_L,model->ETABEXP)-pow(Inv_Llong,model->ETABEXP)),0.0));
T0y=(1.0+(model->PDIBLCL*max((pow(Inv_L,model->PDIBLCLEXP)-pow(Inv_Llong,model->PDIBLCLEXP)),0.0)));
PDIBLC_i=(PDIBLC_i*T0y);
if
((model->ASYMMOD!=0))
{
PDIBLCR_i=(PDIBLCR_i*T0y);
}
T0y=(DELTA_i*(1.0+(model->DELTAL*max((pow(Inv_L,model->DELTALEXP)-pow(Inv_Llong,model->DELTALEXP)),0.0))));
DELTA_i=min(T0y,0.5);
FPROUT_i=(FPROUT_i*(1.0+(model->FPROUTL*max((pow(Inv_L,model->FPROUTLEXP)-pow(Inv_Llong,model->FPROUTLEXP)),0.0))));
T0y=(1.0+(model->PCLML*max((pow(Inv_L,model->PCLMLEXP)-pow(Inv_Llong,model->PCLMLEXP)),0.0)));
PCLM_i=(PCLM_i*T0y);
PCLM_i=max(PCLM_i,0.0);
if
((model->ASYMMOD!=0))
{
PCLMR_i=(PCLMR_i*T0y);
PCLMR_i=max(PCLMR_i,0.0);
}
T0y=(model->VSATL*max((pow(Inv_L,model->VSATLEXP)-pow(Inv_Llong,model->VSATLEXP)),0.0));
T1y=((model->VSATW*max((pow(Inv_W,model->VSATWEXP)-pow(Inv_Wwide,model->VSATWEXP)),0.0))+(model->VSATWL*pow(Inv_WL,model->VSATWLEXP)));
VSAT_i=(VSAT_i*((1.0+T0y)+T1y));
if
((model->ASYMMOD!=0))
{
VSATR_i=(VSATR_i*((1.0+T0y)+T1y));
}
PSAT_i=max((PSAT_i*(1.0+(model->PSATL*max((pow(Inv_L,model->PSATLEXP)-pow(Inv_Llong,model->PSATLEXP)),0.0)))),0.25);
if
((model->ASYMMOD!=0))
{
PSATR_i=max((PSATR_i*(1.0+(model->PSATL*max((pow(Inv_L,model->PSATLEXP)-pow(Inv_Llong,model->PSATLEXP)),0.0)))),0.25);
}
T0y=(1.0+(model->PTWGL*max((pow(Inv_L,model->PTWGLEXP)-pow(Inv_Llong,model->PTWGLEXP)),0.0)));
PTWG_i=(PTWG_i*T0y);
if
((model->ASYMMOD!=0))
{
PTWGR_i=(PTWGR_i*T0y);
}
ALPHA0_i=(ALPHA0_i*(1.0+(model->ALPHA0L*max((pow(Inv_L,model->ALPHA0LEXP)-pow(Inv_Llong,model->ALPHA0LEXP)),0.0))));
AGIDL_i=(AGIDL_i*((1.0+(model->AGIDLL*Inv_L))+(model->AGIDLW*Inv_W)));
AGISL_i=(AGISL_i*((1.0+(model->AGISLL*Inv_L))+(model->AGISLW*Inv_W)));
AIGC_i=(AIGC_i*((1.0+(model->AIGCL*Inv_L))+(model->AIGCW*Inv_W)));
AIGS_i=(AIGS_i*((1.0+(model->AIGSL*Inv_L))+(model->AIGSW*Inv_W)));
AIGD_i=(AIGD_i*((1.0+(model->AIGDL*Inv_L))+(model->AIGDW*Inv_W)));
PIGCD_i=(model->PIGCD*(1.0+(model->PIGCDL*Inv_L)));
T0y=((model->NDEPCVL1*max((pow(Inv_Lact,model->NDEPCVLEXP1)-pow(Inv_Llong,model->NDEPCVLEXP1)),0.0))+(model->NDEPCVL2*max((pow(Inv_Lact,model->NDEPCVLEXP2)-pow(Inv_Llong,model->NDEPCVLEXP2)),0.0)));
T1y=((model->NDEPCVW*max((pow(Inv_Wact,model->NDEPCVWEXP)-pow(Inv_Wwide,model->NDEPCVWEXP)),0.0))+(model->NDEPCVWL*pow((Inv_Wact*Inv_Lact),model->NDEPCVWLEXP)));
NDEPCV_i=(NDEPCV_i*((1.0+T0y)+T1y));
T0y=(model->VFBCVL*max((pow(Inv_Lact,model->VFBCVLEXP)-pow(Inv_Llong,model->VFBCVLEXP)),0.0));
T1y=((model->VFBCVW*max((pow(Inv_Wact,model->VFBCVWEXP)-pow(Inv_Wwide,model->VFBCVWEXP)),0.0))+(model->VFBCVWL*pow(Inv_WL,model->VFBCVWLEXP)));
VFBCV_i=(VFBCV_i*((1.0+T0y)+T1y));
T0y=(model->VSATCVL*max((pow(Inv_Lact,model->VSATCVLEXP)-pow(Inv_Llong,model->VSATCVLEXP)),0.0));
T1y=((model->VSATCVW*max((pow(Inv_W,model->VSATCVWEXP)-pow(Inv_Wwide,model->VSATCVWEXP)),0.0))+(model->VSATCVWL*pow(Inv_WL,model->VSATCVWLEXP)));
VSATCV_i=(VSATCV_i*((1.0+T0y)+T1y));
PCLMCV_i=(PCLMCV_i*(1.0+(model->PCLMCVL*max((pow(Inv_Lact,model->PCLMCVLEXP)-pow(Inv_Llong,model->PCLMCVLEXP)),0.0))));
PCLMCV_i=max(PCLMCV_i,0.0);
T0y=(model->K1L*max((pow(Inv_L,model->K1LEXP)-pow(Inv_Llong,model->K1LEXP)),0.0));
T1y=((model->K1W*max((pow(Inv_W,model->K1WEXP)-pow(Inv_Wwide,model->K1WEXP)),0.0))+(model->K1WL*pow(Inv_WL,model->K1WLEXP)));
K1_i=(K1_i*((1.0+T0y)+T1y));
T0y=(model->K2L*max((pow(Inv_L,model->K2LEXP)-pow(Inv_Llong,model->K2LEXP)),0.0));
T1y=((model->K2W*max((pow(Inv_W,model->K2WEXP)-pow(Inv_Wwide,model->K2WEXP)),0.0))+(model->K2WL*pow(Inv_WL,model->K2WLEXP)));
PRWB_i=(PRWB_i*(1.0+(model->PRWBL*max((pow(Inv_L,model->PRWBLEXP)-pow(Inv_Llong,model->PRWBLEXP)),0))));
UTE_i=(UTE_i*(1.0+(Inv_L*model->UTEL)));
UA1_i=(UA1_i*(1.0+(Inv_L*model->UA1L)));
UD1_i=(UD1_i*(1.0+(Inv_L*model->UD1L)));
AT_i=(AT_i*(1.0+(Inv_L*model->ATL)));
PTWGT_i=(PTWGT_i*(1.0+(Inv_L*model->PTWGTL)));
if
(((here->tNode_connected /* port_connected 13 */)==0))
{
if
(((model->SHMOD==0)||(model->RTH0==0.0)))
{
here->tNode = 0; /* pnode collapsed to GND */ 
  here->tNode_mine = 0;
}
else
{
}
}
if
((model->RDSMOD==1))
{
RSW_i=(RSW_i*(1.0+(model->RSWL*max((pow(Inv_L,model->RSWLEXP)-pow(Inv_Llong,model->RSWLEXP)),0.0))));
RDW_i=(RDW_i*(1.0+(model->RDWL*max((pow(Inv_L,model->RDWLEXP)-pow(Inv_Llong,model->RDWLEXP)),0.0))));
}
else
{
RDSW_i=(RDSW_i*(1.0+(model->RDSWL*max((pow(Inv_L,model->RDSWLEXP)-pow(Inv_Llong,model->RDSWLEXP)),0.0))));
}
if
((UCS_i<1.0))
{
UCS_i=1.0;
}
else
{
if
((UCS_i>2.0))
{
UCS_i=2.0;
}
}
if
((model->ASYMMOD!=0))
{
if
((UCSR_i<1.0))
{
UCSR_i=1.0;
}
else
{
if
((UCSR_i>2.0))
{
UCSR_i=2.0;
}
}
}
if
((CGIDL_i<0.0))
{
}
if
((CGISL_i<0.0))
{
}
if
((CKAPPAD_i<=0.0))
{
}
if
((CKAPPAS_i<=0.0))
{
}
if
((PDITS_i<0.0))
{
}
if
((CIT_i<0.0))
{
}
if
((NFACTOR_i<0.0))
{
}
if
((K1_i<0.0))
{
}
if
((NSD_i<=0.0))
{
}
if
((NDEP_i<=0.0))
{
}
if
((NDEPCV_i<=0.0))
{
}
if
((model->IGBMOD!=0))
{
if
((NIGBINV_i<=0.0))
{
}
if
((NIGBACC_i<=0.0))
{
}
}
if
((model->IGCMOD!=0))
{
if
((POXEDGE_i<=0.0))
{
}
}
if
((CDSCD_i<0.0))
{
}
if
((model->ASYMMOD!=0))
{
if
((CDSCDR_i<0.0))
{
}
}
if
((DLCIG_i<0.0))
{
DLCIG_i=0.0;
}
if
((DLCIGD_i<0.0))
{
DLCIGD_i=0.0;
}
if
((M0_i<0.0))
{
M0_i=0.0;
}
nuEndD=0.0;
nuEndS=0.0;
nuIntD=0.0;
nuIntS=0.0;
Rend=0.0;
Rint=0.0;
DMCGeff=(model->DMCG-model->DMCGT);
DMCIeff=model->DMCI;
DMDGeff=(model->DMDG-model->DMCGT);
if
(here->NRS_Given)
{
RSourceGeo=(model->RSH*here->NRS);
}
else
{
if
(((here->RGEOMOD>0)&&(model->RSH>0.0)))
{
if
((here->GEOMOD<9))
{
if
(((here->NF%2)!=0))
{
nuEndD=1.0;
nuEndS=1.0;
nuIntD=(2.0*max(((here->NF-1.0)/2.0),0.0));
nuIntS=nuIntD;
}
else
{
if
((here->MINZ==1))
{
nuEndD=2.0;
nuIntD=(2.0*max(((here->NF/2.0)-1.0),0.0));
nuEndS=0.0;
nuIntS=here->NF;
}
else
{
nuEndD=0.0;
nuIntD=here->NF;
nuEndS=2.0;
nuIntS=(2.0*max(((here->NF/2.0)-1.0),0.0));
}
}
if
((1==1))
{
if
((nuIntS==0.0))
{
Rint=0.0;
}
else
{
Rint=((model->RSH*DMCGeff)/(Weff*nuIntS));
}
}
else
{
if
((nuIntD==0.0))
{
Rint=0.0;
}
else
{
Rint=((model->RSH*DMCGeff)/(Weff*nuIntD));
}
}
}
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->GEOMOD)==(0)))
{
if
((1==1))
{
if
((1==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(2))||((here->RGEOMOD)==(5)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndS));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(3))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(6)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
}
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(3))||((here->RGEOMOD)==(7)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndS));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(2))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(8)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
}
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
}
else
{
if
((0==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(2))||((here->RGEOMOD)==(5)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndD));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(3))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(6)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
}
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(3))||((here->RGEOMOD)==(7)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndD));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(2))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(8)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
}
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
}
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(1)))
{
if
((1==1))
{
if
((1==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(2))||((here->RGEOMOD)==(5)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndS));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(3))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(6)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
}
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(3))||((here->RGEOMOD)==(7)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndS));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(2))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(8)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
}
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
}
else
{
if
((0==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(2))||((here->RGEOMOD)==(5)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndD));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(3))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(6)))
{
if
((DMCGeff==0.0))
{
}
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(3))||((here->RGEOMOD)==(7)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndD));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(2))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(8)))
{
if
((DMCGeff==0.0))
{
}
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
}
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(2)))
{
if
((1==1))
{
if
((1==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(2))||((here->RGEOMOD)==(5)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndS));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(3))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(6)))
{
if
((DMCGeff==0.0))
{
}
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(3))||((here->RGEOMOD)==(7)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndS));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(2))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(8)))
{
if
((DMCGeff==0.0))
{
}
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
}
else
{
if
((0==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(2))||((here->RGEOMOD)==(5)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndD));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(3))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(6)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
}
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(3))||((here->RGEOMOD)==(7)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndD));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(2))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(8)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
}
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
}
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(3)))
{
if
((1==1))
{
if
((1==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(2))||((here->RGEOMOD)==(5)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndS));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(3))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(6)))
{
if
((DMCGeff==0.0))
{
}
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(3))||((here->RGEOMOD)==(7)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndS));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(2))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(8)))
{
if
((DMCGeff==0.0))
{
}
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
}
else
{
if
((0==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(2))||((here->RGEOMOD)==(5)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndD));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(3))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(6)))
{
if
((DMCGeff==0.0))
{
}
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(3))||((here->RGEOMOD)==(7)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndD));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(2))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(8)))
{
if
((DMCGeff==0.0))
{
}
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
}
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(4)))
{
if
((1==1))
{
if
((1==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(2))||((here->RGEOMOD)==(5)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndS));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(3))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(6)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
}
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(3))||((here->RGEOMOD)==(7)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndS));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(2))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(8)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
}
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
}
else
{
Rend=((model->RSH*DMDGeff)/Weff);
}
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(5)))
{
if
((1==1))
{
if
((1==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(2))||((here->RGEOMOD)==(5)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndS));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(3))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(6)))
{
if
((DMCGeff==0.0))
{
}
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(3))||((here->RGEOMOD)==(7)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndS));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(2))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(8)))
{
if
((DMCGeff==0.0))
{
}
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
}
else
{
if
((nuEndD==0))
{
Rend=0;
}
else
{
Rend=((model->RSH*DMDGeff)/(Weff*nuEndD));
}
}
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(6)))
{
if
((1==1))
{
Rend=((model->RSH*DMDGeff)/Weff);
}
else
{
if
((0==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(2))||((here->RGEOMOD)==(5)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndD));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(3))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(6)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
}
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(3))||((here->RGEOMOD)==(7)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndD));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(2))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(8)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
}
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
}
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(7)))
{
if
((1==1))
{
if
((nuEndS==0))
{
Rend=0;
}
else
{
Rend=((model->RSH*DMDGeff)/(Weff*nuEndS));
}
}
else
{
if
((0==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(2))||((here->RGEOMOD)==(5)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndD));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(3))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(6)))
{
if
((DMCGeff==0.0))
{
}
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(3))||((here->RGEOMOD)==(7)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndD));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(2))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(8)))
{
if
((DMCGeff==0.0))
{
}
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
}
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(8)))
{
Rend=((model->RSH*DMDGeff)/Weff);
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(9)))
{
if
((1==1))
{
Rend=(((0.5*model->RSH)*DMCGeff)/Weff);
if
((here->NF==2.0))
{
Rint=0.0;
}
else
{
Rint=((model->RSH*DMCGeff)/(Weff*(here->NF-2.0)));
}
}
else
{
Rend=0.0;
Rint=((model->RSH*DMCGeff)/(Weff*here->NF));
}
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(10)))
{
if
((1==1))
{
Rend=0.0;
Rint=((model->RSH*DMCGeff)/(Weff*here->NF));
}
else
{
Rend=(((0.5*model->RSH)*DMCGeff)/Weff);
if
((here->NF==2.0))
{
Rint=0.0;
}
else
{
Rint=((model->RSH*DMCGeff)/(Weff*(here->NF-2.0)));
}
}
}
else
/* CASE DEFAULT */
{
Rint=0.0;
}
/* -- CASE END -- */;
if
((Rint<=0.0))
{
RSourceGeo=Rend;
}
else
{
if
((Rend<=0.0))
{
RSourceGeo=Rint;
}
else
{
RSourceGeo=((Rint*Rend)/(Rint+Rend));
}
}
if
((RSourceGeo==0.0))
{
}
}
else
{
RSourceGeo=0.0;
}
}
if
(here->NRD_Given)
{
RDrainGeo=(model->RSH*here->NRD);
}
else
{
if
(((here->RGEOMOD>0)&&(model->RSH>0.0)))
{
if
((here->GEOMOD<9))
{
if
(((here->NF%2)!=0))
{
nuEndD=1.0;
nuEndS=1.0;
nuIntD=(2.0*max(((here->NF-1.0)/2.0),0.0));
nuIntS=nuIntD;
}
else
{
if
((here->MINZ==1))
{
nuEndD=2.0;
nuIntD=(2.0*max(((here->NF/2.0)-1.0),0.0));
nuEndS=0.0;
nuIntS=here->NF;
}
else
{
nuEndD=0.0;
nuIntD=here->NF;
nuEndS=2.0;
nuIntS=(2.0*max(((here->NF/2.0)-1.0),0.0));
}
}
if
((0==1))
{
if
((nuIntS==0.0))
{
Rint=0.0;
}
else
{
Rint=((model->RSH*DMCGeff)/(Weff*nuIntS));
}
}
else
{
if
((nuIntD==0.0))
{
Rint=0.0;
}
else
{
Rint=((model->RSH*DMCGeff)/(Weff*nuIntD));
}
}
}
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->GEOMOD)==(0)))
{
if
((0==1))
{
if
((1==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(2))||((here->RGEOMOD)==(5)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndS));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(3))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(6)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
}
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(3))||((here->RGEOMOD)==(7)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndS));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(2))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(8)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
}
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
}
else
{
if
((0==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(2))||((here->RGEOMOD)==(5)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndD));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(3))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(6)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
}
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(3))||((here->RGEOMOD)==(7)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndD));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(2))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(8)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
}
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
}
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(1)))
{
if
((0==1))
{
if
((1==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(2))||((here->RGEOMOD)==(5)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndS));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(3))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(6)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
}
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(3))||((here->RGEOMOD)==(7)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndS));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(2))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(8)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
}
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
}
else
{
if
((0==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(2))||((here->RGEOMOD)==(5)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndD));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(3))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(6)))
{
if
((DMCGeff==0.0))
{
}
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(3))||((here->RGEOMOD)==(7)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndD));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(2))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(8)))
{
if
((DMCGeff==0.0))
{
}
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
}
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(2)))
{
if
((0==1))
{
if
((1==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(2))||((here->RGEOMOD)==(5)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndS));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(3))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(6)))
{
if
((DMCGeff==0.0))
{
}
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(3))||((here->RGEOMOD)==(7)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndS));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(2))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(8)))
{
if
((DMCGeff==0.0))
{
}
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
}
else
{
if
((0==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(2))||((here->RGEOMOD)==(5)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndD));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(3))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(6)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
}
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(3))||((here->RGEOMOD)==(7)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndD));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(2))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(8)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
}
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
}
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(3)))
{
if
((0==1))
{
if
((1==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(2))||((here->RGEOMOD)==(5)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndS));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(3))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(6)))
{
if
((DMCGeff==0.0))
{
}
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(3))||((here->RGEOMOD)==(7)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndS));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(2))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(8)))
{
if
((DMCGeff==0.0))
{
}
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
}
else
{
if
((0==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(2))||((here->RGEOMOD)==(5)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndD));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(3))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(6)))
{
if
((DMCGeff==0.0))
{
}
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(3))||((here->RGEOMOD)==(7)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndD));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(2))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(8)))
{
if
((DMCGeff==0.0))
{
}
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
}
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(4)))
{
if
((0==1))
{
if
((1==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(2))||((here->RGEOMOD)==(5)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndS));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(3))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(6)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
}
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(3))||((here->RGEOMOD)==(7)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndS));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(2))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(8)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
}
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((3.0*nuEndS)*(DMCGeff+DMCIeff)));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
}
else
{
Rend=((model->RSH*DMDGeff)/Weff);
}
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(5)))
{
if
((0==1))
{
if
((1==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(2))||((here->RGEOMOD)==(5)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndS));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(3))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(6)))
{
if
((DMCGeff==0.0))
{
}
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(3))||((here->RGEOMOD)==(7)))
{
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndS));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(2))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(8)))
{
if
((DMCGeff==0.0))
{
}
if
((nuEndS==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((6.0*nuEndS)*DMCGeff));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
}
else
{
if
((nuEndD==0))
{
Rend=0;
}
else
{
Rend=((model->RSH*DMDGeff)/(Weff*nuEndD));
}
}
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(6)))
{
if
((0==1))
{
Rend=((model->RSH*DMDGeff)/Weff);
}
else
{
if
((0==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(2))||((here->RGEOMOD)==(5)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndD));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(3))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(6)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
}
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(3))||((here->RGEOMOD)==(7)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndD));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(2))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(8)))
{
if
(((DMCGeff+DMCIeff)==0.0))
{
}
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((3.0*nuEndD)*(DMCGeff+DMCIeff)));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
}
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(7)))
{
if
((0==1))
{
if
((nuEndS==0))
{
Rend=0;
}
else
{
Rend=((model->RSH*DMDGeff)/(Weff*nuEndS));
}
}
else
{
if
((0==1))
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(2))||((here->RGEOMOD)==(5)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndD));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(3))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(6)))
{
if
((DMCGeff==0.0))
{
}
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
else
{
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->RGEOMOD)==(1))||((here->RGEOMOD)==(3))||((here->RGEOMOD)==(7)))
{
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*DMCGeff)/(Weff*nuEndD));
}
}
else
/* CASE ITEM */
if
(((here->RGEOMOD)==(2))||((here->RGEOMOD)==(4))||((here->RGEOMOD)==(8)))
{
if
((DMCGeff==0.0))
{
}
if
((nuEndD==0.0))
{
Rend=0.0;
}
else
{
Rend=((model->RSH*Weff)/((6.0*nuEndD)*DMCGeff));
}
}
else
/* CASE DEFAULT */
{
Rend=0.0;
}
/* -- CASE END -- */;
}
}
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(8)))
{
Rend=((model->RSH*DMDGeff)/Weff);
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(9)))
{
if
((0==1))
{
Rend=(((0.5*model->RSH)*DMCGeff)/Weff);
if
((here->NF==2.0))
{
Rint=0.0;
}
else
{
Rint=((model->RSH*DMCGeff)/(Weff*(here->NF-2.0)));
}
}
else
{
Rend=0.0;
Rint=((model->RSH*DMCGeff)/(Weff*here->NF));
}
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(10)))
{
if
((0==1))
{
Rend=0.0;
Rint=((model->RSH*DMCGeff)/(Weff*here->NF));
}
else
{
Rend=(((0.5*model->RSH)*DMCGeff)/Weff);
if
((here->NF==2.0))
{
Rint=0.0;
}
else
{
Rint=((model->RSH*DMCGeff)/(Weff*(here->NF-2.0)));
}
}
}
else
/* CASE DEFAULT */
{
Rint=0.0;
}
/* -- CASE END -- */;
if
((Rint<=0.0))
{
RDrainGeo=Rend;
}
else
{
if
((Rend<=0.0))
{
RDrainGeo=Rint;
}
else
{
RDrainGeo=((Rint*Rend)/(Rint+Rend));
}
}
if
((RDrainGeo==0.0))
{
}
}
else
{
RDrainGeo=0.0;
}
}
if
((RSourceGeo<=1.0e-3))
{
RSourceGeo=1.0e-3;
}
if
((RDrainGeo<=1.0e-3))
{
RDrainGeo=1.0e-3;
}
if
((model->RDSMOD==1))
{
if
((RSWMIN_i<=0.0))
{
RSWMIN_i=0.0;
}
if
((RDWMIN_i<=0.0))
{
RDWMIN_i=0.0;
}
if
((RSW_i<=0.0))
{
RSW_i=0.0;
}
if
((RDW_i<=0.0))
{
RDW_i=0.0;
}
}
else
{
if
((RDSWMIN_i<=0.0))
{
RDSWMIN_i=0.0;
}
if
((RDSW_i<=0.0))
{
RDSW_i=0.0;
}
}
Grbsb=0.0;
Grbdb=0.0;
Grbpb=0.0;
Grbps=0.0;
Grbpd=0.0;
if
((here->RBODYMOD!=0))
{
Lnl=bsimbulk_lln((Leff*1.0e6));
Lnw=bsimbulk_lln((Weff*1.0e6));
Lnnf=bsimbulk_lln(here->NF);
Bodymode=5;
Rbpb=here->RBPB;
Rbpd=here->RBPD;
Rbps=here->RBPS;
Rbdb=here->RBDB;
Rbsb=here->RBSB;
if
(((!model->RBPS0_Given)||(!model->RBPD0_Given)))
{
Bodymode=1;
}
else
{
if
((((!model->RBSBX0_Given)&&(!model->RBSBY0_Given))||((!model->RBDBX0_Given)&&(!model->RBDBY0_Given))))
{
Bodymode=3;
}
}
if
((here->RBODYMOD==2))
{
if
((Bodymode==5))
{
Rbsbx=(model->RBSBX0*bsimbulk_lexp((((model->RBSDBXL*Lnl)+(model->RBSDBXW*Lnw))+(model->RBSDBXNF*Lnnf))));
Rbsby=(model->RBSBY0*bsimbulk_lexp((((model->RBSDBYL*Lnl)+(model->RBSDBYW*Lnw))+(model->RBSDBYNF*Lnnf))));
Rbsb=((Rbsbx*Rbsby)/(Rbsbx+Rbsby));
Rbdbx=(model->RBDBX0*bsimbulk_lexp((((model->RBSDBXL*Lnl)+(model->RBSDBXW*Lnw))+(model->RBSDBXNF*Lnnf))));
Rbdby=(model->RBDBY0*bsimbulk_lexp((((model->RBSDBYL*Lnl)+(model->RBSDBYW*Lnw))+(model->RBSDBYNF*Lnnf))));
Rbdb=((Rbdbx*Rbdby)/(Rbdbx+Rbdby));
}
if
(((Bodymode==3)||(Bodymode==5)))
{
Rbps=(model->RBPS0*bsimbulk_lexp((((model->RBPSL*Lnl)+(model->RBPSW*Lnw))+(model->RBPSNF*Lnnf))));
Rbpd=(model->RBPD0*bsimbulk_lexp((((model->RBPDL*Lnl)+(model->RBPDW*Lnw))+(model->RBPDNF*Lnnf))));
}
Rbpbx=(model->RBPBX0*bsimbulk_lexp((((model->RBPBXL*Lnl)+(model->RBPBXW*Lnw))+(model->RBPBXNF*Lnnf))));
Rbpby=(model->RBPBY0*bsimbulk_lexp((((model->RBPBYL*Lnl)+(model->RBPBYW*Lnw))+(model->RBPBYNF*Lnnf))));
Rbpb=((Rbpbx*Rbpby)/(Rbpbx+Rbpby));
}
if
(((here->RBODYMOD==1)||((here->RBODYMOD==2)&&(Bodymode==5))))
{
if
((Rbdb<1.0e-3))
{
Grbdb=1.0e3;
}
else
{
Grbdb=(model->GBMIN+(1.0/Rbdb));
}
if
((Rbpb<1.0e-3))
{
Grbpb=1.0e3;
}
else
{
Grbpb=(model->GBMIN+(1.0/Rbpb));
}
if
((Rbps<1.0e-3))
{
Grbps=1.0e3;
}
else
{
Grbps=(model->GBMIN+(1.0/Rbps));
}
if
((Rbsb<1.0e-3))
{
Grbsb=1.0e3;
}
else
{
Grbsb=(model->GBMIN+(1.0/Rbsb));
}
if
((Rbpd<1.0e-3))
{
Grbpd=1.0e3;
}
else
{
Grbpd=(model->GBMIN+(1.0/Rbpd));
}
}
else
{
if
(((here->RBODYMOD==2)&&(Bodymode==3)))
{
Grbdb=model->GBMIN;
Grbsb=model->GBMIN;
if
((Rbpb<1.0e-3))
{
Grbpb=1.0e3;
}
else
{
Grbpb=(model->GBMIN+(1.0/Rbpb));
}
if
((Rbps<1.0e-3))
{
Grbps=1.0e3;
}
else
{
Grbps=(model->GBMIN+(1.0/Rbps));
}
if
((Rbpd<1.0e-3))
{
Grbpd=1.0e3;
}
else
{
Grbpd=(model->GBMIN+(1.0/Rbpd));
}
}
else
{
if
(((here->RBODYMOD==2)&&(Bodymode==1)))
{
Grbdb=model->GBMIN;
Grbsb=model->GBMIN;
Grbps=1.0e3;
Grbpd=1.0e3;
if
((Rbpb<1.0e-3))
{
Grbpb=1.0e3;
}
else
{
Grbpb=(model->GBMIN+(1.0/Rbpb));
}
}
}
}
}
Grgeltd=((model->RSHG*(here->XGW+((Weffcj/3.0)/here->NGCON)))/((here->NGCON*here->NF)*(Lnew-model->XGL)));
if
((Grgeltd>0.0))
{
Grgeltd=(1.0/Grgeltd);
}
else
{
Grgeltd=1.0e3;
if
((here->RGATEMOD!=0))
{
}
}
T0y=(model->TOXE*model->TOXE);
T1y=(model->TOXE*POXEDGE_i);
T2y=(T1y*T1y);
ToxRatio=(bsimbulk_lexp((NTOX_i*bsimbulk_lln((model->TOXREF/model->TOXE))))/T0y);
ToxRatioEdge=(bsimbulk_lexp((NTOX_i*bsimbulk_lln((model->TOXREF/T1y))))/T2y);
Aechvb=((model->TYPE==1)?4.97232e-7:3.42537e-7);
Bechvb=((model->TYPE==1)?7.45669e11:1.16645e12);
AechvbEdge=((Aechvb*Weff)*ToxRatioEdge);
BechvbEdge=(((-Bechvb)*model->TOXE)*POXEDGE_i);
Aechvb=(Aechvb*((Weff*Leff)*ToxRatio));
Bechvb=((-Bechvb)*model->TOXE);
Weff_SH=(model->WTH0+Weff);
if
((((model->SHMOD!=0)&&(model->RTH0>0.0))&&(Weff_SH>0.0)))
{
gth=((Weff_SH*here->NF)/model->RTH0);
cth=((model->CTH0*Weff_SH)*here->NF);
}
else
{
gth=1.0;
cth=0.0;
}
if
((model->TNOM<=(-273.15)))
{
Tnom=300.15;
}
else
{
Tnom=(model->TNOM+273.15);
}
if
((((model->SHMOD!=0)&&(model->RTH0>0.0))&&(Weff_SH>0.0)))
{
}
else
{
}
Vtm0=(8.617087e-5*Tnom);
Eg0=(model->BG0SUB-(((model->TBGASUB*Tnom)*Tnom)/(Tnom+model->TBGBSUB)));
if
((((model->SHMOD!=0)&&(model->RTH0>0.0))&&(Weff_SH>0.0)))
{
}
else
{
}
if
((((model->SHMOD!=0)&&(model->RTH0>0.0))&&(Weff_SH>0.0)))
{
}
else
{
}
if
((NGATE_i>0.0))
{
}
else
{
}
T1DEP=sqrt(((2.0*epssi)/(1.60219e-19*NDEP_i)));
litl=sqrt((((epssi/epsox)*model->TOXE)*XJ_i));
if
((model->ASYMMOD!=0))
{
}
eta_mu=((model->TYPE!=1)?(0.33333333333333333*model->ETAMOB):(0.5*model->ETAMOB));
if
((model->ASYMMOD!=0))
{
}
if
((model->ASYMMOD!=0))
{
}
if
((model->ASYMMOD!=0))
{
}
if
((here->GEOMOD<9))
{
if
(((here->NF%2)!=0))
{
nuEndD=1.0;
nuEndS=1.0;
nuIntD=(2.0*max(((here->NF-1.0)/2.0),0.0));
nuIntS=nuIntD;
}
else
{
if
((here->MINZ==1))
{
nuEndD=2.0;
nuIntD=(2.0*max(((here->NF/2.0)-1.0),0.0));
nuEndS=0.0;
nuIntS=here->NF;
}
else
{
nuEndD=0.0;
nuIntD=here->NF;
nuEndS=2.0;
nuIntS=(2.0*max(((here->NF/2.0)-1.0),0.0));
}
}
}
T2y=(DMDGeff+DMDGeff);
PSmer=T2y;
PDmer=T2y;
ASsha=(DMCGeff*Weffcj);
ADsha=(DMCGeff*Weffcj);
ASmer=(DMDGeff*Weffcj);
ADmer=(DMDGeff*Weffcj);
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((here->GEOMOD)==(0)))
{
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(1)))
{
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(2)))
{
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(3)))
{
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(4)))
{
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(5)))
{
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(6)))
{
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(7)))
{
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(8)))
{
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(9)))
{
}
else
/* CASE ITEM */
if
(((here->GEOMOD)==(10)))
{
}
else
/* CASE DEFAULT */
{
}
/* -- CASE END -- */;
if
(here->AS_Given)
{
}
else
{
}
if
(here->AD_Given)
{
}
else
{
}
if
(here->PS_Given)
{
if
((model->PERMOD==0))
{
}
else
{
}
}
else
{
}
if
(here->PD_Given)
{
if
((model->PERMOD==0))
{
}
else
{
}
}
else
{
}
if
((((here->SA>0.0)&&(here->SB>0.0))&&((here->NF==1.0)||((here->NF>1.0)&&(here->SD>0.0)))))
{
W_tmp_stress=(Wnew+model->WLOD);
i=0;
i=(i+1);
Inv_saref=(1.0/(model->SAREF+(0.5*L_mult)));
Inv_sbref=(1.0/(model->SBREF+(0.5*L_mult)));
Inv_odref=(Inv_saref+Inv_sbref);
if
((here->EDGEFET==1))
{
}
}
else
{
}
if
((model->WPEMOD==1))
{
Wdrn=(here->W/here->NF);
if
((((!here->SCA_Given)&&(!here->SCB_Given))&&(!here->SCC_Given)))
{
if
((here->SC_Given&&(here->SC>0.0)))
{
}
else
{
}
}
}
if
((model->ASYMMOD!=0))
{
}
else
{
}
if
((DVTP0_i>0.0))
{
}
else
{
}
VFB_i=(VFB_i+here->DELVTO);
q_vth=0.5;
EeffFactor=(1.0e-8/(epsratio*model->TOXE));
WeffWRFactor=(1.0/(pow((Weff*1.0e6),WR_i)*here->NF));
if
((model->RDSMOD==1))
{
}
else
{
if
((model->RDSMOD==2))
{
}
}
if
((PSATB_i<0.0))
{
}
else
{
}
if
((PVAG_i>0.0))
{
}
else
{
}
if
((FPROUT_i<=0.0))
{
}
else
{
}
if
((PDITS_i>0.0))
{
}
else
{
}
if
((PSCBE2_i>0.0))
{
}
else
{
}
if
((PSATB_i<0.0))
{
}
else
{
}
if
((model->RDSMOD==1))
{
}
else
{
if
((model->RDSMOD==2))
{
}
}
if
((here->RGATEMOD>1))
{
if
((here->RGATEMOD==2))
{
}
}
if
(((model->IGCMOD!=0)||(model->IGBMOD!=0)))
{
if
((model->IGBMOD!=0))
{
}
if
((model->IGCMOD!=0))
{
if
((model->IGCLAMP==1))
{
if
((CIGS_i<0.01))
{
CIGS_i=0.01;
}
}
else
{
}
if
((model->IGCLAMP==1))
{
if
((CIGD_i<0.01))
{
CIGD_i=0.01;
}
}
else
{
}
}
}
if
((model->GIDLMOD!=0))
{
}
czbs_p1=pow(0.1,(-model->MJS));
czbs_p2=((1.0/(1.0-model->MJS))*(1.0-(((0.05*model->MJS)*(1.0+model->MJS))*czbs_p1)));
czbssw_p1=pow(0.1,(-model->MJSWS));
czbssw_p2=((1.0/(1.0-model->MJSWS))*(1.0-(((0.05*model->MJSWS)*(1.0+model->MJSWS))*czbssw_p1)));
czbsswg_p1=pow(0.1,(-model->MJSWGS));
czbsswg_p2=((1.0/(1.0-model->MJSWGS))*(1.0-(((0.05*model->MJSWGS)*(1.0+model->MJSWGS))*czbsswg_p1)));
czbd_p1=pow(0.1,(-model->MJD));
czbd_p2=((1.0/(1.0-model->MJD))*(1.0-(((0.05*model->MJD)*(1.0+model->MJD))*czbd_p1)));
czbdsw_p1=pow(0.1,(-model->MJSWD));
czbdsw_p2=((1.0/(1.0-model->MJSWD))*(1.0-(((0.05*model->MJSWD)*(1.0+model->MJSWD))*czbdsw_p1)));
czbdswg_p1=pow(0.1,(-model->MJSWGD));
czbdswg_p2=((1.0/(1.0-model->MJSWGD))*(1.0-(((0.05*model->MJSWGD)*(1.0+model->MJSWGD))*czbdswg_p1)));
if
((here->SSLMOD!=0))
{
  static_jacobian4(di,si,g,b)
  static_jacobian2s(di,si,t)
  static_jacobian4(di,si,si,bi)
  static_jacobian4(di,si,di,bi)
  static_jacobian4(di,si,gi,bi)
  static_jacobian4(di,si,sbulk,si)
  static_jacobian4(di,si,dbulk,di)
}
if
((model->EM<=0.0))
{
}
else
{
}
if
((model->FNOIMOD==1))
{
if
((model->LINTNOI>=((Leff-model->LH)/2.0)))
{
LINTNOI_i=0.0;
}
else
{
LINTNOI_i=model->LINTNOI;
}
LeffnoiH=Leff;
if
((Leff<model->LH))
{
LeffnoiH=model->LH;
}
if
((Leff!=model->LH))
{
Leffnoi=((LeffnoiH-(2.0*LINTNOI_i))-model->LH);
Leffnoisq=(Leffnoi*Leffnoi);
}
else
{
}
  static_jacobian4(di,si,sbulk,si)
  static_jacobian4(di,si,dbulk,di)
  static_jacobian4(di,si,si,bi)
  static_jacobian4(di,si,di,bi)
  static_jacobian4(di,si,gi,bi)
  static_jacobian2s(di,si,t)
}
else
{
if
((model->LINTNOI>=(Leff/2.0)))
{
LINTNOI_i=0.0;
}
else
{
LINTNOI_i=model->LINTNOI;
}
if
((((model->NOIA>0)||(model->NOIB>0))||(model->NOIC>0)))
{
Leffnoi=(Leff-(2.0*LINTNOI_i));
Leffnoisq=(Leffnoi*Leffnoi);
}
else
{
}
  static_jacobian4(di,si,sbulk,si)
  static_jacobian4(di,si,dbulk,di)
  static_jacobian4(di,si,si,bi)
  static_jacobian4(di,si,di,bi)
  static_jacobian4(di,si,gi,bi)
  static_jacobian2s(di,si,t)
}
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((model->TNOIMOD)==(0)))
{
  static_jacobian4(di,si,si,bi)
  static_jacobian4(di,si,di,bi)
  static_jacobian4(di,si,gi,bi)
  static_jacobian4(di,si,sbulk,si)
  static_jacobian4(di,si,dbulk,di)
  static_jacobian2s(di,si,t)
here->N1Node = 0; /* pnode collapsed to GND */ 
  here->N1Node_mine = 0;
}
else
/* CASE ITEM */
if
(((model->TNOIMOD)==(1)))
{
  static_jacobian1(N2,t)
  static_jacobian2p(N2,si,bi)
  static_jacobian2p(N2,di,bi)
  static_jacobian2p(N2,gi,bi)
  static_jacobian2p(N2,sbulk,si)
  static_jacobian2p(N2,dbulk,di)
  static_jacobian2p(N1,sbulk,si)
  static_jacobian2p(N1,dbulk,di)
  static_jacobian2p(N1,si,bi)
  static_jacobian2p(N1,di,bi)
  static_jacobian2p(N1,gi,bi)
  static_jacobian1(N1,t)
  static_jacobian1(N1,N2)
  static_jacobian2p(N1,sbulk,si)
  static_jacobian2p(N1,dbulk,di)
  static_jacobian2p(N1,si,bi)
  static_jacobian2p(N1,di,bi)
  static_jacobian2p(N1,gi,bi)
  static_jacobian1(N1,t)
  dynamic_jacobian1(N1,N1)
  dynamic_jacobian2p(N1,sbulk,si)
  dynamic_jacobian2p(N1,dbulk,di)
  dynamic_jacobian1(N1,t)
  dynamic_jacobian2p(N1,si,bi)
  dynamic_jacobian2p(N1,di,bi)
  dynamic_jacobian2p(N1,gi,bi)
  static_jacobian4(di,si,si,bi)
  static_jacobian4(di,si,di,bi)
  static_jacobian4(di,si,gi,bi)
  static_jacobian4(di,si,sbulk,si)
  static_jacobian4(di,si,dbulk,di)
  static_jacobian2s(di,si,t)
  static_jacobian2s(di,si,N2)
  static_jacobian4(di,si,si,bi)
  static_jacobian4(di,si,di,bi)
  static_jacobian4(di,si,gi,bi)
  static_jacobian4(di,si,sbulk,si)
  static_jacobian4(di,si,dbulk,di)
  static_jacobian2s(di,si,t)
  dynamic_jacobian2s(gi,si,N1)
  dynamic_jacobian4(gi,si,sbulk,si)
  dynamic_jacobian4(gi,si,dbulk,di)
  dynamic_jacobian2s(gi,si,t)
  dynamic_jacobian4(gi,si,si,bi)
  dynamic_jacobian4(gi,si,di,bi)
  dynamic_jacobian4(gi,si,gi,bi)
  dynamic_jacobian2s(gi,di,N1)
  dynamic_jacobian4(gi,di,sbulk,si)
  dynamic_jacobian4(gi,di,dbulk,di)
  dynamic_jacobian2s(gi,di,t)
  dynamic_jacobian4(gi,di,si,bi)
  dynamic_jacobian4(gi,di,di,bi)
  dynamic_jacobian4(gi,di,gi,bi)
}
else
{ /* no default */ }
/* -- CASE END -- */;
  static_jacobian1(N2,N2)
  static_jacobian1(N1,N1)
if
((model->IGCMOD!=0))
{
  static_jacobian2s(gi,si,t)
  static_jacobian4(gi,si,si,bi)
  static_jacobian4(gi,si,di,bi)
  static_jacobian4(gi,si,gi,bi)
  static_jacobian2s(gi,di,t)
  static_jacobian4(gi,di,si,bi)
  static_jacobian4(gi,di,di,bi)
  static_jacobian4(gi,di,gi,bi)
}
if
((model->IGBMOD!=0))
{
  static_jacobian2s(gi,bi,t)
  static_jacobian4(gi,bi,si,bi)
  static_jacobian4(gi,bi,di,bi)
  static_jacobian4(gi,bi,gi,bi)
}
if
((model->CVMOD==1))
{
VFBCV_i=(VFBCV_i+here->DELVTO);
DPD=((NGATE_i>0.0)?(NDEPCV_i/NGATE_i):0.0);
}
if
((PCLMCV_i!=0.0))
{
}
else
{
}
if
((!model->CF_Given))
{
CF_i=((((2.0*model->EPSROX)*8.85418e-12)/3.14159265358979323846)*bsimbulk_lln((model->CFRCOEFF*(1.0+(0.4e-6/model->TOXE)))));
}
Cgsof=(model->CGSO+CF_i);
Cgdof=(model->CGDO+CF_i);
if
((model->COVMOD==0))
{
}
else
{
}
if
((here->EDGEFET==1))
{
DGAMMAEDGE_i=(model->DGAMMAEDGE*(1.0+(model->DGAMMAEDGEL*pow(Leff,(-model->DGAMMAEDGELEXP)))));
}
  dynamic_jacobian4(gi,bi,si,bi)
  dynamic_jacobian4(gi,bi,di,bi)
  dynamic_jacobian4(gi,bi,gi,bi)
  dynamic_jacobian4(gi,bi,sbulk,si)
  dynamic_jacobian4(gi,bi,dbulk,di)
  dynamic_jacobian2s(gi,bi,t)
  dynamic_jacobian4(si,bi,si,bi)
  dynamic_jacobian4(si,bi,di,bi)
  dynamic_jacobian4(si,bi,gi,bi)
  dynamic_jacobian2s(si,bi,t)
  dynamic_jacobian4(si,bi,sbulk,si)
  dynamic_jacobian4(si,bi,dbulk,di)
  dynamic_jacobian4(di,bi,si,bi)
  dynamic_jacobian4(di,bi,di,bi)
  dynamic_jacobian4(di,bi,gi,bi)
  dynamic_jacobian2s(di,bi,t)
  dynamic_jacobian4(di,bi,sbulk,si)
  dynamic_jacobian4(di,bi,dbulk,di)
  dynamic_jacobian4(gm,si,gm,si)
  dynamic_jacobian4(gm,si,si,bi)
  dynamic_jacobian4(gm,si,di,bi)
  dynamic_jacobian4(gm,si,gi,bi)
  dynamic_jacobian4(gm,si,sbulk,si)
  dynamic_jacobian4(gm,si,dbulk,di)
  dynamic_jacobian2s(gm,si,t)
  dynamic_jacobian4(gm,di,gm,di)
  dynamic_jacobian4(gm,di,si,bi)
  dynamic_jacobian4(gm,di,di,bi)
  dynamic_jacobian4(gm,di,gi,bi)
  dynamic_jacobian4(gm,di,sbulk,si)
  dynamic_jacobian4(gm,di,dbulk,di)
  dynamic_jacobian4(gm,di,gm,si)
  dynamic_jacobian2s(gm,di,t)
  dynamic_jacobian4(gm,bi,gm,bi)
  static_jacobian4(di,si,si,bi)
  static_jacobian4(di,si,di,bi)
  static_jacobian2s(di,si,t)
  static_jacobian4(di,si,gi,bi)
  static_jacobian4(di,si,sbulk,si)
  static_jacobian4(di,si,dbulk,di)
  static_jacobian4(di,si,gm,di)
  static_jacobian4(di,si,gm,si)
if
((model->IGBMOD!=0))
{
  static_jacobian2s(gi,bi,t)
  static_jacobian4(gi,bi,si,bi)
  static_jacobian4(gi,bi,di,bi)
  static_jacobian4(gi,bi,gi,bi)
}
if
((model->IGCMOD!=0))
{
  static_jacobian4(gi,si,di,bi)
  static_jacobian4(gi,si,si,bi)
  static_jacobian4(gi,si,gi,bi)
  static_jacobian2s(gi,si,t)
  static_jacobian4(gi,di,si,bi)
  static_jacobian4(gi,di,di,bi)
  static_jacobian4(gi,di,gi,bi)
  static_jacobian2s(gi,di,t)
}
if
((model->RDSMOD!=2))
{
  static_jacobian4(d,di,si,bi)
  static_jacobian4(d,di,di,bi)
  static_jacobian4(d,di,gi,bi)
  static_jacobian2s(d,di,t)
  static_jacobian4(d,di,d,di)
  static_jacobian4(s,si,si,bi)
  static_jacobian4(s,si,di,bi)
  static_jacobian4(s,si,gi,bi)
  static_jacobian2s(s,si,t)
  static_jacobian4(s,si,s,si)
  static_jacobian4(d,di,si,bi)
  static_jacobian4(d,di,di,bi)
  static_jacobian4(d,di,gi,bi)
  static_jacobian2s(d,di,t)
  static_jacobian4(s,si,si,bi)
  static_jacobian4(s,si,di,bi)
  static_jacobian4(s,si,gi,bi)
  static_jacobian2s(s,si,t)
}
else
{
here->diNode = here->dNode; /* nnode collapsed */
  here->diNode_mine = 0;
here->siNode = here->sNode; /* nnode collapsed */
  here->siNode_mine = 0;
}
if
((here->RGATEMOD==0))
{
here->gmNode = here->gNode; /* nnode collapsed */
  here->gmNode_mine = 0;
}
else
{
if
((here->RGATEMOD==2))
{
}
else
{
}
  static_jacobian2s(g,gm,t)
  static_jacobian4(g,gm,si,bi)
  static_jacobian4(g,gm,di,bi)
  static_jacobian4(g,gm,gi,bi)
  static_jacobian4(g,gm,g,gm)
  static_jacobian4(g,gm,si,bi)
  static_jacobian4(g,gm,di,bi)
  static_jacobian4(g,gm,gi,bi)
  static_jacobian2s(g,gm,t)
}
if
((here->RGATEMOD==3))
{
  static_jacobian2s(gm,gi,t)
  static_jacobian4(gm,gi,si,bi)
  static_jacobian4(gm,gi,di,bi)
  static_jacobian4(gm,gi,gi,bi)
  static_jacobian4(gm,gi,gm,gi)
}
else
{
here->giNode = here->gmNode; /* nnode collapsed */
  here->giNode_mine = 0;
here->gmNode = here->giNode; /* pnode collapsed */
  here->gmNode_mine = 0;
}
if
(((model->SHMOD!=0)&&(model->RTH0>0.0)))
{
if
((model->RDSMOD!=2))
{
  static_jacobian2p(t,s,si)
  static_jacobian2p(t,d,di)
  static_jacobian2p(t,di,si)
  static_jacobian2p(t,si,bi)
  static_jacobian2p(t,di,bi)
  static_jacobian1(t,t)
  static_jacobian2p(t,gi,bi)
  static_jacobian2p(t,sbulk,si)
  static_jacobian2p(t,dbulk,di)
  static_jacobian2p(t,gm,di)
  static_jacobian2p(t,gm,si)
}
else
{
  static_jacobian2p(t,di,si)
  static_jacobian2p(t,si,bi)
  static_jacobian2p(t,di,bi)
  static_jacobian1(t,t)
  static_jacobian2p(t,gi,bi)
  static_jacobian2p(t,sbulk,si)
  static_jacobian2p(t,dbulk,di)
  static_jacobian2p(t,gm,di)
  static_jacobian2p(t,gm,si)
}
  dynamic_jacobian1(t,t)
}
else
{
here->tNode = 0; /* pnode collapsed to GND */ 
  here->tNode_mine = 0;
}
if
((here->RBODYMOD!=0))
{
  static_jacobian4(bi,sbulk,bi,sbulk)
  static_jacobian4(b,sbulk,b,sbulk)
  static_jacobian4(b,bi,b,bi)
  static_jacobian4(b,dbulk,b,dbulk)
  static_jacobian4(bi,dbulk,bi,dbulk)
  static_jacobian2s(sbulk,bi,t)
  static_jacobian2s(sbulk,b,t)
  static_jacobian2s(b,bi,t)
  static_jacobian2s(dbulk,bi,t)
  static_jacobian2s(dbulk,b,t)
}
else
{
here->sbulkNode = here->bNode; /* nnode collapsed */
  here->sbulkNode_mine = 0;
here->biNode = here->bNode; /* nnode collapsed */
  here->biNode_mine = 0;
here->dbulkNode = here->bNode; /* nnode collapsed */
  here->dbulkNode_mine = 0;
}
if
((here->RBODYMOD!=0))
{
  static_jacobian2s(sbulk,si,t)
  static_jacobian4(sbulk,si,si,bi)
  static_jacobian4(sbulk,si,di,bi)
  static_jacobian4(sbulk,si,gi,bi)
  static_jacobian4(sbulk,si,sbulk,si)
  static_jacobian2s(dbulk,di,t)
  static_jacobian4(dbulk,di,si,bi)
  static_jacobian4(dbulk,di,di,bi)
  static_jacobian4(dbulk,di,gi,bi)
  static_jacobian4(dbulk,di,sbulk,si)
  static_jacobian4(dbulk,di,dbulk,di)
  dynamic_jacobian4(sbulk,si,si,bi)
  dynamic_jacobian4(sbulk,si,di,bi)
  dynamic_jacobian4(sbulk,si,gi,bi)
  dynamic_jacobian4(sbulk,si,sbulk,si)
  dynamic_jacobian4(sbulk,si,dbulk,di)
  dynamic_jacobian2s(sbulk,si,t)
  dynamic_jacobian4(dbulk,di,si,bi)
  dynamic_jacobian4(dbulk,di,di,bi)
  dynamic_jacobian4(dbulk,di,gi,bi)
  dynamic_jacobian4(dbulk,di,sbulk,si)
  dynamic_jacobian4(dbulk,di,dbulk,di)
  dynamic_jacobian2s(dbulk,di,t)
}
else
{
  static_jacobian2s(bi,si,t)
  static_jacobian4(bi,si,si,bi)
  static_jacobian4(bi,si,di,bi)
  static_jacobian4(bi,si,gi,bi)
  static_jacobian4(bi,si,sbulk,si)
  static_jacobian2s(bi,di,t)
  static_jacobian4(bi,di,si,bi)
  static_jacobian4(bi,di,di,bi)
  static_jacobian4(bi,di,gi,bi)
  static_jacobian4(bi,di,sbulk,si)
  static_jacobian4(bi,di,dbulk,di)
  dynamic_jacobian4(bi,si,si,bi)
  dynamic_jacobian4(bi,si,di,bi)
  dynamic_jacobian4(bi,si,gi,bi)
  dynamic_jacobian4(bi,si,sbulk,si)
  dynamic_jacobian4(bi,si,dbulk,di)
  dynamic_jacobian2s(bi,si,t)
  dynamic_jacobian4(bi,di,si,bi)
  dynamic_jacobian4(bi,di,di,bi)
  dynamic_jacobian4(bi,di,gi,bi)
  dynamic_jacobian4(bi,di,sbulk,si)
  dynamic_jacobian4(bi,di,dbulk,di)
  dynamic_jacobian2s(bi,di,t)
}

  return(OK);
}
