/***
*** Interface: ngspice 1.0.0.0
 *** created by: admsXml-2.3.7 ***/


#include "ngspice/ngspice.h"
#include "ngspice/cktdefs.h"
#include "ngspice/smpdefs.h"
#include "bsimcmgdefs.h"
#include "ngspice/const.h"
#include "ngspice/sperror.h"
#include "ngspice/ifsim.h"
#include "ngspice/suffix.h"

#define  ELECTRON_CHARGE        1.602191770e-19         /* C */
#define  BOLTZMANN              1.38062259e-23          /* J/oK */

#define jacobian(a,b) here->PTR_J_##a##_##b##_required=1;
#define static_jacobian4(p,q,r,s)  jacobian(p,r) jacobian(p,s) jacobian(q,r) jacobian(q,s)
#define static_jacobian2s(p,q,r)   jacobian(p,r) jacobian(q,r)
#define static_jacobian2p(p,r,s)   jacobian(p,r) jacobian(p,s)
#define static_jacobian1(p,r)      jacobian(p,r)
#define dynamic_jacobian4(p,q,r,s) jacobian(p,r) jacobian(p,s) jacobian(q,r) jacobian(q,s)
#define dynamic_jacobian2s(p,q,r)  jacobian(p,r) jacobian(q,r)
#define dynamic_jacobian2p(p,r,s)  jacobian(p,r) jacobian(p,s)
#define dynamic_jacobian1(p,r)     jacobian(p,r)
#define whitenoise_jacobian4(p,q,r,s)
#define whitenoise_jacobian2s(p,q,r)
#define whitenoise_jacobian2p(p,r,s)
#define whitenoise_jacobian1(p)
#define flickernoise_jacobian4(p,q,r,s)
#define flickernoise_jacobian2s(p,q,r)
#define flickernoise_jacobian2p(p,r,s)
#define flickernoise_jacobian1(p)


int bsimcmgguesstopology (SMPmatrix *matrix, CKTcircuit *ckt, bsimcmgmodel *model, bsimcmginstance *here)
     /* guess topology */
{
  NG_IGNOREABLE(matrix);
  NG_IGNOREABLE(ckt);
double Abulk=0.0/0.0;
double Leffnoisq=0.0/0.0;
double Leffnoi=0.0/0.0;
double qb0=0.0/0.0;
double vesmax=0.0/0.0;
double eta_mu_cv=0.0/0.0;
double E1prime=0.0/0.0;
double E1=0.0/0.0;
double E0prime=0.0/0.0;
double E0=0.0/0.0;
double Eg0=0.0/0.0;
double Vtm0=0.0/0.0;
double Tnom=0.0/0.0;
double igsd_mult0=0.0/0.0;
double Toxratioedge=0.0/0.0;
double Toxratio=0.0/0.0;
double Bechvb=0.0/0.0;
double Aechvb=0.0/0.0;
double qbs=0.0/0.0;
double nbody=0.0/0.0;
double Theta_DITS=0.0/0.0;
double Theta_RSCE=0.0/0.0;
double Theta_DIBL=0.0/0.0;
double Theta_SW=0.0/0.0;
double Theta_SCE=0.0/0.0;
double tmp=0.0/0.0;
double litl=0.0/0.0;
double WeffWRFactor=0.0/0.0;
double EeffFactor=0.0/0.0;
double cgbox=0.0/0.0;
double cdbox=0.0/0.0;
double csbox=0.0/0.0;
double Ccorner=0.0/0.0;
double Acorner=0.0/0.0;
double Cgg_side=0.0/0.0;
double Cfg=0.0/0.0;
double x42_delta=0.0/0.0;
double x42_Cfgsat=0.0/0.0;
double x42_TT2=0.0/0.0;
double x42_TT0=0.0/0.0;
double x42_dcf=0.0/0.0;
double x42_Cfglog=0.0/0.0;
double x42_C3=0.0/0.0;
double x42_C2=0.0/0.0;
double x42_C1=0.0/0.0;
double x42_Ccg=0.0/0.0;
double x42_Ccg2=0.0/0.0;
double x42_Rcf=0.0/0.0;
double x42_r1cf=0.0/0.0;
double x42_Ccg1=0.0/0.0;
double x42_TT1=0.0/0.0;
double x42_CcgSat=0.0/0.0;
double x42_Cnon=0.0/0.0;
double x42_x=0.0/0.0;
double x42_y=0.0/0.0;
double x42_Lmax=0.0/0.0;
double x42_Hgdelta=0.0/0.0;
double x42_Lr=0.0/0.0;
double x42_Hr=0.0/0.0;
double Cgg_top=0.0/0.0;
double Hrsd=0.0/0.0;
double Wg=0.0/0.0;
double Trsd=0.0/0.0;
double Hg=0.0/0.0;
double LSP_i=0.0/0.0;
double Rdsgeo=0.0/0.0;
double Rrsd=0.0/0.0;
double Rrsdside=0.0/0.0;
double RrsdTML=0.0/0.0;
double eta=0.0/0.0;
double T0y=0.0/0.0;
double alpha=0.0/0.0;
double lt=0.0/0.0;
double prsd_total=0.0/0.0;
double arsd_total=0.0/0.0;
double Rsp=0.0/0.0;
double afin=0.0/0.0;
double thetarsp=0.0/0.0;
double mu_rsd=0.0/0.0;
double mu_max=0.0/0.0;
double rhorsd=0.0/0.0;
double Prsd=0.0/0.0;
double Arsd=0.0/0.0;
double RDrainGeo=0.0/0.0;
double RSourceGeo=0.0/0.0;
double Rgeltd=0.0/0.0;
double cth=0.0/0.0;
double gth=0.0/0.0;
double T2y=0.0/0.0;
double T1y=0.0/0.0;
double NTNOI_i=0.0/0.0;
double LINTNOI_i=0.0/0.0;
double LINTIGEN_i=0.0/0.0;
double RDWMIN_i=0.0/0.0;
double RSWMIN_i=0.0/0.0;
double RDSWMIN_i=0.0/0.0;
double NGATE_i=0.0/0.0;
double IGT_i=0.0/0.0;
double TGIDL_i=0.0/0.0;
double IIT_i=0.0/0.0;
double TSS_i=0.0/0.0;
double KT1_i=0.0/0.0;
double PRT_i=0.0/0.0;
double ATCV_i=0.0/0.0;
double AT_i=0.0/0.0;
double PTWGT_i=0.0/0.0;
double UCSTE_i=0.0/0.0;
double UD1_i=0.0/0.0;
double UA1_i=0.0/0.0;
double EMOBT_i=0.0/0.0;
double UTL_i=0.0/0.0;
double UTE_i=0.0/0.0;
double BIGEN_i=0.0/0.0;
double AIGEN_i=0.0/0.0;
double NTGEN_i=0.0/0.0;
double CKAPPAB_i=0.0/0.0;
double CKAPPAD_i=0.0/0.0;
double CKAPPAS_i=0.0/0.0;
double CGBL_i=0.0/0.0;
double CGDL_i=0.0/0.0;
double CGSL_i=0.0/0.0;
double CFD_i=0.0/0.0;
double CFS_i=0.0/0.0;
double TII_i=0.0/0.0;
double SIID_i=0.0/0.0;
double SII2_i=0.0/0.0;
double SII1_i=0.0/0.0;
double SII0_i=0.0/0.0;
double LII_i=0.0/0.0;
double ESATII_i=0.0/0.0;
double BETAII2_i=0.0/0.0;
double BETAII1_i=0.0/0.0;
double BETAII0_i=0.0/0.0;
double BETA0_i=0.0/0.0;
double ALPHAII1_i=0.0/0.0;
double ALPHAII0_i=0.0/0.0;
double ALPHA1_i=0.0/0.0;
double ALPHA0_i=0.0/0.0;
double PGISL_i=0.0/0.0;
double EGISL_i=0.0/0.0;
double CGISL_i=0.0/0.0;
double BGISL_i=0.0/0.0;
double AGISL_i=0.0/0.0;
double PGIDL_i=0.0/0.0;
double EGIDL_i=0.0/0.0;
double CGIDL_i=0.0/0.0;
double BGIDL_i=0.0/0.0;
double AGIDL_i=0.0/0.0;
double POXEDGE_i=0.0/0.0;
double NTOX_i=0.0/0.0;
double CIGD_i=0.0/0.0;
double BIGD_i=0.0/0.0;
double AIGD1_i=0.0/0.0;
double AIGD_i=0.0/0.0;
double CIGS_i=0.0/0.0;
double BIGS_i=0.0/0.0;
double AIGS1_i=0.0/0.0;
double AIGS_i=0.0/0.0;
double PIGCD_i=0.0/0.0;
double CIGC_i=0.0/0.0;
double BIGC_i=0.0/0.0;
double AIGC1_i=0.0/0.0;
double AIGC_i=0.0/0.0;
double NIGBACC_i=0.0/0.0;
double CIGBACC_i=0.0/0.0;
double BIGBACC_i=0.0/0.0;
double AIGBACC1_i=0.0/0.0;
double AIGBACC_i=0.0/0.0;
double NIGBINV_i=0.0/0.0;
double EIGBINV_i=0.0/0.0;
double CIGBINV_i=0.0/0.0;
double BIGBINV_i=0.0/0.0;
double AIGBINV1_i=0.0/0.0;
double AIGBINV_i=0.0/0.0;
double PVAG_i=0.0/0.0;
double DROUT_i=0.0/0.0;
double PDIBL2_i=0.0/0.0;
double PDIBL1_i=0.0/0.0;
double WR_i=0.0/0.0;
double PRWGS_i=0.0/0.0;
double PRWGD_i=0.0/0.0;
double RDW_i=0.0/0.0;
double RSW_i=0.0/0.0;
double RDSW_i=0.0/0.0;
double A21_i=0.0/0.0;
double A2_i=0.0/0.0;
double A11_i=0.0/0.0;
double A1_i=0.0/0.0;
double PCLMCV_i=0.0/0.0;
double PCLMG_i=0.0/0.0;
double PCLM_i=0.0/0.0;
double UCS_i=0.0/0.0;
double UD_i=0.0/0.0;
double EU_i=0.0/0.0;
double UA_i=0.0/0.0;
double UP_i=0.0/0.0;
double ETAMOB_i=0.0/0.0;
double U0_i=0.0/0.0;
double PTWG_i=0.0/0.0;
double MEXP_i=0.0/0.0;
double KSATIV_i=0.0/0.0;
double PSATCV_i=0.0/0.0;
double DELTAVSATCV_i=0.0/0.0;
double PSAT_i=0.0/0.0;
double DELTAVSAT_i=0.0/0.0;
double VSATCV_i=0.0/0.0;
double VSAT1_i=0.0/0.0;
double VSAT_i=0.0/0.0;
double QMTCENCVA_i=0.0/0.0;
double QMTCENCV_i=0.0/0.0;
double QMFACTOR_i=0.0/0.0;
double K2SISAT1_i=0.0/0.0;
double K2SISAT_i=0.0/0.0;
double K0SISAT1_i=0.0/0.0;
double K0SISAT_i=0.0/0.0;
double K2SI1_i=0.0/0.0;
double K2SI_i=0.0/0.0;
double K0SI1_i=0.0/0.0;
double K0SI_i=0.0/0.0;
double K01_i=0.0/0.0;
double K0_i=0.0/0.0;
double DVTSHIFT_i=0.0/0.0;
double LPE0_i=0.0/0.0;
double K1RSCE_i=0.0/0.0;
double DSUB_i=0.0/0.0;
double ETA0_i=0.0/0.0;
double PHIN_i=0.0/0.0;
double DVT1SS_i=0.0/0.0;
double DVT1_i=0.0/0.0;
double DVT0_i=0.0/0.0;
double CDSCD_i=0.0/0.0;
double CDSC_i=0.0/0.0;
double CIT_i=0.0/0.0;
double PHIG_i=0.0/0.0;
double scl=0.0/0.0;
double cox=0.0/0.0;
double NBODY_i=0.0/0.0;
double Inv_LNFIN=0.0/0.0;
double Inv_NFIN=0.0/0.0;
double Inv_L=0.0/0.0;
double NFINtotal=0.0/0.0;
double LeffCV=0.0/0.0;
double Leff1=0.0/0.0;
double Leff=0.0/0.0;
double deltaLCV=0.0/0.0;
double deltaL1=0.0/0.0;
double deltaL=0.0/0.0;
double Lg=0.0/0.0;
double gfactor=0.0/0.0;
double gprime=0.0/0.0;
double mdprime=0.0/0.0;
double md=0.0/0.0;
double mxprime=0.0/0.0;
double mx=0.0/0.0;
double epsratio=0.0/0.0;
double cbox=0.0/0.0;
double epssp=0.0/0.0;
double epssub=0.0/0.0;
int devsign;
double Qdep_ov_Cins=0.0/0.0;
double auxQMfact=0.0/0.0;
double rc=0.0/0.0;
double Weff_UFCM=0.0/0.0;
double Ach=0.0/0.0;
double Cins=0.0/0.0;
double ggeltd=0.0/0.0;
double VSATR_i=0.0/0.0;
double UTLR_i=0.0/0.0;
double UTER_i=0.0/0.0;
double UDR_i=0.0/0.0;
double UD1R_i=0.0/0.0;
double UCR_i=0.0/0.0;
double UC1R_i=0.0/0.0;
double UAR_i=0.0/0.0;
double UA1R_i=0.0/0.0;
double DVTSHIFTR_i=0.0/0.0;
double Tcen0=0.0/0.0;
double T3y=0.0/0.0;
double LeffCV_acc=0.0/0.0;
double PCLMR_i=0.0/0.0;
double DVTP1_i=0.0/0.0;
double DVTP0_i=0.0/0.0;
double CITR_i=0.0/0.0;
double ATR_i=0.0/0.0;
double EUR_i=0.0/0.0;
double UPR_i=0.0/0.0;
double U0R_i=0.0/0.0;
double UC1_i=0.0/0.0;
double UC_i=0.0/0.0;
double K21_i=0.0/0.0;
double K2_i=0.0/0.0;
double KSATIVR_i=0.0/0.0;
double K2SAT1_i=0.0/0.0;
double K2SAT_i=0.0/0.0;
double K11_i=0.0/0.0;
double K1_i=0.0/0.0;
double PHIBE_i=0.0/0.0;
double PDIBL2R_i=0.0/0.0;
double PDIBL1R_i=0.0/0.0;
double PTWGR_i=0.0/0.0;
double MEXPR_i=0.0/0.0;
double VSAT1R_i=0.0/0.0;
double ETA0R_i=0.0/0.0;
double CDSCDR_i=0.0/0.0;
double CGDO_i=0.0/0.0;
double CGSO_i=0.0/0.0;
double Cfr_geo=0.0/0.0;
double MTcen=0.0/0.0;
double WeffCV0=0.0/0.0;
double Weff0=0.0/0.0;
Weff0=0.0;
WeffCV0=0.0;
MTcen=0.0;
Cfr_geo=0.0;
CGSO_i=0.0;
CGDO_i=0.0;
CDSCDR_i=0.0;
ETA0R_i=0.0;
VSAT1R_i=0.0;
MEXPR_i=0.0;
PTWGR_i=0.0;
PDIBL1R_i=0.0;
PDIBL2R_i=0.0;
PHIBE_i=0.0;
K1_i=0.0;
K11_i=0.0;
K2SAT_i=0.0;
K2SAT1_i=0.0;
KSATIVR_i=0.0;
K2_i=0.0;
K21_i=0.0;
UC_i=0.0;
UC1_i=0.0;
U0R_i=0.0;
UPR_i=0.0;
EUR_i=0.0;
ATR_i=0.0;
CITR_i=0.0;
ETA0R_i=0.0;
DVTP0_i=0.0;
DVTP1_i=0.0;
PDIBL2R_i=0.0;
PCLMR_i=0.0;
LeffCV_acc=0.0;
T3y=0.0;
Tcen0=0.0;
DVTSHIFTR_i=0.0;
UA1R_i=0.0;
UAR_i=0.0;
UC1R_i=0.0;
UCR_i=0.0;
UD1R_i=0.0;
UDR_i=0.0;
UTER_i=0.0;
UTLR_i=0.0;
VSATR_i=0.0;
ggeltd=0.0;
Cins=1.0;
Ach=1.0;
Weff_UFCM=1.0;
rc=1.0;
auxQMfact=0.0;
Qdep_ov_Cins=0.0;
if
((model->TYPE==1))
{
devsign=1;
}
else
{
devsign=(-1);
}
epssub=(model->EPSRSUB*8.8542e-12);
epssp=(model->EPSRSP*8.8542e-12);
cbox=((model->EPSROX*8.8542e-12)/model->EOTBOX);
epsratio=(model->EPSRSUB/model->EPSROX);
if
(((here->tNode_connected /* port_connected 13 */)==1))
{
if
((model->SHMOD==0))
{
if
((model->SH_WARN==1))
{
}
}
}
mx=(0.916*9.11e-31);
mxprime=(0.190*9.11e-31);
md=(0.190*9.11e-31);
mdprime=(0.417*9.11e-31);
gprime=4.0;
gfactor=2.0;
Lg=(here->L+model->XL);
deltaL=(model->LINT+(model->LL*pow(Lg,(-model->LLN))));
deltaL1=(model->LINT+(model->LL*pow((Lg+model->DLBIN),(-model->LLN))));
deltaLCV=(model->DLC+(model->LLC*pow(Lg,(-model->LLN))));
Leff=(Lg-(2.0*deltaL));
Leff1=((Lg+model->DLBIN)-(2.0*deltaL1));
LeffCV=(Lg-(2.0*deltaLCV));
if
((model->BULKMOD!=0))
{
LeffCV_acc=(LeffCV-model->DLCACC);
}
NFINtotal=(here->NFIN*here->NF);
if
((Leff<=0.0))
{
}
else
{
if
((Leff<=1.0e-9))
{
}
}
if
((Leff1<=0.0))
{
}
else
{
if
((Leff1<=1.0e-9))
{
}
}
Inv_L=(1.0e-6/Leff1);
Inv_NFIN=(1.0/here->NFIN);
Inv_LNFIN=(1.0e-6/(Leff1*here->NFIN));
NBODY_i=(((model->NBODY+(Inv_L*model->LNBODY))+(Inv_NFIN*model->NNBODY))+(Inv_LNFIN*model->PNBODY));
if
((model->NBODYN1!=0.0))
{
NBODY_i=(NBODY_i*(1.0+((model->NBODYN1/here->NFIN)*bsimcmg_lln((1.0+(here->NFIN/model->NBODYN2))))));
}
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((model->GEOMOD)==(0)))
{
if
(((!model->TFIN_TOP_Given)||(!model->TFIN_BASE_Given)))
{
Weff_UFCM=(2.0*model->HFIN);
Cins=(((Weff_UFCM*model->EPSROX)*8.8542e-12)/model->EOT);
Ach=(model->HFIN*here->TFIN);
rc=((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach));
Qdep_ov_Cins=((((-1.60219e-19)*NBODY_i)*Ach)/Cins);
}
else
{
Weff_UFCM=(2.0*sqrt(((model->HFIN*model->HFIN)+(((model->TFIN_TOP-model->TFIN_BASE)*(model->TFIN_TOP-model->TFIN_BASE))/4.0))));
Cins=(((Weff_UFCM*model->EPSROX)*8.8542e-12)/model->EOT);
Ach=((model->HFIN*(model->TFIN_TOP+model->TFIN_BASE))/2.0);
rc=((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach));
Qdep_ov_Cins=((((-1.60219e-19)*NBODY_i)*Ach)/Cins);
}
}
else
/* CASE ITEM */
if
(((model->GEOMOD)==(1)))
{
if
(((!model->TFIN_TOP_Given)||(!model->TFIN_BASE_Given)))
{
Weff_UFCM=((2.0*model->HFIN)+here->TFIN);
Cins=(((Weff_UFCM*model->EPSROX)*8.8542e-12)/model->EOT);
Ach=(model->HFIN*here->TFIN);
rc=((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach));
Qdep_ov_Cins=((((-1.60219e-19)*NBODY_i)*Ach)/Cins);
}
else
{
Weff_UFCM=((2.0*sqrt(((model->HFIN*model->HFIN)+(((model->TFIN_TOP-model->TFIN_BASE)*(model->TFIN_TOP-model->TFIN_BASE))/4.0))))+model->TFIN_TOP);
Cins=(((Weff_UFCM*model->EPSROX)*8.8542e-12)/model->EOT);
Ach=((model->HFIN*(model->TFIN_TOP+model->TFIN_BASE))/2.0);
rc=((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach));
Qdep_ov_Cins=((((-1.60219e-19)*NBODY_i)*Ach)/Cins);
}
}
else
/* CASE ITEM */
if
(((model->GEOMOD)==(2)))
{
if
(((!model->TFIN_TOP_Given)||(!model->TFIN_BASE_Given)))
{
Weff_UFCM=((2.0*model->HFIN)+(2.0*here->TFIN));
Cins=(((Weff_UFCM*model->EPSROX)*8.8542e-12)/model->EOT);
Ach=(model->HFIN*here->TFIN);
rc=((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach));
Qdep_ov_Cins=((((-1.60219e-19)*NBODY_i)*Ach)/Cins);
}
else
{
Weff_UFCM=(((2.0*sqrt(((model->HFIN*model->HFIN)+(((model->TFIN_TOP-model->TFIN_BASE)*(model->TFIN_TOP-model->TFIN_BASE))/4.0))))+model->TFIN_TOP)+model->TFIN_BASE);
Cins=(((Weff_UFCM*model->EPSROX)*8.8542e-12)/model->EOT);
Ach=((model->HFIN*(model->TFIN_TOP+model->TFIN_BASE))/2.0);
rc=((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach));
Qdep_ov_Cins=((((-1.60219e-19)*NBODY_i)*Ach)/Cins);
}
}
else
/* CASE ITEM */
if
(((model->GEOMOD)==(3)))
{
Weff_UFCM=(3.14159265358979323846*here->D);
Cins=((((2.0*3.14159265358979323846)*model->EPSROX)*8.8542e-12)/log((1.0+((2.0*model->EOT)/here->D))));
Ach=(((3.14159265358979323846*here->D)*here->D)/4.0);
rc=((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach));
Qdep_ov_Cins=((((-1.60219e-19)*NBODY_i)*Ach)/Cins);
}
else
/* CASE ITEM */
if
(((model->GEOMOD)==(4)))
{
Weff_UFCM=model->W_UFCM;
Cins=model->CINS_UFCM;
Ach=model->ACH_UFCM;
rc=((2.0*Cins)/(((Weff_UFCM*Weff_UFCM)*epssub)/Ach));
Qdep_ov_Cins=((((-1.60219e-19)*NBODY_i)*Ach)/Cins);
}
else
{ /* no default */ }
/* -- CASE END -- */;
cox=(Cins/Weff_UFCM);
if
((model->BULKMOD!=0))
{
}
Weff0=(Weff_UFCM-model->DELTAW);
WeffCV0=(Weff_UFCM-model->DELTAWCV);
scl=sqrt((((epssub*Ach)/Cins)*(1.0+((Ach*Cins)/(((2.0*epssub)*Weff_UFCM)*Weff_UFCM)))));
PHIG_i=(((model->PHIG+(Inv_L*model->LPHIG))+(Inv_NFIN*model->NPHIG))+(Inv_LNFIN*model->PPHIG));
CIT_i=(((model->CIT+(Inv_L*model->LCIT))+(Inv_NFIN*model->NCIT))+(Inv_LNFIN*model->PCIT));
CDSC_i=(((model->CDSC+(Inv_L*model->LCDSC))+(Inv_NFIN*model->NCDSC))+(Inv_LNFIN*model->PCDSC));
CDSCD_i=(((model->CDSCD+(Inv_L*model->LCDSCD))+(Inv_NFIN*model->NCDSCD))+(Inv_LNFIN*model->PCDSCD));
DVT0_i=(((model->DVT0+(Inv_L*model->LDVT0))+(Inv_NFIN*model->NDVT0))+(Inv_LNFIN*model->PDVT0));
DVT1_i=(((model->DVT1+(Inv_L*model->LDVT1))+(Inv_NFIN*model->NDVT1))+(Inv_LNFIN*model->PDVT1));
DVT1SS_i=(((model->DVT1SS+(Inv_L*model->LDVT1SS))+(Inv_NFIN*model->NDVT1SS))+(Inv_LNFIN*model->PDVT1SS));
PHIN_i=(((model->PHIN+(Inv_L*model->LPHIN))+(Inv_NFIN*model->NPHIN))+(Inv_LNFIN*model->PPHIN));
ETA0_i=(((model->ETA0+(Inv_L*model->LETA0))+(Inv_NFIN*model->NETA0))+(Inv_LNFIN*model->PETA0));
DSUB_i=(((model->DSUB+(Inv_L*model->LDSUB))+(Inv_NFIN*model->NDSUB))+(Inv_LNFIN*model->PDSUB));
K1RSCE_i=(((model->K1RSCE+(Inv_L*model->LK1RSCE))+(Inv_NFIN*model->NK1RSCE))+(Inv_LNFIN*model->PK1RSCE));
LPE0_i=(((model->LPE0+(Inv_L*model->LLPE0))+(Inv_NFIN*model->NLPE0))+(Inv_LNFIN*model->PLPE0));
DVTSHIFT_i=(((model->DVTSHIFT+(Inv_L*model->LDVTSHIFT))+(Inv_NFIN*model->NDVTSHIFT))+(Inv_LNFIN*model->PDVTSHIFT));
K0_i=(((model->K0+(Inv_L*model->LK0))+(Inv_NFIN*model->NK0))+(Inv_LNFIN*model->PK0));
K01_i=(((model->K01+(Inv_L*model->LK01))+(Inv_NFIN*model->NK01))+(Inv_LNFIN*model->PK01));
K0SI_i=(((model->K0SI+(Inv_L*model->LK0SI))+(Inv_NFIN*model->NK0SI))+(Inv_LNFIN*model->PK0SI));
K0SI1_i=(((model->K0SI1+(Inv_L*model->LK0SI1))+(Inv_NFIN*model->NK0SI1))+(Inv_LNFIN*model->PK0SI1));
K2SI_i=(((model->K2SI+(Inv_L*model->LK2SI))+(Inv_NFIN*model->NK2SI))+(Inv_LNFIN*model->PK2SI));
K2SI1_i=(((model->K2SI1+(Inv_L*model->LK2SI1))+(Inv_NFIN*model->NK2SI1))+(Inv_LNFIN*model->PK2SI1));
K0SISAT_i=(((model->K0SISAT+(Inv_L*model->LK0SISAT))+(Inv_NFIN*model->NK0SISAT))+(Inv_LNFIN*model->PK0SISAT));
K0SISAT1_i=(((model->K0SISAT1+(Inv_L*model->LK0SISAT1))+(Inv_NFIN*model->NK0SISAT1))+(Inv_LNFIN*model->PK0SISAT1));
K2SISAT_i=(((model->K2SISAT+(Inv_L*model->LK2SISAT))+(Inv_NFIN*model->NK2SISAT))+(Inv_LNFIN*model->PK2SISAT));
K2SISAT1_i=(((model->K2SISAT1+(Inv_L*model->LK2SISAT1))+(Inv_NFIN*model->NK2SISAT1))+(Inv_LNFIN*model->PK2SISAT1));
if
((model->BULKMOD!=0))
{
if
((model->BULKMOD==2))
{
K2_i=(((model->K2+(Inv_L*model->LK2))+(Inv_NFIN*model->NK2))+(Inv_LNFIN*model->PK2));
K21_i=(((model->K21+(Inv_L*model->LK21))+(Inv_NFIN*model->NK21))+(Inv_LNFIN*model->PK21));
K2SAT_i=(((model->K2SAT+(Inv_L*model->LK2SAT))+(Inv_NFIN*model->NK2SAT))+(Inv_LNFIN*model->PK2SAT));
K2SAT1_i=(((model->K2SAT1+(Inv_L*model->LK2SAT1))+(Inv_NFIN*model->NK2SAT1))+(Inv_LNFIN*model->PK2SAT1));
}
PHIBE_i=(((model->PHIBE+(Inv_L*model->LPHIBE))+(Inv_NFIN*model->NPHIBE))+(Inv_LNFIN*model->PPHIBE));
K1_i=(((model->K1+(Inv_L*model->LK1))+(Inv_NFIN*model->NK1))+(Inv_LNFIN*model->PK1));
K11_i=(((model->K11+(Inv_L*model->LK11))+(Inv_NFIN*model->NK11))+(Inv_LNFIN*model->PK11));
}
QMFACTOR_i=(((model->QMFACTOR+(Inv_L*model->LQMFACTOR))+(Inv_NFIN*model->NQMFACTOR))+(Inv_LNFIN*model->PQMFACTOR));
QMTCENCV_i=(((model->QMTCENCV+(Inv_L*model->LQMTCENCV))+(Inv_NFIN*model->NQMTCENCV))+(Inv_LNFIN*model->PQMTCENCV));
QMTCENCVA_i=(((model->QMTCENCVA+(Inv_L*model->LQMTCENCVA))+(Inv_NFIN*model->NQMTCENCVA))+(Inv_LNFIN*model->PQMTCENCVA));
VSAT_i=(((model->VSAT+(Inv_L*model->LVSAT))+(Inv_NFIN*model->NVSAT))+(Inv_LNFIN*model->PVSAT));
VSAT1_i=(((model->VSAT1+(Inv_L*model->LVSAT1))+(Inv_NFIN*model->NVSAT1))+(Inv_LNFIN*model->PVSAT1));
VSATCV_i=(((model->VSATCV+(Inv_L*model->LVSATCV))+(Inv_NFIN*model->NVSATCV))+(Inv_LNFIN*model->PVSATCV));
DELTAVSAT_i=(((model->DELTAVSAT+(Inv_L*model->LDELTAVSAT))+(Inv_NFIN*model->NDELTAVSAT))+(Inv_LNFIN*model->PDELTAVSAT));
PSAT_i=(((model->PSAT+(Inv_L*model->LPSAT))+(Inv_NFIN*model->NPSAT))+(Inv_LNFIN*model->PPSAT));
DELTAVSATCV_i=(((model->DELTAVSATCV+(Inv_L*model->LDELTAVSATCV))+(Inv_NFIN*model->NDELTAVSATCV))+(Inv_LNFIN*model->PDELTAVSATCV));
PSATCV_i=(((model->PSATCV+(Inv_L*model->LPSATCV))+(Inv_NFIN*model->NPSATCV))+(Inv_LNFIN*model->PPSATCV));
KSATIV_i=(((model->KSATIV+(Inv_L*model->LKSATIV))+(Inv_NFIN*model->NKSATIV))+(Inv_LNFIN*model->PKSATIV));
MEXP_i=(((model->MEXP+(Inv_L*model->LMEXP))+(Inv_NFIN*model->NMEXP))+(Inv_LNFIN*model->PMEXP));
PTWG_i=(((model->PTWG+(Inv_L*model->LPTWG))+(Inv_NFIN*model->NPTWG))+(Inv_LNFIN*model->PPTWG));
U0_i=(((model->U0+(Inv_L*model->LU0))+(Inv_NFIN*model->NU0))+(Inv_LNFIN*model->PU0));
ETAMOB_i=(((model->ETAMOB+(Inv_L*model->LETAMOB))+(Inv_NFIN*model->NETAMOB))+(Inv_LNFIN*model->PETAMOB));
UP_i=(((model->UP+(Inv_L*model->LUP))+(Inv_NFIN*model->NUP))+(Inv_LNFIN*model->PUP));
UA_i=(((model->UA+(Inv_L*model->LUA))+(Inv_NFIN*model->NUA))+(Inv_LNFIN*model->PUA));
if
((model->BULKMOD!=0))
{
UC_i=(((model->UC+(Inv_L*model->LUC))+(Inv_NFIN*model->NUC))+(Inv_LNFIN*model->PUC));
}
EU_i=(((model->EU+(Inv_L*model->LEU))+(Inv_NFIN*model->NEU))+(Inv_LNFIN*model->PEU));
UD_i=(((model->UD+(Inv_L*model->LUD))+(Inv_NFIN*model->NUD))+(Inv_LNFIN*model->PUD));
UCS_i=(((model->UCS+(Inv_L*model->LUCS))+(Inv_NFIN*model->NUCS))+(Inv_LNFIN*model->PUCS));
PCLM_i=(((model->PCLM+(Inv_L*model->LPCLM))+(Inv_NFIN*model->NPCLM))+(Inv_LNFIN*model->PPCLM));
PCLMG_i=(((model->PCLMG+(Inv_L*model->LPCLMG))+(Inv_NFIN*model->NPCLMG))+(Inv_LNFIN*model->PPCLMG));
PCLMCV_i=(((model->PCLMCV+(Inv_L*model->LPCLMCV))+(Inv_NFIN*model->NPCLMCV))+(Inv_LNFIN*model->PPCLMCV));
A1_i=(((model->A1+(Inv_L*model->LA1))+(Inv_NFIN*model->NA1))+(Inv_LNFIN*model->PA1));
A11_i=(((model->A11+(Inv_L*model->LA11))+(Inv_NFIN*model->NA11))+(Inv_LNFIN*model->PA11));
A2_i=(((model->A2+(Inv_L*model->LA2))+(Inv_NFIN*model->NA2))+(Inv_LNFIN*model->PA2));
A21_i=(((model->A21+(Inv_L*model->LA21))+(Inv_NFIN*model->NA21))+(Inv_LNFIN*model->PA21));
RDSW_i=(((model->RDSW+(Inv_L*model->LRDSW))+(Inv_NFIN*model->NRDSW))+(Inv_LNFIN*model->PRDSW));
RSW_i=(((model->RSW+(Inv_L*model->LRSW))+(Inv_NFIN*model->NRSW))+(Inv_LNFIN*model->PRSW));
RDW_i=(((model->RDW+(Inv_L*model->LRDW))+(Inv_NFIN*model->NRDW))+(Inv_LNFIN*model->PRDW));
PRWGD_i=(((model->PRWGD+(Inv_L*model->LPRWGD))+(Inv_NFIN*model->NPRWGD))+(Inv_LNFIN*model->PPRWGD));
PRWGS_i=(((model->PRWGS+(Inv_L*model->LPRWGS))+(Inv_NFIN*model->NPRWGS))+(Inv_LNFIN*model->PPRWGS));
WR_i=(((model->WR+(Inv_L*model->LWR))+(Inv_NFIN*model->NWR))+(Inv_LNFIN*model->PWR));
PDIBL1_i=(((model->PDIBL1+(Inv_L*model->LPDIBL1))+(Inv_NFIN*model->NPDIBL1))+(Inv_LNFIN*model->PPDIBL1));
PDIBL2_i=(((model->PDIBL2+(Inv_L*model->LPDIBL2))+(Inv_NFIN*model->NPDIBL2))+(Inv_LNFIN*model->PPDIBL2));
DROUT_i=(((model->DROUT+(Inv_L*model->LDROUT))+(Inv_NFIN*model->NDROUT))+(Inv_LNFIN*model->PDROUT));
PVAG_i=(((model->PVAG+(Inv_L*model->LPVAG))+(Inv_NFIN*model->NPVAG))+(Inv_LNFIN*model->PPVAG));
AIGBINV_i=(((model->AIGBINV+(Inv_L*model->LAIGBINV))+(Inv_NFIN*model->NAIGBINV))+(Inv_LNFIN*model->PAIGBINV));
AIGBINV1_i=(((model->AIGBINV1+(Inv_L*model->LAIGBINV1))+(Inv_NFIN*model->NAIGBINV1))+(Inv_LNFIN*model->PAIGBINV1));
BIGBINV_i=(((model->BIGBINV+(Inv_L*model->LBIGBINV))+(Inv_NFIN*model->NBIGBINV))+(Inv_LNFIN*model->PBIGBINV));
CIGBINV_i=(((model->CIGBINV+(Inv_L*model->LCIGBINV))+(Inv_NFIN*model->NCIGBINV))+(Inv_LNFIN*model->PCIGBINV));
EIGBINV_i=(((model->EIGBINV+(Inv_L*model->LEIGBINV))+(Inv_NFIN*model->NEIGBINV))+(Inv_LNFIN*model->PEIGBINV));
NIGBINV_i=(((model->NIGBINV+(Inv_L*model->LNIGBINV))+(Inv_NFIN*model->NNIGBINV))+(Inv_LNFIN*model->PNIGBINV));
AIGBACC_i=(((model->AIGBACC+(Inv_L*model->LAIGBACC))+(Inv_NFIN*model->NAIGBACC))+(Inv_LNFIN*model->PAIGBACC));
AIGBACC1_i=(((model->AIGBACC1+(Inv_L*model->LAIGBACC1))+(Inv_NFIN*model->NAIGBACC1))+(Inv_LNFIN*model->PAIGBACC1));
BIGBACC_i=(((model->BIGBACC+(Inv_L*model->LBIGBACC))+(Inv_NFIN*model->NBIGBACC))+(Inv_LNFIN*model->PBIGBACC));
CIGBACC_i=(((model->CIGBACC+(Inv_L*model->LCIGBACC))+(Inv_NFIN*model->NCIGBACC))+(Inv_LNFIN*model->PCIGBACC));
NIGBACC_i=(((model->NIGBACC+(Inv_L*model->LNIGBACC))+(Inv_NFIN*model->NNIGBACC))+(Inv_LNFIN*model->PNIGBACC));
AIGC_i=(((model->AIGC+(Inv_L*model->LAIGC))+(Inv_NFIN*model->NAIGC))+(Inv_LNFIN*model->PAIGC));
AIGC1_i=(((model->AIGC1+(Inv_L*model->LAIGC1))+(Inv_NFIN*model->NAIGC1))+(Inv_LNFIN*model->PAIGC1));
BIGC_i=(((model->BIGC+(Inv_L*model->LBIGC))+(Inv_NFIN*model->NBIGC))+(Inv_LNFIN*model->PBIGC));
CIGC_i=(((model->CIGC+(Inv_L*model->LCIGC))+(Inv_NFIN*model->NCIGC))+(Inv_LNFIN*model->PCIGC));
PIGCD_i=(((model->PIGCD+(Inv_L*model->LPIGCD))+(Inv_NFIN*model->NPIGCD))+(Inv_LNFIN*model->PPIGCD));
AIGS_i=(((model->AIGS+(Inv_L*model->LAIGS))+(Inv_NFIN*model->NAIGS))+(Inv_LNFIN*model->PAIGS));
AIGS1_i=(((model->AIGS1+(Inv_L*model->LAIGS1))+(Inv_NFIN*model->NAIGS1))+(Inv_LNFIN*model->PAIGS1));
BIGS_i=(((model->BIGS+(Inv_L*model->LBIGS))+(Inv_NFIN*model->NBIGS))+(Inv_LNFIN*model->PBIGS));
CIGS_i=(((model->CIGS+(Inv_L*model->LCIGS))+(Inv_NFIN*model->NCIGS))+(Inv_LNFIN*model->PCIGS));
AIGD_i=(((model->AIGD+(Inv_L*model->LAIGD))+(Inv_NFIN*model->NAIGD))+(Inv_LNFIN*model->PAIGD));
AIGD1_i=(((model->AIGD1+(Inv_L*model->LAIGD1))+(Inv_NFIN*model->NAIGD1))+(Inv_LNFIN*model->PAIGD1));
BIGD_i=(((model->BIGD+(Inv_L*model->LBIGD))+(Inv_NFIN*model->NBIGD))+(Inv_LNFIN*model->PBIGD));
CIGD_i=(((model->CIGD+(Inv_L*model->LCIGD))+(Inv_NFIN*model->NCIGD))+(Inv_LNFIN*model->PCIGD));
NTOX_i=(((model->NTOX+(Inv_L*model->LNTOX))+(Inv_NFIN*model->NNTOX))+(Inv_LNFIN*model->PNTOX));
POXEDGE_i=(((model->POXEDGE+(Inv_L*model->LPOXEDGE))+(Inv_NFIN*model->NPOXEDGE))+(Inv_LNFIN*model->PPOXEDGE));
AGIDL_i=(((model->AGIDL+(Inv_L*model->LAGIDL))+(Inv_NFIN*model->NAGIDL))+(Inv_LNFIN*model->PAGIDL));
BGIDL_i=(((model->BGIDL+(Inv_L*model->LBGIDL))+(Inv_NFIN*model->NBGIDL))+(Inv_LNFIN*model->PBGIDL));
CGIDL_i=(((model->CGIDL+(Inv_L*model->LCGIDL))+(Inv_NFIN*model->NCGIDL))+(Inv_LNFIN*model->PCGIDL));
EGIDL_i=(((model->EGIDL+(Inv_L*model->LEGIDL))+(Inv_NFIN*model->NEGIDL))+(Inv_LNFIN*model->PEGIDL));
PGIDL_i=(((model->PGIDL+(Inv_L*model->LPGIDL))+(Inv_NFIN*model->NPGIDL))+(Inv_LNFIN*model->PPGIDL));
AGISL_i=(((model->AGISL+(Inv_L*model->LAGISL))+(Inv_NFIN*model->NAGISL))+(Inv_LNFIN*model->PAGISL));
BGISL_i=(((model->BGISL+(Inv_L*model->LBGISL))+(Inv_NFIN*model->NBGISL))+(Inv_LNFIN*model->PBGISL));
CGISL_i=(((model->CGISL+(Inv_L*model->LCGISL))+(Inv_NFIN*model->NCGISL))+(Inv_LNFIN*model->PCGISL));
EGISL_i=(((model->EGISL+(Inv_L*model->LEGISL))+(Inv_NFIN*model->NEGISL))+(Inv_LNFIN*model->PEGISL));
PGISL_i=(((model->PGISL+(Inv_L*model->LPGISL))+(Inv_NFIN*model->NPGISL))+(Inv_LNFIN*model->PPGISL));
ALPHA0_i=(((model->ALPHA0+(Inv_L*model->LALPHA0))+(Inv_NFIN*model->NALPHA0))+(Inv_LNFIN*model->PALPHA0));
ALPHA1_i=(((model->ALPHA1+(Inv_L*model->LALPHA1))+(Inv_NFIN*model->NALPHA1))+(Inv_LNFIN*model->PALPHA1));
ALPHAII0_i=(((model->ALPHAII0+(Inv_L*model->LALPHAII0))+(Inv_NFIN*model->NALPHAII0))+(Inv_LNFIN*model->PALPHAII0));
ALPHAII1_i=(((model->ALPHAII1+(Inv_L*model->LALPHAII1))+(Inv_NFIN*model->NALPHAII1))+(Inv_LNFIN*model->PALPHAII1));
BETA0_i=(((model->BETA0+(Inv_L*model->LBETA0))+(Inv_NFIN*model->NBETA0))+(Inv_LNFIN*model->PBETA0));
BETAII0_i=(((model->BETAII0+(Inv_L*model->LBETAII0))+(Inv_NFIN*model->NBETAII0))+(Inv_LNFIN*model->PBETAII0));
BETAII1_i=(((model->BETAII1+(Inv_L*model->LBETAII1))+(Inv_NFIN*model->NBETAII1))+(Inv_LNFIN*model->PBETAII1));
BETAII2_i=(((model->BETAII2+(Inv_L*model->LBETAII2))+(Inv_NFIN*model->NBETAII2))+(Inv_LNFIN*model->PBETAII2));
ESATII_i=(((model->ESATII+(Inv_L*model->LESATII))+(Inv_NFIN*model->NESATII))+(Inv_LNFIN*model->PESATII));
LII_i=(((model->LII+(Inv_L*model->LLII))+(Inv_NFIN*model->NLII))+(Inv_LNFIN*model->PLII));
SII0_i=(((model->SII0+(Inv_L*model->LSII0))+(Inv_NFIN*model->NSII0))+(Inv_LNFIN*model->PSII0));
SII1_i=(((model->SII1+(Inv_L*model->LSII1))+(Inv_NFIN*model->NSII1))+(Inv_LNFIN*model->PSII1));
SII2_i=(((model->SII2+(Inv_L*model->LSII2))+(Inv_NFIN*model->NSII2))+(Inv_LNFIN*model->PSII2));
SIID_i=(((model->SIID+(Inv_L*model->LSIID))+(Inv_NFIN*model->NSIID))+(Inv_LNFIN*model->PSIID));
TII_i=(((model->TII+(Inv_L*model->LTII))+(Inv_NFIN*model->NTII))+(Inv_LNFIN*model->PTII));
CFS_i=(((model->CFS+(Inv_L*model->LCFS))+(Inv_NFIN*model->NCFS))+(Inv_LNFIN*model->PCFS));
CFD_i=(((model->CFD+(Inv_L*model->LCFD))+(Inv_NFIN*model->NCFD))+(Inv_LNFIN*model->PCFD));
CGSL_i=(((model->CGSL+(Inv_L*model->LCGSL))+(Inv_NFIN*model->NCGSL))+(Inv_LNFIN*model->PCGSL));
CGDL_i=(((model->CGDL+(Inv_L*model->LCGDL))+(Inv_NFIN*model->NCGDL))+(Inv_LNFIN*model->PCGDL));
CGBL_i=(((model->CGBL+(Inv_L*model->LCGBL))+(Inv_NFIN*model->NCGBL))+(Inv_LNFIN*model->PCGBL));
CKAPPAS_i=(((model->CKAPPAS+(Inv_L*model->LCKAPPAS))+(Inv_NFIN*model->NCKAPPAS))+(Inv_LNFIN*model->PCKAPPAS));
CKAPPAD_i=(((model->CKAPPAD+(Inv_L*model->LCKAPPAD))+(Inv_NFIN*model->NCKAPPAD))+(Inv_LNFIN*model->PCKAPPAD));
CKAPPAB_i=(((model->CKAPPAB+(Inv_L*model->LCKAPPAB))+(Inv_NFIN*model->NCKAPPAB))+(Inv_LNFIN*model->PCKAPPAB));
NTGEN_i=(((model->NTGEN+(Inv_L*model->LNTGEN))+(Inv_NFIN*model->NNTGEN))+(Inv_LNFIN*model->PNTGEN));
AIGEN_i=(((model->AIGEN+(Inv_L*model->LAIGEN))+(Inv_NFIN*model->NAIGEN))+(Inv_LNFIN*model->PAIGEN));
BIGEN_i=(((model->BIGEN+(Inv_L*model->LBIGEN))+(Inv_NFIN*model->NBIGEN))+(Inv_LNFIN*model->PBIGEN));
if
((model->ASYMMOD!=0))
{
CDSCDR_i=(((model->CDSCDR+(Inv_L*model->LCDSCDR))+(Inv_NFIN*model->NCDSCDR))+(Inv_LNFIN*model->PCDSCDR));
CITR_i=(((model->CITR+(Inv_L*model->LCITR))+(Inv_NFIN*model->NCITR))+(Inv_LNFIN*model->PCITR));
ETA0R_i=(((model->ETA0R+(Inv_L*model->LETA0R))+(Inv_NFIN*model->NETA0R))+(Inv_LNFIN*model->PETA0R));
VSAT1R_i=(((model->VSAT1R+(Inv_L*model->LVSAT1R))+(Inv_NFIN*model->NVSAT1R))+(Inv_LNFIN*model->PVSAT1R));
MEXPR_i=(((model->MEXPR+(Inv_L*model->LMEXPR))+(Inv_NFIN*model->NMEXPR))+(Inv_LNFIN*model->PMEXPR));
PTWGR_i=(((model->PTWGR+(Inv_L*model->LPTWGR))+(Inv_NFIN*model->NPTWGR))+(Inv_LNFIN*model->PPTWGR));
PDIBL1R_i=(((model->PDIBL1R+(Inv_L*model->LPDIBL1R))+(Inv_NFIN*model->NPDIBL1R))+(Inv_LNFIN*model->PPDIBL1R));
PDIBL2R_i=(((model->PDIBL2R+(Inv_L*model->LPDIBL2R))+(Inv_NFIN*model->NPDIBL2R))+(Inv_LNFIN*model->PPDIBL2R));
PCLMR_i=(((model->PCLMR+(Inv_L*model->LPCLMR))+(Inv_NFIN*model->NPCLMR))+(Inv_LNFIN*model->PPCLMR));
DVTSHIFTR_i=(((model->DVTSHIFTR+(Inv_L*model->LDVTSHIFTR))+(Inv_NFIN*model->NDVTSHIFTR))+(Inv_LNFIN*model->PDVTSHIFTR));
VSATR_i=(((model->VSATR+(Inv_L*model->LVSATR))+(Inv_NFIN*model->NVSATR))+(Inv_LNFIN*model->PVSATR));
KSATIVR_i=(((model->KSATIVR+(Inv_L*model->LKSATIVR))+(Inv_NFIN*model->NKSATIVR))+(Inv_LNFIN*model->PKSATIVR));
U0R_i=(((model->U0R+(Inv_L*model->LU0R))+(Inv_NFIN*model->NU0R))+(Inv_LNFIN*model->PU0R));
UAR_i=(((model->UAR+(Inv_L*model->LUAR))+(Inv_NFIN*model->NUAR))+(Inv_LNFIN*model->PUAR));
UPR_i=(((model->UPR+(Inv_L*model->LUPR))+(Inv_NFIN*model->NUPR))+(Inv_LNFIN*model->PUPR));
if
((model->BULKMOD!=0))
{
UCR_i=(((model->UCR+(Inv_L*model->LUCR))+(Inv_NFIN*model->NUCR))+(Inv_LNFIN*model->PUCR));
}
EUR_i=(((model->EUR+(Inv_L*model->LEUR))+(Inv_NFIN*model->NEUR))+(Inv_LNFIN*model->PEUR));
UDR_i=(((model->UDR+(Inv_L*model->LUDR))+(Inv_NFIN*model->NUDR))+(Inv_LNFIN*model->PUDR));
}
if
((model->NQSMOD==1))
{
}
if
((model->NQSMOD==2))
{
}
UTE_i=(((model->UTE+(Inv_L*model->LUTE))+(Inv_NFIN*model->NUTE))+(Inv_LNFIN*model->PUTE));
UTL_i=(((model->UTL+(Inv_L*model->LUTL))+(Inv_NFIN*model->NUTL))+(Inv_LNFIN*model->PUTL));
EMOBT_i=(((model->EMOBT+(Inv_L*model->LEMOBT))+(Inv_NFIN*model->NEMOBT))+(Inv_LNFIN*model->PEMOBT));
UA1_i=(((model->UA1+(Inv_L*model->LUA1))+(Inv_NFIN*model->NUA1))+(Inv_LNFIN*model->PUA1));
if
((model->BULKMOD!=0))
{
UC1_i=(((model->UC1+(Inv_L*model->LUC1))+(Inv_NFIN*model->NUC1))+(Inv_LNFIN*model->PUC1));
}
UD1_i=(((model->UD1+(Inv_L*model->LUD1))+(Inv_NFIN*model->NUD1))+(Inv_LNFIN*model->PUD1));
UCSTE_i=(((model->UCSTE+(Inv_L*model->LUCSTE))+(Inv_NFIN*model->NUCSTE))+(Inv_LNFIN*model->PUCSTE));
PTWGT_i=(((model->PTWGT+(Inv_L*model->LPTWGT))+(Inv_NFIN*model->NPTWGT))+(Inv_LNFIN*model->PPTWGT));
AT_i=(((model->AT+(Inv_L*model->LAT))+(Inv_NFIN*model->NAT))+(Inv_LNFIN*model->PAT));
ATCV_i=(((model->ATCV+(Inv_L*model->LATCV))+(Inv_NFIN*model->NATCV))+(Inv_LNFIN*model->PATCV));
PRT_i=(((model->PRT+(Inv_L*model->LPRT))+(Inv_NFIN*model->NPRT))+(Inv_LNFIN*model->PPRT));
KT1_i=(((model->KT1+(Inv_L*model->LKT1))+(Inv_NFIN*model->NKT1))+(Inv_LNFIN*model->PKT1));
TSS_i=(((model->TSS+(Inv_L*model->LTSS))+(Inv_NFIN*model->NTSS))+(Inv_LNFIN*model->PTSS));
IIT_i=(((model->IIT+(Inv_L*model->LIIT))+(Inv_NFIN*model->NIIT))+(Inv_LNFIN*model->PIIT));
TGIDL_i=(((model->TGIDL+(Inv_L*model->LTGIDL))+(Inv_NFIN*model->NTGIDL))+(Inv_LNFIN*model->PTGIDL));
IGT_i=(((model->IGT+(Inv_L*model->LIGT))+(Inv_NFIN*model->NIGT))+(Inv_LNFIN*model->PIGT));
if
((model->ASYMMOD!=0))
{
UTER_i=(((model->UTER+(Inv_L*model->LUTER))+(Inv_NFIN*model->NUTER))+(Inv_LNFIN*model->PUTER));
UTLR_i=(((model->UTLR+(Inv_L*model->LUTLR))+(Inv_NFIN*model->NUTLR))+(Inv_LNFIN*model->PUTLR));
UA1R_i=(((model->UA1R+(Inv_L*model->LUA1R))+(Inv_NFIN*model->NUA1R))+(Inv_LNFIN*model->PUA1R));
UD1R_i=(((model->UD1R+(Inv_L*model->LUD1R))+(Inv_NFIN*model->NUD1R))+(Inv_LNFIN*model->PUD1R));
ATR_i=(((model->ATR+(Inv_L*model->LATR))+(Inv_NFIN*model->NATR))+(Inv_LNFIN*model->PATR));
if
((model->BULKMOD!=0))
{
UC1R_i=(((model->UC1R+(Inv_L*model->LUC1R))+(Inv_NFIN*model->NUC1R))+(Inv_LNFIN*model->PUC1R));
}
}
if
((model->PHIGN1!=0.0))
{
PHIG_i=(PHIG_i*(1.0+((model->PHIGN1/here->NFIN)*bsimcmg_lln((1.0+(here->NFIN/model->PHIGN2))))));
}
if
((model->ETA0N1!=0.0))
{
ETA0_i=(ETA0_i*(1.0+((model->ETA0N1/here->NFIN)*bsimcmg_lln((1.0+(here->NFIN/model->ETA0N2))))));
}
if
((model->CDSCN1!=0.0))
{
CDSC_i=(CDSC_i*(1.0+((model->CDSCN1/here->NFIN)*bsimcmg_lln((1.0+(here->NFIN/model->CDSCN2))))));
}
if
((model->CDSCDN1!=0.0))
{
CDSCD_i=(CDSCD_i*(1.0+((model->CDSCDN1/here->NFIN)*bsimcmg_lln((1.0+(here->NFIN/model->CDSCDN2))))));
}
if
((model->CDSCDRN1!=0.0))
{
CDSCDR_i=(CDSCDR_i*(1.0+((model->CDSCDRN1/here->NFIN)*bsimcmg_lln((1.0+(here->NFIN/model->CDSCDRN2))))));
}
if
((model->VSATN1!=0.0))
{
VSAT_i=(VSAT_i*(1.0+((model->VSATN1/here->NFIN)*bsimcmg_lln((1.0+(here->NFIN/model->VSATN2))))));
}
if
((model->VSAT1N1!=0.0))
{
VSAT1_i=(VSAT1_i*(1.0+((model->VSAT1N1/here->NFIN)*bsimcmg_lln((1.0+(here->NFIN/model->VSAT1N2))))));
}
if
((model->VSAT1RN1!=0.0))
{
VSAT1R_i=(VSAT1R_i*(1.0+((model->VSAT1RN1/here->NFIN)*bsimcmg_lln((1.0+(here->NFIN/model->VSAT1RN2))))));
}
if
((model->U0N1!=0.0))
{
U0_i=(U0_i*(1.0+((model->U0N1/here->NFIN)*bsimcmg_lln((1.0+(here->NFIN/model->U0N2))))));
}
if
(here->NFINNOM_Given)
{
PHIG_i=(PHIG_i*(1.0+(((here->NFIN-here->NFINNOM)*model->PHIGLT)*Leff)));
ETA0_i=(ETA0_i*(1.0+(((here->NFIN-here->NFINNOM)*model->ETA0LT)*Leff)));
U0_i=(U0_i*(1.0+(((here->NFIN-here->NFINNOM)*model->U0LT)*Leff)));
}
if
((model->U0N1R!=0.0))
{
U0R_i=(U0R_i*(1.0+((model->U0N1R/here->NFIN)*bsimcmg_lln((1.0+(here->NFIN/model->U0N2R))))));
}
PHIG_i=(PHIG_i+(model->PHIGL*Leff));
if
((model->LPA>0.0))
{
U0_i=(U0_i*(1.0-(UP_i*pow(Leff,(-model->LPA)))));
}
else
{
U0_i=(U0_i*(1.0-UP_i));
}
UA_i=(UA_i+(model->AUA*bsimcmg_lexp(((-Leff)/model->BUA))));
UD_i=(UD_i+(model->AUD*bsimcmg_lexp(((-Leff)/model->BUD))));
EU_i=(EU_i+(model->AEU*bsimcmg_lexp(((-Leff)/model->BEU))));
if
((model->ASYMMOD!=0))
{
if
((model->LPAR>0.0))
{
U0R_i=(U0R_i*(1.0-(UPR_i*pow(Leff,(-model->LPAR)))));
}
else
{
U0R_i=(U0R_i*(1.0-UPR_i));
}
UAR_i=(UAR_i+(model->AUAR*bsimcmg_lexp(((-Leff)/model->BUAR))));
UDR_i=(UDR_i+(model->AUDR*bsimcmg_lexp(((-Leff)/model->BUDR))));
EUR_i=(EUR_i+(model->AEUR*bsimcmg_lexp(((-Leff)/model->BEUR))));
}
if
((model->RDSMOD==1))
{
RSW_i=(RSW_i+(model->ARSW*bsimcmg_lexp(((-Leff)/model->BRSW))));
RDW_i=(RDW_i+(model->ARDW*bsimcmg_lexp(((-Leff)/model->BRDW))));
}
else
{
RDSW_i=(RDSW_i+(model->ARDSW*bsimcmg_lexp(((-Leff)/model->BRDSW))));
}
PCLM_i=(PCLM_i+(model->APCLM*bsimcmg_lexp(((-Leff)/model->BPCLM))));
if
((model->ASYMMOD!=0))
{
PCLMR_i=(PCLMR_i+(model->APCLMR*pow(Leff,(-model->BPCLMR))));
}
MEXP_i=(MEXP_i+(model->AMEXP*pow(Leff,(-model->BMEXP))));
if
((model->ASYMMOD!=0))
{
MEXPR_i=(MEXPR_i+(model->AMEXPR*pow(Leff,(-model->BMEXPR))));
}
PTWG_i=(PTWG_i+(model->APTWG*bsimcmg_lexp(((-Leff)/model->BPTWG))));
if
((model->ASYMMOD!=0))
{
PTWGR_i=(PTWGR_i+(model->APTWG*bsimcmg_lexp(((-Leff)/model->BPTWG))));
}
VSAT_i=(VSAT_i+(model->AVSAT*bsimcmg_lexp(((-Leff)/model->BVSAT))));
VSAT1_i=(VSAT1_i+(model->AVSAT1*bsimcmg_lexp(((-Leff)/model->BVSAT1))));
if
((model->ASYMMOD!=0))
{
VSAT1R_i=(VSAT1R_i+(model->AVSAT1*bsimcmg_lexp(((-Leff)/model->BVSAT1))));
}
PSAT_i=(PSAT_i+(model->APSAT*bsimcmg_lexp(((-Leff)/model->BPSAT))));
PSATCV_i=(PSATCV_i+(model->APSATCV*bsimcmg_lexp(((-Leff)/model->BPSATCV))));
VSATCV_i=(VSATCV_i+(model->AVSATCV*bsimcmg_lexp(((-LeffCV)/model->BVSATCV))));
DVTP0_i=(model->DVTP0+(model->ADVTP0*bsimcmg_lexp(((-Leff)/model->BDVTP0))));
DVTP1_i=(model->DVTP1+(model->ADVTP1*bsimcmg_lexp(((-Leff)/model->BDVTP1))));
if
(((QMTCENCV_i>0.0)||(QMTCENCVA_i>0.0)))
{
MTcen=(1.0+(model->AQMTCEN*bsimcmg_lexp(((-((2.0*Ach)/Weff_UFCM))/model->BQMTCEN))));
Tcen0=(((2.0*Ach)/Weff_UFCM)*MTcen);
}
if
((LeffCV<=1.0e-9))
{
}
if
((model->BULKMOD!=0))
{
if
((LeffCV_acc<=1.0e-9))
{
}
}
if
((Weff0<=1.0e-9))
{
}
if
((WeffCV0<=1.0e-9))
{
}
if
((NBODY_i<=0.0))
{
}
else
{
if
((NBODY_i<=1.0e18))
{
}
}
if
((NGATE_i<0.0))
{
}
else
{
if
(((NGATE_i!=0.0)&&(NGATE_i<=1.0e24)))
{
}
else
{
if
((NGATE_i>1.0e31))
{
}
}
}
if
((DVT0_i<0.0))
{
}
if
((PHIG_i<=0.0))
{
}
if
((VSAT_i<=0.0))
{
}
if
((VSAT1_i<=0.0))
{
}
if
(((model->ASYMMOD!=0)&&(VSAT1R_i<=0.0)))
{
}
if
((DVT1_i<=0.0))
{
}
if
((DVT1SS_i<=0.0))
{
}
if
((CDSC_i<0.0))
{
}
if
((CDSCD_i<0.0))
{
}
if
(((model->ASYMMOD!=0)&&(CDSCDR_i<0.0)))
{
}
if
((DSUB_i<=0.0))
{
}
if
((ETA0_i<0.0))
{
ETA0_i=0.0;
}
if
((ETA0R_i<0.0))
{
ETA0R_i=0.0;
}
if
((LPE0_i<(-Leff)))
{
LPE0_i=0.0;
}
if
((K0SI_i<=0.0))
{
K0SI_i=0.0;
}
if
((K2SI_i<=0.0))
{
K2SI_i=0.0;
}
if
(((PHIBE_i<0.2)&&(model->BULKMOD!=0)))
{
PHIBE_i=0.2;
}
if
(((PHIBE_i>1.2)&&(model->BULKMOD!=0)))
{
PHIBE_i=1.2;
}
if
((PSAT_i<2.0))
{
PSAT_i=2.0;
}
if
((PSATCV_i<2.0))
{
PSATCV_i=2.0;
}
if
((U0_i<0.0))
{
U0_i=0.03;
}
if
((UA_i<0.0))
{
UA_i=0.0;
}
if
((EU_i<0.0))
{
EU_i=0.0;
}
if
((UD_i<0.0))
{
UD_i=0.0;
}
if
((UCS_i<0.0))
{
UCS_i=0.0;
}
if
((ETAMOB_i<0.0))
{
ETAMOB_i=0.0;
}
RDSWMIN_i=model->RDSWMIN;
if
((RDSWMIN_i<0.0))
{
RDSWMIN_i=0.0;
}
if
((RDSW_i<0.0))
{
RDSW_i=0.0;
}
RSWMIN_i=model->RSWMIN;
if
((RSWMIN_i<0.0))
{
RSWMIN_i=0.0;
}
if
((RSW_i<0.0))
{
RSW_i=0.0;
}
RDWMIN_i=model->RDWMIN;
if
((RDWMIN_i<0.0))
{
RDWMIN_i=0.0;
}
if
((RDW_i<0))
{
RDW_i=0.0;
}
if
((PRWGD_i<0.0))
{
PRWGD_i=0.0;
}
if
((PRWGS_i<0.0))
{
PRWGS_i=0.0;
}
if
((PCLM_i<0))
{
}
if
((PDIBL1_i<0.0))
{
}
if
((model->ASYMMOD!=0))
{
if
((PDIBL1R_i<0.0))
{
}
if
((PDIBL2R_i<0.0))
{
}
if
((U0R_i<0))
{
U0R_i=0.0;
}
if
((UAR_i<0.0))
{
UAR_i=0.0;
}
if
((EUR_i<0.0))
{
EUR_i=0.0;
}
if
((UDR_i<0.0))
{
UDR_i=0.0;
}
}
if
((PDIBL2_i<0.0))
{
}
if
((DROUT_i<=0.0))
{
}
if
((MEXP_i<2.0))
{
MEXP_i=2.0;
}
if
((model->ASYMMOD!=0))
{
if
((MEXPR_i<2.0))
{
MEXPR_i=2.0;
}
}
if
((PTWG_i<0))
{
PTWG_i=0.0;
}
if
((QMTCENCV_i>0.0))
{
if
((model->QM0<=0.0))
{
}
}
if
(((model->BULKMOD!=0)&&(QMTCENCVA_i>0.0)))
{
if
((model->QM0ACC<=0.0))
{
}
}
if
((CGIDL_i<0.0))
{
CGIDL_i=0.0;
}
if
((CGISL_i<0.0))
{
CGISL_i=0.0;
}
if
((model->IGBMOD!=0))
{
if
((NIGBINV_i<=0.0))
{
}
if
((NIGBACC_i<=0.0))
{
}
}
if
((model->IGCMOD!=0))
{
if
((POXEDGE_i<=0.0))
{
}
if
((PIGCD_i<=0.0))
{
}
}
if
(((model->IGCMOD!=0)||(model->IGBMOD!=0)))
{
if
((model->TOXREF<=0))
{
}
}
if
((model->LINTIGEN>=(Leff/2.0)))
{
LINTIGEN_i=0.0;
}
else
{
LINTIGEN_i=model->LINTIGEN;
}
if
((NTGEN_i<=0.0))
{
}
if
((model->IIMOD==2))
{
if
((BETAII0_i<0.0))
{
}
if
((BETAII1_i<0.0))
{
}
if
((BETAII2_i<0.0))
{
}
if
((ESATII_i<0.0))
{
}
if
((LII_i<0.0))
{
}
if
((SII1_i<0.0))
{
}
if
((SII2_i<0.0))
{
}
if
((SIID_i<0.0))
{
}
}
if
((model->EF<=0.0))
{
}
else
{
if
((model->EF>2.0))
{
}
}
if
((model->LINTNOI>=(Leff/2.0)))
{
LINTNOI_i=0.0;
}
else
{
LINTNOI_i=model->LINTNOI;
}
if
((model->NTNOI<0))
{
NTNOI_i=0.0;
}
else
{
NTNOI_i=model->NTNOI;
}
if
(((model->SHMOD!=0)&&(model->RTH0>0.0)))
{
T1y=model->WTH0;
if
((model->BSHEXP!=0.0))
{
T1y=(model->WTH0*pow(here->NF,model->BSHEXP));
}
T2y=here->FPITCH;
if
((model->ASHEXP!=0.0))
{
T2y=(here->FPITCH*pow(NFINtotal,model->ASHEXP));
}
gth=((T1y+T2y)/model->RTH0);
cth=(model->CTH0*(T1y+T2y));
}
else
{
gth=1.0;
cth=0.0;
}
if
((model->RGATEMOD!=0))
{
Rgeltd=(((model->RGEXT/here->NGCON)+((model->RGFIN*here->NFIN)/((here->NGCON==2)?12.0:3.0)))/here->NF);
ggeltd=(1.0/max(1.0e-3,Rgeltd));
}
if
((model->RGEOMOD==0))
{
RSourceGeo=(model->RSHS*here->NRS);
RDrainGeo=(model->RSHD*here->NRD);
}
else
{
if
((model->HEPI>0.0))
{
Arsd=((here->FPITCH*model->HFIN)+((here->TFIN+((here->FPITCH-here->TFIN)*model->CRATIO))*model->HEPI));
}
else
{
Arsd=(here->FPITCH*max(1.0e-9,(model->HFIN+model->HEPI)));
}
Prsd=(here->FPITCH+model->DELTAPRSD);
if
(model->RHORSD_Given)
{
rhorsd=model->RHORSD;
}
else
{
mu_max=((model->TYPE==1)?1417.0:470.5);
if
((model->TYPE==1))
{
mu_rsd=(((52.2+((mu_max-52.2)/(1.0+pow((model->NSD/9.68e22),0.680))))-(43.4/(1.0+pow((3.43e26/model->NSD),2.0))))*1.0e-4);
}
else
{
mu_rsd=(((44.9+((mu_max-44.9)/(1.0+pow((model->NSD/2.23e22),0.719))))-(29.0/(1.0+pow((6.10e26/model->NSD),2.0))))*1.0e-4);
}
rhorsd=(1.0/((1.60219e-19*model->NSD)*mu_rsd));
}
thetarsp=((55.0*3.14159265358979323846)/180.0);
afin=min(Arsd,max(1.0e-18,(here->TFIN*(model->HFIN+min(0.0,model->HEPI)))));
T1y=((thetarsp>=(3.14159265358979323846/2))?0:((thetarsp<=((-3.14159265358979323846)/2))?0:(1.0/tan(thetarsp))));
Rsp=(((rhorsd*T1y)/(sqrt(3.14159265358979323846)*here->NFIN))*(((1.0/sqrt(afin))-(2.0/sqrt(Arsd)))+sqrt((afin/(Arsd*Arsd)))));
arsd_total=((Arsd*here->NFIN)+model->ARSDEND);
prsd_total=((Prsd*here->NFIN)+model->PRSDEND);
lt=sqrt(((model->RHOC*arsd_total)/(rhorsd*prsd_total)));
alpha=(here->LRSD/lt);
T0y=bsimcmg_lexp((alpha+alpha));
if
((model->SDTERM==1.0))
{
eta=((rhorsd*lt)/model->RHOC);
T1y=(T0y*(1.0+eta));
T2y=((T1y+1.0)-eta);
T3y=((T1y-1.0)+eta);
}
else
{
T2y=(T0y+1.0);
T3y=(T0y-1.0);
}
RrsdTML=(((rhorsd*lt)*T2y)/(arsd_total*T3y));
if
((model->HEPI<(-1.0e-10)))
{
Rrsdside=(model->RHOC/(((-model->HEPI)*here->TFIN)*here->NFIN));
Rrsd=(((RrsdTML+Rsp)*Rrsdside)/((RrsdTML+Rsp)+Rrsdside));
}
else
{
Rrsd=(RrsdTML+Rsp);
}
Rdsgeo=((Rrsd/here->NF)*max(0.0,((((model->RGEOA+(model->RGEOB*here->TFIN))+(model->RGEOC*here->FPITCH))+(model->RGEOD*here->LRSD))+(model->RGEOE*model->HEPI))));
RSourceGeo=Rdsgeo;
RDrainGeo=Rdsgeo;
}
if
((RSourceGeo<=1.0e-3))
{
RSourceGeo=1.0e-3;
}
if
((RDrainGeo<=1.0e-3))
{
RDrainGeo=1.0e-3;
}
if
((model->RDSMOD==1))
{
if
((RSWMIN_i<=0.0))
{
RSWMIN_i=0.0;
}
if
((RDWMIN_i<=0.0))
{
RDWMIN_i=0.0;
}
if
((RSW_i<=0.0))
{
RSW_i=0.0;
}
if
((RDW_i<=0.0))
{
RDW_i=0.0;
}
}
else
{
if
((RDSWMIN_i<=0.0))
{
RDSWMIN_i=0.0;
}
if
((RDSW_i<=0.0))
{
RDSW_i=0.0;
}
}
if
((model->CGEOMOD!=1))
{
if
(model->CGSO_Given)
{
CGSO_i=model->CGSO;
}
else
{
if
((model->DLC_Given&&(model->DLC>0.0)))
{
CGSO_i=max(0.0,((model->DLC*cox)-CGSL_i));
}
else
{
CGSO_i=((0.3*here->TFIN)*cox);
}
}
if
(model->CGDO_Given)
{
CGDO_i=model->CGDO;
}
else
{
if
((model->DLC_Given&&(model->DLC>0.0)))
{
CGDO_i=max(0.0,((model->DLC*cox)-CGDL_i));
}
else
{
CGDO_i=((0.3*here->TFIN)*cox);
}
}
}
if
((model->CGEOMOD==2))
{
if
(model->LSP_Given)
{
LSP_i=model->LSP;
}
else
{
LSP_i=(0.2*(here->L+model->XL));
}
Hg=(model->TGATE+model->TMASK);
Trsd=(0.5*(here->FPITCH-here->TFIN));
Wg=max(0.0,(Trsd-model->TOXP));
Hrsd=max(0.0,(model->HEPI+model->TSILI));
if
((model->TMASK>0.0))
{
T0y=(3.467e-11*bsimcmg_lln(((1.0e-7*model->EPSRSP)/(3.9*LSP_i))));
T1y=(((0.942*Hrsd)*epssp)/LSP_i);
Cgg_top=((T0y+T1y)*(here->TFIN+((here->FPITCH-here->TFIN)*model->CRATIO)));
}
else
{
x42_Hr=(2.3+((0.2*(Hg+model->TOXP))/Hrsd));
x42_Lr=1.05;
x42_Hgdelta=fabs(((Hg+model->TOXP)-Hrsd));
x42_Lmax=(LSP_i*x42_Lr);
x42_y=min(Hrsd,(Hg+model->TOXP));
x42_x=(LSP_i/(x42_Hr+1.0));
x42_Cnon=1.7e12;
x42_CcgSat=((epssp*(x42_y-x42_x))/LSP_i);
x42_TT1=(x42_Cnon*x42_CcgSat);
if
((x42_TT1>80.0))
{
x42_Ccg1=x42_CcgSat;
}
else
{
x42_Ccg1=((1.0/x42_Cnon)*log((1.0+bsimcmg_lexp(x42_TT1))));
}
x42_r1cf=(0.5*min((Hrsd/(Hg+model->TOXP)),((Hg+model->TOXP)/Hrsd)));
x42_Rcf=(x42_Hgdelta*x42_r1cf);
x42_Ccg2=(((epssp*2)/3.14159265358979323846)*log(((LSP_i+((0.5*3.14159265358979323846)*x42_Rcf))/LSP_i)));
x42_Ccg=(here->TFIN*(x42_Ccg1+x42_Ccg2));
x42_x=(x42_Lmax/Hg);
x42_C1=(4.0/(sqrt((2.0*(x42_x+1)))*3.14159265358979323846));
x42_C2=((((sqrt((((model->TOXP*model->TOXP)+((2.0*Hg)*model->TOXP))+((Hg*Hg)*(x42_x+1))))*sqrt((x42_x+1)))+model->TOXP)+(Hg*x42_x))+Hg);
x42_C3=((model->TOXP*sqrt(((x42_x+1)*(x42_x+4))))+(model->TOXP*(x42_x+2)));
x42_Cfglog=(epssp*((x42_C1*log((x42_C2/x42_C3)))+12.27));
x42_dcf=(x42_Hr*x42_Lr);
x42_TT0=sqrt(((x42_dcf*x42_dcf)+1.0));
x42_TT1=(((sqrt((((x42_dcf*x42_dcf)+1)*((((x42_dcf*model->TOXP)*(x42_dcf*model->TOXP))+(((2*x42_dcf)*x42_Lmax)*model->TOXP))+((((x42_dcf*x42_dcf)+1)*x42_Lmax)*x42_Lmax))))+(x42_dcf*model->TOXP))+((x42_dcf*x42_dcf)*x42_Lmax))+x42_Lmax);
x42_TT2=((x42_TT0+1.0)*(x42_dcf*model->TOXP));
x42_Cfgsat=(((((((2.0*epssp)*sqrt(2))/3.14159265358979323846)*0.85)*x42_dcf)/x42_TT0)*log((x42_TT1/x42_TT2)));
x42_delta=1.2e-12;
x42_TT1=((x42_Cfgsat-x42_Cfglog)-x42_delta);
Cfg=(here->TFIN*(x42_Cfgsat-(0.5*(x42_TT1+sqrt(((x42_TT1*x42_TT1)+((4*x42_delta)*x42_Cfgsat)))))));
Cgg_top=(x42_Ccg+Cfg);
}
if
((model->TMASK>0))
{
x42_Hr=(2.3+((0.2*(Wg+model->TOXP))/Trsd));
x42_Lr=1.05;
x42_Hgdelta=fabs(((Wg+model->TOXP)-Trsd));
x42_Lmax=(LSP_i*x42_Lr);
x42_y=min(Trsd,(Wg+model->TOXP));
x42_x=(LSP_i/(x42_Hr+1.0));
x42_Cnon=1.7e12;
x42_CcgSat=((epssp*(x42_y-x42_x))/LSP_i);
x42_TT1=(x42_Cnon*x42_CcgSat);
if
((x42_TT1>80.0))
{
x42_Ccg1=x42_CcgSat;
}
else
{
x42_Ccg1=((1.0/x42_Cnon)*log((1.0+bsimcmg_lexp(x42_TT1))));
}
x42_r1cf=(0.5*min((Trsd/(Wg+model->TOXP)),((Wg+model->TOXP)/Trsd)));
x42_Rcf=(x42_Hgdelta*x42_r1cf);
x42_Ccg2=(((epssp*2)/3.14159265358979323846)*log(((LSP_i+((0.5*3.14159265358979323846)*x42_Rcf))/LSP_i)));
x42_Ccg=(model->HFIN*(x42_Ccg1+x42_Ccg2));
x42_x=(x42_Lmax/Wg);
x42_C1=(4.0/(sqrt((2.0*(x42_x+1)))*3.14159265358979323846));
x42_C2=((((sqrt((((model->TOXP*model->TOXP)+((2.0*Wg)*model->TOXP))+((Wg*Wg)*(x42_x+1))))*sqrt((x42_x+1)))+model->TOXP)+(Wg*x42_x))+Wg);
x42_C3=((model->TOXP*sqrt(((x42_x+1)*(x42_x+4))))+(model->TOXP*(x42_x+2)));
x42_Cfglog=(epssp*((x42_C1*log((x42_C2/x42_C3)))+12.27));
x42_dcf=(x42_Hr*x42_Lr);
x42_TT0=sqrt(((x42_dcf*x42_dcf)+1.0));
x42_TT1=(((sqrt((((x42_dcf*x42_dcf)+1)*((((x42_dcf*model->TOXP)*(x42_dcf*model->TOXP))+(((2*x42_dcf)*x42_Lmax)*model->TOXP))+((((x42_dcf*x42_dcf)+1)*x42_Lmax)*x42_Lmax))))+(x42_dcf*model->TOXP))+((x42_dcf*x42_dcf)*x42_Lmax))+x42_Lmax);
x42_TT2=((x42_TT0+1.0)*(x42_dcf*model->TOXP));
x42_Cfgsat=(((((((2.0*epssp)*sqrt(2))/3.14159265358979323846)*0.70)*x42_dcf)/x42_TT0)*log((x42_TT1/x42_TT2)));
x42_delta=1.2e-12;
x42_TT1=((x42_Cfgsat-x42_Cfglog)-x42_delta);
Cfg=(model->HFIN*(x42_Cfgsat-(0.5*(x42_TT1+sqrt(((x42_TT1*x42_TT1)+((4*x42_delta)*x42_Cfgsat)))))));
Cgg_side=(x42_Ccg+Cfg);
}
else
{
x42_Hr=(2.3+((0.2*(Wg+model->TOXP))/Trsd));
x42_Lr=1.05;
x42_Hgdelta=fabs(((Wg+model->TOXP)-Trsd));
x42_Lmax=(LSP_i*x42_Lr);
x42_y=min(Trsd,(Wg+model->TOXP));
x42_x=(LSP_i/(x42_Hr+1.0));
x42_Cnon=1.7e12;
x42_CcgSat=((epssp*(x42_y-x42_x))/LSP_i);
x42_TT1=(x42_Cnon*x42_CcgSat);
if
((x42_TT1>80.0))
{
x42_Ccg1=x42_CcgSat;
}
else
{
x42_Ccg1=((1.0/x42_Cnon)*log((1.0+bsimcmg_lexp(x42_TT1))));
}
x42_r1cf=(0.5*min((Trsd/(Wg+model->TOXP)),((Wg+model->TOXP)/Trsd)));
x42_Rcf=(x42_Hgdelta*x42_r1cf);
x42_Ccg2=(((epssp*2)/3.14159265358979323846)*log(((LSP_i+((0.5*3.14159265358979323846)*x42_Rcf))/LSP_i)));
x42_Ccg=(model->HFIN*(x42_Ccg1+x42_Ccg2));
x42_x=(x42_Lmax/Wg);
x42_C1=(4.0/(sqrt((2.0*(x42_x+1)))*3.14159265358979323846));
x42_C2=((((sqrt((((model->TOXP*model->TOXP)+((2.0*Wg)*model->TOXP))+((Wg*Wg)*(x42_x+1))))*sqrt((x42_x+1)))+model->TOXP)+(Wg*x42_x))+Wg);
x42_C3=((model->TOXP*sqrt(((x42_x+1)*(x42_x+4))))+(model->TOXP*(x42_x+2)));
x42_Cfglog=(epssp*((x42_C1*log((x42_C2/x42_C3)))+12.27));
x42_dcf=(x42_Hr*x42_Lr);
x42_TT0=sqrt(((x42_dcf*x42_dcf)+1.0));
x42_TT1=(((sqrt((((x42_dcf*x42_dcf)+1)*((((x42_dcf*model->TOXP)*(x42_dcf*model->TOXP))+(((2*x42_dcf)*x42_Lmax)*model->TOXP))+((((x42_dcf*x42_dcf)+1)*x42_Lmax)*x42_Lmax))))+(x42_dcf*model->TOXP))+((x42_dcf*x42_dcf)*x42_Lmax))+x42_Lmax);
x42_TT2=((x42_TT0+1.0)*(x42_dcf*model->TOXP));
x42_Cfgsat=(((((((2.0*epssp)*sqrt(2))/3.14159265358979323846)*0.85)*x42_dcf)/x42_TT0)*log((x42_TT1/x42_TT2)));
x42_delta=1.2e-12;
x42_TT1=((x42_Cfgsat-x42_Cfglog)-x42_delta);
Cfg=(model->HFIN*(x42_Cfgsat-(0.5*(x42_TT1+sqrt(((x42_TT1*x42_TT1)+((4*x42_delta)*x42_Cfgsat)))))));
Cgg_side=(x42_Ccg+Cfg);
}
if
((model->TMASK>0.0))
{
Acorner=0.0;
}
else
{
if
((model->HEPI>0.0))
{
Acorner=((here->FPITCH-here->TFIN)*((model->HEPI*model->CRATIO)+model->TSILI));
}
else
{
Acorner=((here->FPITCH-here->TFIN)*Hrsd);
}
}
Ccorner=(((((here->NFIN*Acorner)+model->ARSDEND)+model->ASILIEND)*epssp)/LSP_i);
Cfr_geo=(((Ccorner+(Cgg_top*here->NFIN))+(((model->CGEOE*Cgg_side)*here->NFIN)*2.0))*here->NF);
Cfr_geo=(Cfr_geo*max(0.0,(((model->CGEOA+(model->CGEOB*here->TFIN))+(model->CGEOC*here->FPITCH))+(model->CGEOD*here->LRSD))));
}
T0y=(model->CSDESW*bsimcmg_lln((1.0+(model->HFIN/model->EOTBOX))));
csbox=((cbox*here->ASEO)+(T0y*max(0.0,(here->PSEO-(here->FPITCH*NFINtotal)))));
cdbox=((cbox*here->ADEO)+(T0y*max(0.0,(here->PDEO-(here->FPITCH*NFINtotal)))));
cgbox=((((model->CGBO*here->NF)*here->NGCON)+(model->CGBN*NFINtotal))*Lg);
EeffFactor=(1.0e-8/(epsratio*model->EOT));
WeffWRFactor=(1.0/(pow((Weff0*1.0e6),WR_i)*NFINtotal));
litl=sqrt((((epsratio*model->EOT)*0.5)*here->TFIN));
if
((!model->THETASCE_Given))
{
tmp=(((DVT1_i*Leff)/scl)+1.0e-6);
if
((tmp<40.0))
{
Theta_SCE=(0.5/(cosh(tmp)-1.0));
}
else
{
Theta_SCE=exp((-tmp));
}
}
else
{
Theta_SCE=model->THETASCE;
}
if
((!model->THETASW_Given))
{
tmp=(((DVT1SS_i*Leff)/scl)+1.0e-6);
if
((tmp<40.0))
{
Theta_SW=(0.5/(cosh(tmp)-1.0));
}
else
{
Theta_SW=exp((-tmp));
}
}
else
{
Theta_SW=model->THETASW;
}
if
((!model->THETADIBL_Given))
{
tmp=(((DSUB_i*Leff)/scl)+1.0e-6);
if
((tmp<40.0))
{
Theta_DIBL=(0.5/(cosh(tmp)-1.0));
}
else
{
Theta_DIBL=exp((-tmp));
}
}
else
{
Theta_DIBL=model->THETADIBL;
}
Theta_RSCE=(sqrt((1.0+(LPE0_i/Leff)))-1.0);
tmp=(((DSUB_i*Leff)/scl)+1.0e-6);
if
((tmp<40.0))
{
T0y=(1.0/max((1.0+(model->DVTP2*(cosh(tmp)-2.0))),1.0e-6));
}
else
{
T0y=(exp((-tmp))/max((exp((-tmp))+model->DVTP2),1.0e-6));
}
Theta_DITS=T0y;
nbody=NBODY_i;
qbs=(((1.60219e-19*nbody)*Ach)/Cins);
if
((model->TYPE==1))
{
Aechvb=4.97232e-7;
Bechvb=7.45669e11;
}
else
{
Aechvb=3.42537e-7;
Bechvb=1.16645e12;
}
T0y=(model->TOXG*model->TOXG);
T1y=(model->TOXG*POXEDGE_i);
T2y=(T1y*T1y);
Toxratio=(bsimcmg_lexp((NTOX_i*bsimcmg_lln((model->TOXREF/model->TOXG))))/T0y);
Toxratioedge=(bsimcmg_lexp((NTOX_i*bsimcmg_lln((model->TOXREF/T1y))))/T2y);
igsd_mult0=((Weff0*Aechvb)*Toxratioedge);
if
((model->TNOM<(-273.15)))
{
Tnom=300.15;
}
else
{
Tnom=(model->TNOM+273.15);
}
if
(((model->SHMOD!=0)&&(model->RTH0>0.0)))
{
}
else
{
}
Vtm0=(8.617087e-5*Tnom);
Eg0=(model->BG0SUB-(((model->TBGASUB*Tnom)*Tnom)/(Tnom+model->TBGBSUB)));
T0y=((1.05457e-34*3.14159265358979323846)/((2*Ach)/Weff_UFCM));
E0=((T0y*T0y)/(2.0*mx));
E0prime=((T0y*T0y)/(2.0*mxprime));
E1=(4.0*E0);
E1prime=(4.0*E0prime);
if
((model->ASYMMOD==1))
{
}
if
((model->ASYMMOD!=0))
{
}
if
((model->BULKMOD!=0))
{
if
((model->TEMPMOD==0))
{
if
((model->ASYMMOD!=0))
{
}
}
else
{
if
((model->ASYMMOD!=0))
{
}
}
}
if
((model->ASYMMOD!=0))
{
}
if
((model->ASYMMOD!=0))
{
}
if
((model->ASYMMOD!=0))
{
}
if
((model->ASYMMOD!=0))
{
}
if
((model->ASYMMOD!=0))
{
}
if
((model->ASYMMOD!=0))
{
}
if
((model->ASYMMOD!=0))
{
}
if
((model->BULKMOD!=0))
{
}
if
((!model->VFBSD_Given))
{
if
((model->NGATE>0.0))
{
}
else
{
}
}
else
{
}
if
((!model->VFBSDCV_Given))
{
}
else
{
}
if
(((model->SHMOD!=0)&&(model->RTH0>0.0)))
{
}
else
{
}
if
(((model->SHMOD!=0)&&(model->RTH0>0.0)))
{
}
else
{
}
eta_mu_cv=0.5;
if
((model->TYPE!=1))
{
eta_mu_cv=(1.0/3.0);
}
if
((model->BULKMOD!=0))
{
}
if
((model->BULKMOD!=0))
{
vesmax=(0.95*PHIBE_i);
}
if
((model->ASYMMOD!=0))
{
}
else
{
}
if
((!model->NVTM_Given))
{
}
else
{
}
auxQMfact=pow((((((((3.0/4.0)*3.0)*1.05457e-34)*2.0)*3.14159265358979323846)*1.60219e-19)/(4.0*sqrt((2.0*mx)))),(2.0/3.0));
if
((model->BULKMOD!=0))
{
}
else
{
}
qb0=(1.0e-2/cox);
if
((model->BULKMOD!=0))
{
}
else
{
}
if
((model->RDSMOD==1))
{
}
else
{
if
((model->RDSMOD==0))
{
}
else
{
}
}
if
((model->BULKMOD!=0))
{
}
else
{
}
if
((model->BULKMOD!=0))
{
}
if
((model->CHARGEWF!=0.0))
{
}
else
{
}
if
((QMTCENCV_i>0.0))
{
}
else
{
}
if
(((model->BULKMOD!=0)&&(QMTCENCVA_i!=0.0)))
{
}
if
((model->BULKMOD!=0))
{
}
else
{
}
tmp=(((DROUT_i*Leff)/scl)+1.0e-6);
if
((tmp<40.0))
{
}
else
{
}
if
((PVAG_i>0.0))
{
}
else
{
}
if
((model->BULKMOD==2))
{
}
else
{
}
if
((PCLMCV_i!=0))
{
}
else
{
}
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((model->RDSMOD)==(1)))
{
}
else
/* CASE ITEM */
if
(((model->RDSMOD)==(0)))
{
}
else
/* CASE ITEM */
if
(((model->RDSMOD)==(2)))
{
}
else
{ /* no default */ }
/* -- CASE END -- */;
if
((model->BULKMOD!=0))
{
}
if
((model->CGEOMOD!=1))
{
}
if
((model->CGEOMOD==0))
{
}
else
{
if
((model->CGEOMOD==1))
{
if
((model->CGEO1SW==1))
{
}
else
{
}
}
else
{
}
}
if
((model->IIMOD==1))
{
}
else
{
if
((model->IIMOD==2))
{
}
}
if
((model->IGBMOD!=0))
{
if
((model->BULKMOD!=0))
{
}
else
{
}
}
if
((model->IGCMOD!=0))
{
if
((model->IGCLAMP==1))
{
if
((CIGS_i<0.01))
{
CIGS_i=0.01;
}
}
else
{
}
if
((model->IGCLAMP==1))
{
if
((CIGD_i<0.01))
{
CIGD_i=0.01;
}
}
else
{
}
}
if
((model->GIDLMOD!=0))
{
}
if
((model->BULKMOD!=0))
{
}
if
((model->BULKMOD!=0))
{
}
if
((model->BULKMOD==0))
{
}
if
((((model->NOIA>0.0)||(model->NOIB>0.0))||(model->NOIC>0.0)))
{
Leffnoi=(Leff-(2.0*LINTNOI_i));
Leffnoisq=(Leffnoi*Leffnoi);
if
((model->EM<=0.0))
{
}
else
{
}
}
else
{
}
/* -- CASE BEGIN -- */;
/* CASE ITEM */
if
(((model->TNOIMOD)==(0)))
{
}
else
/* CASE ITEM */
if
(((model->TNOIMOD)==(1)))
{
Abulk=1.0;
}
else
{ /* no default */ }
/* -- CASE END -- */;
if
((model->RDSMOD!=2))
{
}
  dynamic_jacobian4(di,si,ge,e)
  dynamic_jacobian2s(di,si,t)
  dynamic_jacobian4(di,si,ge,si)
  dynamic_jacobian4(di,si,e,di)
  dynamic_jacobian4(di,si,e,si)
  dynamic_jacobian4(di,si,di,si)
  dynamic_jacobian4(ge,si,ge,e)
  dynamic_jacobian2s(ge,si,t)
  dynamic_jacobian4(ge,si,ge,si)
  dynamic_jacobian4(ge,si,e,di)
  dynamic_jacobian4(ge,si,e,si)
  dynamic_jacobian4(ge,si,di,si)
if
((model->BULKMOD==0))
{
  static_jacobian4(ge,si,si,s)
  static_jacobian4(ge,si,di,d)
  static_jacobian4(ge,si,ge,di)
  static_jacobian4(ge,si,ge,si)
  static_jacobian4(ge,si,e,di)
  static_jacobian4(ge,si,e,si)
  static_jacobian2s(ge,si,t)
  static_jacobian4(ge,si,di,si)
  static_jacobian4(ge,si,ge,e)
  static_jacobian4(ge,di,si,s)
  static_jacobian4(ge,di,di,d)
  static_jacobian4(ge,di,ge,di)
  static_jacobian4(ge,di,ge,si)
  static_jacobian4(ge,di,e,di)
  static_jacobian4(ge,di,e,si)
  static_jacobian2s(ge,di,t)
  static_jacobian4(ge,di,di,si)
  static_jacobian4(ge,di,ge,e)
}
if
((model->BULKMOD!=0))
{
  static_jacobian2s(e,si,t)
  static_jacobian4(e,si,di,si)
  static_jacobian4(e,si,ge,si)
  static_jacobian4(e,si,e,di)
  static_jacobian4(e,si,e,si)
  static_jacobian4(e,si,ge,e)
  static_jacobian4(e,si,ge,di)
  static_jacobian2s(e,di,t)
  static_jacobian4(e,di,di,si)
  static_jacobian4(e,di,ge,si)
  static_jacobian4(e,di,e,di)
  static_jacobian4(e,di,e,si)
  static_jacobian4(e,di,ge,e)
  static_jacobian4(e,di,ge,di)
}
  dynamic_jacobian4(e,si,di,si)
  dynamic_jacobian4(e,si,ge,si)
  dynamic_jacobian4(e,si,e,di)
  dynamic_jacobian4(e,si,e,si)
  dynamic_jacobian4(e,si,ge,e)
  dynamic_jacobian4(e,si,ge,di)
  dynamic_jacobian2s(e,si,t)
  dynamic_jacobian4(e,si,si,s)
  dynamic_jacobian4(e,si,di,d)
  dynamic_jacobian4(e,di,di,si)
  dynamic_jacobian4(e,di,ge,si)
  dynamic_jacobian4(e,di,e,di)
  dynamic_jacobian4(e,di,e,si)
  dynamic_jacobian4(e,di,ge,e)
  dynamic_jacobian4(e,di,ge,di)
  dynamic_jacobian2s(e,di,t)
  dynamic_jacobian4(e,di,si,s)
  dynamic_jacobian4(e,di,di,d)
  dynamic_jacobian4(e,ge,e,ge)
  dynamic_jacobian2s(e,ge,t)
  dynamic_jacobian4(e,ge,ge,si)
  dynamic_jacobian4(e,ge,e,di)
  dynamic_jacobian4(e,ge,e,si)
  dynamic_jacobian4(e,ge,di,si)
  dynamic_jacobian4(e,ge,ge,e)
  dynamic_jacobian4(e,ge,ge,di)
  dynamic_jacobian2s(ge,si,t)
  dynamic_jacobian4(ge,si,di,si)
  dynamic_jacobian4(ge,si,ge,si)
  dynamic_jacobian4(ge,si,e,di)
  dynamic_jacobian4(ge,si,e,si)
  dynamic_jacobian4(ge,si,ge,e)
  dynamic_jacobian4(ge,si,ge,di)
  dynamic_jacobian4(ge,si,ge,s)
  dynamic_jacobian2s(ge,di,t)
  dynamic_jacobian4(ge,di,di,si)
  dynamic_jacobian4(ge,di,ge,si)
  dynamic_jacobian4(ge,di,e,di)
  dynamic_jacobian4(ge,di,e,si)
  dynamic_jacobian4(ge,di,ge,e)
  dynamic_jacobian4(ge,di,ge,di)
  dynamic_jacobian4(ge,di,ge,d)
  dynamic_jacobian4(d,s,d,s)
if
((model->CGEOMOD==1))
{
  dynamic_jacobian2s(ge,s,t)
  dynamic_jacobian4(ge,s,di,si)
  dynamic_jacobian4(ge,s,ge,si)
  dynamic_jacobian4(ge,s,e,di)
  dynamic_jacobian4(ge,s,e,si)
  dynamic_jacobian4(ge,s,ge,e)
  dynamic_jacobian4(ge,s,ge,di)
  dynamic_jacobian4(ge,s,ge,s)
  dynamic_jacobian2s(ge,d,t)
  dynamic_jacobian4(ge,d,di,si)
  dynamic_jacobian4(ge,d,ge,si)
  dynamic_jacobian4(ge,d,e,di)
  dynamic_jacobian4(ge,d,e,si)
  dynamic_jacobian4(ge,d,ge,e)
  dynamic_jacobian4(ge,d,ge,di)
  dynamic_jacobian4(ge,d,ge,d)
}
if
((model->BULKMOD!=0))
{
  dynamic_jacobian2s(ge,si,t)
  dynamic_jacobian4(ge,si,di,si)
  dynamic_jacobian4(ge,si,ge,si)
  dynamic_jacobian4(ge,si,e,di)
  dynamic_jacobian4(ge,si,e,si)
  dynamic_jacobian4(ge,si,ge,e)
  dynamic_jacobian4(ge,si,ge,di)
  dynamic_jacobian2s(e,si,t)
  dynamic_jacobian4(e,si,di,si)
  dynamic_jacobian4(e,si,ge,si)
  dynamic_jacobian4(e,si,e,di)
  dynamic_jacobian4(e,si,e,si)
  dynamic_jacobian4(e,si,ge,e)
  dynamic_jacobian4(e,si,ge,di)
}
if
((model->RDSMOD==2))
{
here->diNode = here->dNode; /* nnode collapsed */
  here->diNode_mine = 0;
here->siNode = here->sNode; /* nnode collapsed */
  here->siNode_mine = 0;
}
else
{
  static_jacobian4(d,di,ge,di)
  static_jacobian4(d,di,ge,si)
  static_jacobian4(d,di,e,di)
  static_jacobian4(d,di,e,si)
  static_jacobian4(d,di,di,si)
  static_jacobian4(d,di,ge,e)
  static_jacobian4(d,di,si,s)
  static_jacobian4(d,di,di,d)
  static_jacobian2s(d,di,t)
  static_jacobian4(d,di,d,di)
  static_jacobian4(s,si,ge,si)
  static_jacobian4(s,si,e,di)
  static_jacobian4(s,si,e,si)
  static_jacobian4(s,si,di,si)
  static_jacobian4(s,si,ge,e)
  static_jacobian4(s,si,si,s)
  static_jacobian2s(s,si,t)
  static_jacobian4(s,si,s,si)
}
if
((model->RGATEMOD!=0))
{
  static_jacobian4(g,ge,g,ge)
}
else
{
here->geNode = here->gNode; /* nnode collapsed */
  here->geNode_mine = 0;
}
  static_jacobian4(di,si,si,s)
  static_jacobian4(di,si,di,d)
  static_jacobian2s(di,si,t)
  static_jacobian4(di,si,di,si)
  static_jacobian4(di,si,ge,si)
  static_jacobian4(di,si,e,di)
  static_jacobian4(di,si,e,si)
  static_jacobian4(di,si,ge,e)
  static_jacobian4(di,si,ge,di)
if
((model->RDSMOD!=2))
{
  static_jacobian4(d,di,ge,di)
  static_jacobian4(d,di,ge,si)
  static_jacobian4(d,di,e,di)
  static_jacobian4(d,di,e,si)
  static_jacobian4(d,di,di,si)
  static_jacobian4(d,di,ge,e)
  static_jacobian4(d,di,si,s)
  static_jacobian4(d,di,di,d)
  static_jacobian2s(d,di,t)
  static_jacobian4(s,si,ge,si)
  static_jacobian4(s,si,e,di)
  static_jacobian4(s,si,e,si)
  static_jacobian4(s,si,di,si)
  static_jacobian4(s,si,ge,e)
  static_jacobian4(s,si,si,s)
  static_jacobian2s(s,si,t)
}
if
((model->RGATEMOD!=0))
{
  static_jacobian2s(g,ge,t)
}
if
((model->TNOIMOD==0))
{
  static_jacobian4(di,si,si,s)
  static_jacobian4(di,si,di,d)
  static_jacobian4(di,si,di,si)
  static_jacobian4(di,si,ge,si)
  static_jacobian4(di,si,e,di)
  static_jacobian4(di,si,e,si)
  static_jacobian4(di,si,ge,e)
  static_jacobian4(di,si,ge,di)
  static_jacobian2s(di,si,t)
here->NNode = 0; /* pnode collapsed to GND */ 
  here->NNode_mine = 0;
}
else
{
  static_jacobian4(di,si,si,s)
  static_jacobian4(di,si,di,d)
  static_jacobian4(di,si,di,si)
  static_jacobian4(di,si,ge,si)
  static_jacobian4(di,si,e,di)
  static_jacobian4(di,si,e,si)
  static_jacobian4(di,si,ge,e)
  static_jacobian4(di,si,ge,di)
  static_jacobian2s(di,si,t)
  static_jacobian2s(di,si,N)
  static_jacobian2s(di,si,t)
  static_jacobian4(di,si,ge,si)
  static_jacobian4(di,si,e,di)
  static_jacobian4(di,si,e,si)
  static_jacobian4(di,si,di,si)
  static_jacobian4(di,si,ge,e)
  static_jacobian4(di,si,si,s)
  static_jacobian4(di,si,di,d)
  static_jacobian4(di,si,ge,di)
  dynamic_jacobian2s(ge,si,N)
  dynamic_jacobian2s(ge,si,t)
  dynamic_jacobian4(ge,si,ge,si)
  dynamic_jacobian4(ge,si,e,di)
  dynamic_jacobian4(ge,si,e,si)
  dynamic_jacobian4(ge,si,di,si)
  dynamic_jacobian4(ge,si,ge,e)
  dynamic_jacobian2s(ge,di,N)
  dynamic_jacobian2s(ge,di,t)
  dynamic_jacobian4(ge,di,ge,si)
  dynamic_jacobian4(ge,di,e,di)
  dynamic_jacobian4(ge,di,e,si)
  dynamic_jacobian4(ge,di,di,si)
  dynamic_jacobian4(ge,di,ge,e)
}
if
((model->IGCMOD!=0))
{
}
if
((model->IGBMOD!=0))
{
if
((model->BULKMOD!=0))
{
  static_jacobian4(ge,e,si,s)
  static_jacobian4(ge,e,di,d)
  static_jacobian4(ge,e,ge,di)
  static_jacobian4(ge,e,ge,si)
  static_jacobian4(ge,e,e,di)
  static_jacobian4(ge,e,e,si)
  static_jacobian2s(ge,e,t)
  static_jacobian4(ge,e,di,si)
  static_jacobian4(ge,e,ge,e)
}
else
{
  static_jacobian4(ge,si,si,s)
  static_jacobian4(ge,si,di,d)
  static_jacobian4(ge,si,ge,di)
  static_jacobian4(ge,si,ge,si)
  static_jacobian4(ge,si,e,di)
  static_jacobian4(ge,si,e,si)
  static_jacobian2s(ge,si,t)
  static_jacobian4(ge,si,di,si)
  static_jacobian4(ge,si,ge,e)
  static_jacobian4(ge,di,si,s)
  static_jacobian4(ge,di,di,d)
  static_jacobian4(ge,di,ge,di)
  static_jacobian4(ge,di,ge,si)
  static_jacobian4(ge,di,e,di)
  static_jacobian4(ge,di,e,si)
  static_jacobian2s(ge,di,t)
  static_jacobian4(ge,di,di,si)
  static_jacobian4(ge,di,ge,e)
}
}
if
(((model->SHMOD!=0)&&(model->RTH0>0)))
{
if
((model->RDSMOD!=2))
{
  static_jacobian2p(t,s,si)
  static_jacobian2p(t,si,s)
  static_jacobian2p(t,di,d)
  static_jacobian2p(t,d,di)
  static_jacobian2p(t,ge,di)
  static_jacobian2p(t,ge,si)
  static_jacobian2p(t,e,di)
  static_jacobian2p(t,e,si)
  static_jacobian2p(t,ge,e)
  static_jacobian1(t,t)
  static_jacobian2p(t,di,si)
}
else
{
  static_jacobian2p(t,ge,di)
  static_jacobian2p(t,ge,si)
  static_jacobian2p(t,e,di)
  static_jacobian2p(t,e,si)
  static_jacobian2p(t,ge,e)
  static_jacobian1(t,t)
  static_jacobian2p(t,di,si)
}
}
  static_jacobian1(t,t)
  dynamic_jacobian1(t,t)
if
((model->BULKMOD==0))
{
}
else
{
}
if
((model->BULKMOD!=0))
{
}
else
{
}
if
((model->BULKMOD!=0))
{
}
else
{
}
if
((NGATE_i>0))
{
}
else
{
}
if
((model->BULKMOD!=0))
{
}
else
{
}
if
((model->BULKMOD==0))
{
}
else
{
}

  return(OK);
}
