/***
*** Interface: ngspice 1.0.0.0
 *** created by: admsXml-2.3.7 ***/

#define NGSPICE_DEBUG_OK


#include "ngspice/ngspice.h"
#include "ngspice/cktdefs.h"
#include "ekvdefs.h"
#include "ngspice/const.h"
#include "ngspice/trandefs.h"
#include "ngspice/sperror.h"
#include "ngspice/devdefs.h"
#include "ngspice/suffix.h"

/*fixme: noise not implemented in ngspice*/
#define ngspice_flickernoise(p,n,mag,freq,info)\
{\
}
#define ngspice_whitenoise(p,n,mag,info)\
{\
}

#define NP(p) *(ckt->CKTrhsOld+here->p ## Node)
#define BP(p,n) (NP(p)-NP(n))
#define DBGNODE(p) printf(#p "=%i - v=%e\n",here->p ## Node,NP(p));
static void ekvdebug (CKTcircuit *ckt, ekvmodel *model, ekvinstance *here)
{
  fprintf(stdout,"voltage: d=%e\n",NP(d));
  fprintf(stdout,"voltage: g=%e\n",NP(g));
  fprintf(stdout,"voltage: s=%e\n",NP(s));
  fprintf(stdout,"voltage: b=%e\n",NP(b));
  fprintf(stdout,"voltage: dp=%e\n",NP(dp));
  fprintf(stdout,"voltage: sp=%e\n",NP(sp));
  fprintf(stdout,"Parameter: instance: l=%e\n",here->l);
  fprintf(stdout,"Parameter: instance: w=%e\n",here->w);
  fprintf(stdout,"Parameter: instance: m=%e\n",here->m);
  fprintf(stdout,"Parameter: instance: ns=%e\n",here->ns);
  fprintf(stdout,"Parameter: instance: dtemp=%e\n",here->dtemp);
  fprintf(stdout,"Parameter: instance: ad=%e\n",here->ad);
  fprintf(stdout,"Parameter: instance: as=%e\n",here->as);
  fprintf(stdout,"Parameter: instance: pd=%e\n",here->pd);
  fprintf(stdout,"Parameter: instance: ps=%e\n",here->ps);
  fprintf(stdout,"Parameter: instance: nrd=%e\n",here->nrd);
  fprintf(stdout,"Parameter: instance: nrs=%e\n",here->nrs);
  fprintf(stdout,"Parameter: model: nmos=%i\n",model->nmos);
  fprintf(stdout,"Parameter: model: pmos=%i\n",model->pmos);
  fprintf(stdout,"Parameter: model: type=%i\n",model->type);
  fprintf(stdout,"Parameter: model: tnom=%e\n",model->tnom);
  fprintf(stdout,"Parameter: model: imax=%e\n",model->imax);
  fprintf(stdout,"Parameter: model: tox=%e\n",model->tox);
  fprintf(stdout,"Parameter: model: nsub=%e\n",model->nsub);
  fprintf(stdout,"Parameter: model: vfb=%e\n",model->vfb);
  fprintf(stdout,"Parameter: model: uo=%e\n",model->uo);
  fprintf(stdout,"Parameter: model: vmax=%e\n",model->vmax);
  fprintf(stdout,"Parameter: model: theta=%e\n",model->theta);
  fprintf(stdout,"Parameter: model: cox=%e\n",model->cox);
  fprintf(stdout,"Parameter: model: xj=%e\n",model->xj);
  fprintf(stdout,"Parameter: model: dl=%e\n",model->dl);
  fprintf(stdout,"Parameter: model: dw=%e\n",model->dw);
  fprintf(stdout,"Parameter: model: gamma=%e\n",model->gamma);
  fprintf(stdout,"Parameter: model: phi=%e\n",model->phi);
  fprintf(stdout,"Parameter: model: vto=%e\n",model->vto);
  fprintf(stdout,"Parameter: model: kp=%e\n",model->kp);
  fprintf(stdout,"Parameter: model: ucrit=%e\n",model->ucrit);
  fprintf(stdout,"Parameter: model: e0=%e\n",model->e0);
  fprintf(stdout,"Parameter: model: lambda=%e\n",model->lambda);
  fprintf(stdout,"Parameter: model: weta=%e\n",model->weta);
  fprintf(stdout,"Parameter: model: leta=%e\n",model->leta);
  fprintf(stdout,"Parameter: model: q0=%e\n",model->q0);
  fprintf(stdout,"Parameter: model: lk=%e\n",model->lk);
  fprintf(stdout,"Parameter: model: iba=%e\n",model->iba);
  fprintf(stdout,"Parameter: model: ibb=%e\n",model->ibb);
  fprintf(stdout,"Parameter: model: ibn=%e\n",model->ibn);
  fprintf(stdout,"Parameter: model: tcv=%e\n",model->tcv);
  fprintf(stdout,"Parameter: model: bex=%e\n",model->bex);
  fprintf(stdout,"Parameter: model: ucex=%e\n",model->ucex);
  fprintf(stdout,"Parameter: model: ibbt=%e\n",model->ibbt);
  fprintf(stdout,"Parameter: model: avto=%e\n",model->avto);
  fprintf(stdout,"Parameter: model: akp=%e\n",model->akp);
  fprintf(stdout,"Parameter: model: agamma=%e\n",model->agamma);
  fprintf(stdout,"Parameter: model: kf=%e\n",model->kf);
  fprintf(stdout,"Parameter: model: af=%e\n",model->af);
  fprintf(stdout,"Parameter: model: hdif=%e\n",model->hdif);
  fprintf(stdout,"Parameter: model: rsh=%e\n",model->rsh);
  fprintf(stdout,"Parameter: model: js=%e\n",model->js);
  fprintf(stdout,"Parameter: model: jsw=%e\n",model->jsw);
  fprintf(stdout,"Parameter: model: xti=%e\n",model->xti);
  fprintf(stdout,"Parameter: model: n=%e\n",model->n);
  fprintf(stdout,"Parameter: model: cj=%e\n",model->cj);
  fprintf(stdout,"Parameter: model: cjsw=%e\n",model->cjsw);
  fprintf(stdout,"Parameter: model: pb=%e\n",model->pb);
  fprintf(stdout,"Parameter: model: pbsw=%e\n",model->pbsw);
  fprintf(stdout,"Parameter: model: mj=%e\n",model->mj);
  fprintf(stdout,"Parameter: model: mjsw=%e\n",model->mjsw);
  fprintf(stdout,"Parameter: model: fc=%e\n",model->fc);
  fprintf(stdout,"Parameter: model: fcsw=%e\n",model->fcsw);
  fprintf(stdout,"Parameter: model: cgso=%e\n",model->cgso);
  fprintf(stdout,"Parameter: model: cgdo=%e\n",model->cgdo);
  fprintf(stdout,"Parameter: model: cgbo=%e\n",model->cgbo);
  fprintf(stdout,"model: MOStype=%i\n",model->MOStype);
  fprintf(stdout,"model: lc=%e\n",model->lc);
  fprintf(stdout,"model: cox_p=%e\n",model->cox_p);
  fprintf(stdout,"model: gamma_p=%e\n",model->gamma_p);
  fprintf(stdout,"model: phi_p=%e\n",model->phi_p);
  fprintf(stdout,"model: kp_p=%e\n",model->kp_p);
  fprintf(stdout,"model: vto_p=%e\n",model->vto_p);
  fprintf(stdout,"model: ucrit_p=%e\n",model->ucrit_p);
  fprintf(stdout,"instance: isat_s=%e\n",here->isat_s);
  fprintf(stdout,"instance: vexp_s=%e\n",here->vexp_s);
  fprintf(stdout,"instance: gexp_s=%e\n",here->gexp_s);
  fprintf(stdout,"instance: isat_d=%e\n",here->isat_d);
  fprintf(stdout,"instance: vexp_d=%e\n",here->vexp_d);
  fprintf(stdout,"instance: gexp_d=%e\n",here->gexp_d);
  fprintf(stdout,"instance: weff=%e\n",here->weff);
  fprintf(stdout,"instance: leff=%e\n",here->leff);
  fprintf(stdout,"instance: lmin=%e\n",here->lmin);
  fprintf(stdout,"instance: RDeff=%e\n",here->RDeff);
  fprintf(stdout,"instance: RSeff=%e\n",here->RSeff);
  fprintf(stdout,"instance: dvrsce=%e\n",here->dvrsce);
  fprintf(stdout,"instance: Vt=%e\n",here->Vt);
  fprintf(stdout,"instance: vto_a=%e\n",here->vto_a);
  fprintf(stdout,"instance: kp_a=%e\n",here->kp_a);
  fprintf(stdout,"instance: gamma_a=%e\n",here->gamma_a);
  fprintf(stdout,"instance: ucrit_a=%e\n",here->ucrit_a);
  fprintf(stdout,"instance: phi_a=%e\n",here->phi_a);
  fprintf(stdout,"instance: ibb_a=%e\n",here->ibb_a);
  fprintf(stdout,"instance: vc=%e\n",here->vc);
  fprintf(stdout,"instance: qb0=%e\n",here->qb0);
  fprintf(stdout,"instance: tmp=%e\n",here->tmp);
  fprintf(stdout,"instance: coxt=%e\n",here->coxt);
  fprintf(stdout,"instance: cbs0=%e\n",here->cbs0);
  fprintf(stdout,"instance: cbs0sw=%e\n",here->cbs0sw);
  fprintf(stdout,"instance: cbd0=%e\n",here->cbd0);
  fprintf(stdout,"instance: cbd0sw=%e\n",here->cbd0sw);
  fprintf(stdout,"instance: cgso_s=%e\n",here->cgso_s);
  fprintf(stdout,"instance: cgdo_s=%e\n",here->cgdo_s);
  fprintf(stdout,"instance: cgbo_s=%e\n",here->cgbo_s);
}


#define _STATIC
#define _DYNAMIC
#define _DERIVATE

#define _load_static_residual2(p,n,v)\
  *(ckt->CKTrhs+here->p ## Node)-=v;\
  *(ckt->CKTrhs+here->n ## Node)+=v;
#define _load_static_residual1(p,v)\
  *(ckt->CKTrhs+here->p ## Node)-=v;

#define _load_static_jacobian4(Sp,Sn,Pp,Pn,v)\
  _load_static_residual2(Sp,Sn,-v*BP(Pp,Pn))\
  *(here->PTR_J_ ## Sp ## _ ## Pp)+=v;\
  *(here->PTR_J_ ## Sn ## _ ## Pn)+=v;\
  *(here->PTR_J_ ## Sp ## _ ## Pn)-=v;\
  *(here->PTR_J_ ## Sn ## _ ## Pp)-=v;\
  (here->JSVAL_ ## Sp ## _ ## Pp)+=v;\
  (here->JSVAL_ ## Sn ## _ ## Pn)+=v;\
  (here->JSVAL_ ## Sp ## _ ## Pn)-=v;\
  (here->JSVAL_ ## Sn ## _ ## Pp)-=v;
#define _load_static_jacobian2s(Sp,Sn,Pp,v)\
  _load_static_residual2(Sp,Sn,-v*NP(Pp))\
  *(here->PTR_J_ ## Sp ## _ ## Pp)+=v;\
  *(here->PTR_J_ ## Sn ## _ ## Pp)-=v;\
  (here->JSVAL_ ## Sp ## _ ## Pp)+=v;\
  (here->JSVAL_ ## Sn ## _ ## Pp)-=v;
#define _load_static_jacobian2p(Sp,Pp,Pn,v)\
  _load_static_residual1(Sp,-v*BP(Pp,Pn))\
  *(here->PTR_J_ ## Sp ## _ ## Pp)+=v;\
  *(here->PTR_J_ ## Sp ## _ ## Pn)-=v;\
  (here->JSVAL_ ## Sp ## _ ## Pp)+=v;\
  (here->JSVAL_ ## Sp ## _ ## Pn)-=v;
#define _load_static_jacobian1(Sp,Pp,v)\
  _load_static_residual1(Sp,-v*NP(Pp))\
  *(here->PTR_J_ ## Sp ## _ ## Pp)+=v;\
  (here->JSVAL_ ## Sp ## _ ## Pp)+=v;

#define _load_dynamic_residual2(p,n,v)\
if(ChargeComputationNeeded)\
{\
  int error;\
  double unused;\
  *(ckt->CKTstate0+here->state_##p##_##n)=v;\
  if(ckt->CKTmode & MODEINITTRAN)\
    *(ckt->CKTstate1+here->state_##p##_##n)=*(ckt->CKTstate0+here->state_##p##_##n);\
  error = NIintegrate(ckt,&unused,&unused,0.0,here->state_##p##_##n);\
  if(error) return(error);\
  if(ckt->CKTmode & MODEINITTRAN)\
    *(ckt->CKTstate1+here->state_##p##_##n+1) = *(ckt->CKTstate0+here->state_##p##_##n+1);\
  *(ckt->CKTrhs+here->p##Node)-=*(ckt->CKTstate0+here->state_##p##_##n+1);\
  *(ckt->CKTrhs+here->n##Node)+=*(ckt->CKTstate0+here->state_##p##_##n+1);\
}
#define _load_dynamic_residual1(p,v)\
if(ChargeComputationNeeded)\
{\
  int error;\
  double unused;\
  *(ckt->CKTstate0+here->state_##p##_GND)=v;\
  if(ckt->CKTmode & MODEINITTRAN)\
    *(ckt->CKTstate1+here->state_##p##_GND)=*(ckt->CKTstate0+here->state_##p##_GND);\
  error = NIintegrate(ckt,&unused,&unused,0.0,here->state_##p##_GND);\
  if(error) return(error);\
  if(ckt->CKTmode & MODEINITTRAN)\
    *(ckt->CKTstate1+here->state_##p##_GND+1) = *(ckt->CKTstate0+here->state_##p##_GND+1);\
  *(ckt->CKTrhs+here->p##Node)-=*(ckt->CKTstate0+here->state_##p##_GND+1);\
}

#define _load_dynamic_jacobian4(Sp,Sn,Pp,Pn,v)\
if(ChargeComputationNeeded)\
{\
  double geq=(v)*ckt->CKTag[0];\
  double ceq=geq*BP(Pp,Pn);\
  *(ckt->CKTrhs+here->Sp##Node)+=ceq;\
  *(ckt->CKTrhs+here->Sn##Node)-=ceq;\
  *(here->PTR_J_ ## Sp ## _ ## Pp)+=geq;\
  *(here->PTR_J_ ## Sn ## _ ## Pn)+=geq;\
  *(here->PTR_J_ ## Sp ## _ ## Pn)-=geq;\
  *(here->PTR_J_ ## Sn ## _ ## Pp)-=geq;\
}\
  (here->JDVAL_ ## Sp ## _ ## Pp)+=v;\
  (here->JDVAL_ ## Sn ## _ ## Pn)+=v;\
  (here->JDVAL_ ## Sp ## _ ## Pn)-=v;\
  (here->JDVAL_ ## Sn ## _ ## Pp)-=v;
#define _load_dynamic_jacobian2s(Sp,Sn,Pp,v)\
if(ChargeComputationNeeded)\
{\
  double geq=(v)*ckt->CKTag[0];\
  double ceq=geq*NP(Pp);\
  *(ckt->CKTrhs+here->Sp##Node)+=ceq;\
  *(ckt->CKTrhs+here->Sn##Node)-=ceq;\
  *(here->PTR_J_ ## Sp ## _ ## Pp)+=geq;\
  *(here->PTR_J_ ## Sn ## _ ## Pp)-=geq;\
}\
  (here->JDVAL_ ## Sp ## _ ## Pp)+=v;\
  (here->JDVAL_ ## Sn ## _ ## Pp)-=v;
#define _load_dynamic_jacobian2p(Sp,Pp,Pn,v)\
if(ChargeComputationNeeded)\
{\
  double geq=(v)*ckt->CKTag[0];\
  double ceq=geq*BP(Pp,Pn);\
  *(ckt->CKTrhs+here->Sp##Node)+=ceq;\
  *(here->PTR_J_ ## Sp ## _ ## Pp)+=geq;\
  *(here->PTR_J_ ## Sp ## _ ## Pn)-=geq;\
}\
  (here->JDVAL_ ## Sp ## _ ## Pp)+=v;\
  (here->JDVAL_ ## Sp ## _ ## Pn)-=v;
#define _load_dynamic_jacobian1(Sp,Pp,v)\
if(ChargeComputationNeeded)\
{\
  double geq=(v)*ckt->CKTag[0];\
  double ceq=geq*NP(Pp);\
  *(ckt->CKTrhs+here->Sp##Node)+=ceq;\
  *(here->PTR_J_ ## Sp ## _ ## Pp)+=geq;\
}\
(here->JDVAL_ ## Sp ## _ ## Pp)+=v;

int ekvload(GENmodel *inModel, CKTcircuit *ckt)
     /* actually load the current value into the 
      * sparse matrix previously provided 
      */
{
  ekvmodel *model = (ekvmodel*)inModel;
  ekvinstance *here;
  int ChargeComputationNeeded =  
                 ((ckt->CKTmode & (MODEAC | MODETRAN | MODEINITSMSIG)) ||
                 ((ckt->CKTmode & MODETRANOP) && (ckt->CKTmode & MODEUIC)))
                 ? 1 : 0;

  for ( ; model != NULL; model = ekvnextModel(model) )
  {
    /* loop through all the instances of the model */
    for (here = ekvinstances(model); here != NULL ; here = ekvnextInstance(here))
    {
{  here->JSVAL_dp_sp=0.0;
  here->JSVAL_dp_b=0.0;
  here->JSVAL_sp_sp=0.0;
  here->JSVAL_sp_b=0.0;
  here->JSVAL_dp_dp=0.0;
  here->JSVAL_sp_dp=0.0;
  here->JSVAL_dp_g=0.0;
  here->JSVAL_sp_g=0.0;
  here->JSVAL_b_sp=0.0;
  here->JSVAL_b_b=0.0;
  here->JSVAL_b_dp=0.0;
  here->JSVAL_b_g=0.0;
  here->JSVAL_d_d=0.0;
  here->JSVAL_d_dp=0.0;
  here->JSVAL_dp_d=0.0;
  here->JSVAL_s_s=0.0;
  here->JSVAL_s_sp=0.0;
  here->JSVAL_sp_s=0.0;
  here->JDVAL_dp_sp=0.0;
  here->JDVAL_dp_b=0.0;
  here->JDVAL_sp_sp=0.0;
  here->JDVAL_sp_b=0.0;
  here->JDVAL_dp_dp=0.0;
  here->JDVAL_sp_dp=0.0;
  here->JDVAL_dp_g=0.0;
  here->JDVAL_sp_g=0.0;
  here->JDVAL_b_sp=0.0;
  here->JDVAL_b_b=0.0;
  here->JDVAL_b_dp=0.0;
  here->JDVAL_b_g=0.0;
  here->JDVAL_g_sp=0.0;
  here->JDVAL_g_b=0.0;
  here->JDVAL_g_dp=0.0;
  here->JDVAL_g_g=0.0;

}
{
#include "ekv.hxx"
}
    } /* End of Instance */
  } /* End of Model */
  return(OK);
}
