/***
*** Interface: ads2002 2.2.0.0
 *** created by: admsXml-2.3.7 ***/


#include "ngspice/ngspice.h"
#include "ngspice/devdefs.h"
#include "psp102defs.h"
#include "ngspice/suffix.h"

IFparm psp102pTable[] = {
  IOP("l",psp102_instance_L,IF_REAL,"L"),
  IOP("w",psp102_instance_W,IF_REAL,"W"),
  IOP("sa",psp102_instance_SA,IF_REAL,"SA"),
  IOP("sb",psp102_instance_SB,IF_REAL,"SB"),
  IOP("sd",psp102_instance_SD,IF_REAL,"SD"),
  IOP("sca",psp102_instance_SCA,IF_REAL,"SCA"),
  IOP("scb",psp102_instance_SCB,IF_REAL,"SCB"),
  IOP("scc",psp102_instance_SCC,IF_REAL,"SCC"),
  IOP("sc",psp102_instance_SC,IF_REAL,"SC"),
  IOP("delvto",psp102_instance_DELVTO,IF_REAL,"DELVTO"),
  IOP("factuo",psp102_instance_FACTUO,IF_REAL,"FACTUO"),
  IOP("absource",psp102_instance_ABSOURCE,IF_REAL,"ABSOURCE"),
  IOP("lssource",psp102_instance_LSSOURCE,IF_REAL,"LSSOURCE"),
  IOP("lgsource",psp102_instance_LGSOURCE,IF_REAL,"LGSOURCE"),
  IOP("abdrain",psp102_instance_ABDRAIN,IF_REAL,"ABDRAIN"),
  IOP("lsdrain",psp102_instance_LSDRAIN,IF_REAL,"LSDRAIN"),
  IOP("lgdrain",psp102_instance_LGDRAIN,IF_REAL,"LGDRAIN"),
  IOP("as",psp102_instance_AS,IF_REAL,"AS"),
  IOP("ps",psp102_instance_PS,IF_REAL,"PS"),
  IOP("ad",psp102_instance_AD,IF_REAL,"AD"),
  IOP("pd",psp102_instance_PD,IF_REAL,"PD"),
  IOP("mult",psp102_instance_MULT,IF_REAL,"MULT"),
  IOP("nf",psp102_instance_NF,IF_REAL,"NF"),
  IOP("ngcon",psp102_instance_NGCON,IF_REAL,"NGCON"),
  IOP("xgw",psp102_instance_XGW,IF_REAL,"XGW"),
  OP("ctype",psp102_ask_ctype,IF_REAL,"Flag for channel type"),
  OP("sdint",psp102_ask_sdint,IF_REAL,"Flag for source-drain interchange"),
  OP("ise",psp102_ask_ise,IF_REAL,"Total source current"),
  OP("ige",psp102_ask_ige,IF_REAL,"Total gate current"),
  OP("ide",psp102_ask_ide,IF_REAL,"Total drain current"),
  OP("ibe",psp102_ask_ibe,IF_REAL,"Total bulk current"),
  OP("ids",psp102_ask_ids,IF_REAL,"Drain current, excl. avalanche, tunnel, GISL, GIDL, and junction currents"),
  OP("idb",psp102_ask_idb,IF_REAL,"Drain to bulk current"),
  OP("isb",psp102_ask_isb,IF_REAL,"Source to bulk current"),
  OP("igs",psp102_ask_igs,IF_REAL,"Gate-source tunneling current"),
  OP("igd",psp102_ask_igd,IF_REAL,"Gate-drain tunneling current"),
  OP("igb",psp102_ask_igb,IF_REAL,"Gate-bulk tunneling current"),
  OP("igcs",psp102_ask_igcs,IF_REAL,"Gate-channel tunneling current (source component)"),
  OP("igcd",psp102_ask_igcd,IF_REAL,"Gate-channel tunneling current (drain component)"),
  OP("iavl",psp102_ask_iavl,IF_REAL,"Substrate current due to weak avelanche"),
  OP("igisl",psp102_ask_igisl,IF_REAL,"Gate-induced source leakage current"),
  OP("igidl",psp102_ask_igidl,IF_REAL,"Gate-induced drain leakage current"),
  OP("ijs",psp102_ask_ijs,IF_REAL,"Total source junction current"),
  OP("ijsbot",psp102_ask_ijsbot,IF_REAL,"Source junction current (bottom component)"),
  OP("ijsgat",psp102_ask_ijsgat,IF_REAL,"Source junction current (gate-edge component)"),
  OP("ijssti",psp102_ask_ijssti,IF_REAL,"Source junction current (STI-edge component)"),
  OP("ijd",psp102_ask_ijd,IF_REAL,"Total drain junction current"),
  OP("ijdbot",psp102_ask_ijdbot,IF_REAL,"Drain junction current (bottom component)"),
  OP("ijdgat",psp102_ask_ijdgat,IF_REAL,"Drain junction current (gate-edge component)"),
  OP("ijdsti",psp102_ask_ijdsti,IF_REAL,"Drain junction current (STI-edge component)"),
  OP("vds",psp102_ask_vds,IF_REAL,"Drain-source voltage"),
  OP("vgs",psp102_ask_vgs,IF_REAL,"Gate-source voltage"),
  OP("vsb",psp102_ask_vsb,IF_REAL,"Source-bulk voltage"),
  OP("vto",psp102_ask_vto,IF_REAL,"Zero-bias threshold voltage"),
  OP("vts",psp102_ask_vts,IF_REAL,"Threshold voltage including back bias effects"),
  OP("vth",psp102_ask_vth,IF_REAL,"Threshold voltage including back bias and drain bias effects"),
  OP("vgt",psp102_ask_vgt,IF_REAL,"Effective gate drive voltage including back bias and drain bias effects"),
  OP("vdss",psp102_ask_vdss,IF_REAL,"Drain saturation voltage at actual bias"),
  OP("vsat",psp102_ask_vsat,IF_REAL,"Saturation limit"),
  OP("gm",psp102_ask_gm,IF_REAL,"Transconductance"),
  OP("gmb",psp102_ask_gmb,IF_REAL,"Substrate transconductance"),
  OP("gds",psp102_ask_gds,IF_REAL,"Output conductance"),
  OP("gjs",psp102_ask_gjs,IF_REAL,"Source junction conductance"),
  OP("gjd",psp102_ask_gjd,IF_REAL,"Drain junction conductance"),
  OP("cdd",psp102_ask_cdd,IF_REAL,"Drain capacitance"),
  OP("cdg",psp102_ask_cdg,IF_REAL,"Drain-gate capacitance"),
  OP("cds",psp102_ask_cds,IF_REAL,"Drain-source capacitance"),
  OP("cdb",psp102_ask_cdb,IF_REAL,"Drain-bulk capacitance"),
  OP("cgd",psp102_ask_cgd,IF_REAL,"Gate-drain capacitance"),
  OP("cgg",psp102_ask_cgg,IF_REAL,"Gate capacitance"),
  OP("cgs",psp102_ask_cgs,IF_REAL,"Gate-source capacitance"),
  OP("cgb",psp102_ask_cgb,IF_REAL,"Gate-bulk capacitance"),
  OP("csd",psp102_ask_csd,IF_REAL,"Source-drain capacitance"),
  OP("csg",psp102_ask_csg,IF_REAL,"Source-gate capacitance"),
  OP("css",psp102_ask_css,IF_REAL,"Source capacitance"),
  OP("csb",psp102_ask_csb,IF_REAL,"Source-bulk capacitance"),
  OP("cbd",psp102_ask_cbd,IF_REAL,"Bulk-drain capacitance"),
  OP("cbg",psp102_ask_cbg,IF_REAL,"Bulk-gate capacitance"),
  OP("cbs",psp102_ask_cbs,IF_REAL,"Bulk-source capacitance"),
  OP("cbb",psp102_ask_cbb,IF_REAL,"Bulk capacitance"),
  OP("cgsol",psp102_ask_cgsol,IF_REAL,"Total gate-source overlap capacitance"),
  OP("cgdol",psp102_ask_cgdol,IF_REAL,"Total gate-drain overlap capacitance"),
  OP("cjs",psp102_ask_cjs,IF_REAL,"Total source junction capacitance"),
  OP("cjsbot",psp102_ask_cjsbot,IF_REAL,"Source junction capacitance (bottom component)"),
  OP("cjsgat",psp102_ask_cjsgat,IF_REAL,"Source junction capacitance (gate-edge component)"),
  OP("cjssti",psp102_ask_cjssti,IF_REAL,"Source junction capacitance (STI-edge component)"),
  OP("cjd",psp102_ask_cjd,IF_REAL,"Total drain junction capacitance"),
  OP("cjdbot",psp102_ask_cjdbot,IF_REAL,"Drain junction capacitance (bottom component)"),
  OP("cjdgat",psp102_ask_cjdgat,IF_REAL,"Drain junction capacitance (gate-edge component)"),
  OP("cjdsti",psp102_ask_cjdsti,IF_REAL,"Drain junction capacitance (STI-edge component)"),
  OP("weff",psp102_ask_weff,IF_REAL,"Effective channel width for geometrical models"),
  OP("leff",psp102_ask_leff,IF_REAL,"Effective channel length for geometrical models"),
  OP("u",psp102_ask_u,IF_REAL,"Transistor gain"),
  OP("rout",psp102_ask_rout,IF_REAL,"Small-signal output resistance"),
  OP("vearly",psp102_ask_vearly,IF_REAL,"Equivalent Early voltage"),
  OP("beff",psp102_ask_beff,IF_REAL,"Gain factor"),
  OP("fug",psp102_ask_fug,IF_REAL,"Unity gain frequency at actual bias"),
  OP("rg_op",psp102_ask_rg_op,IF_REAL,"Gate resistance"),
  OP("sfl",psp102_ask_sfl,IF_REAL,"Flicker noise current spectral density at 1 Hz"),
  OP("sqrtsff",psp102_ask_sqrtsff,IF_REAL,"Input-referred RMS white noise voltage spectral density at 1 kHz"),
  OP("sqrtsfw",psp102_ask_sqrtsfw,IF_REAL,"Input-referred RMS white noise voltage spectral density"),
  OP("sid",psp102_ask_sid,IF_REAL,"White noise current spectral density"),
  OP("sig",psp102_ask_sig,IF_REAL,"Induced gate noise current spectral density at 1 Hz"),
  OP("cigid",psp102_ask_cigid,IF_REAL,"Imaginary part of correlation coefficient between Sig and Sid"),
  OP("fknee",psp102_ask_fknee,IF_REAL,"Cross-over frequency above which white noise is dominant"),
  OP("sigs",psp102_ask_sigs,IF_REAL,"Gate-source current noise spectral density"),
  OP("sigd",psp102_ask_sigd,IF_REAL,"Gate-drain current noise spectral density"),
  OP("siavl",psp102_ask_siavl,IF_REAL,"Impact ionization current noise spectral density"),
  OP("ssi",psp102_ask_ssi,IF_REAL,"Total source junction current noise spectral density"),
  OP("sdi",psp102_ask_sdi,IF_REAL,"Total drain junction current noise spectral density"),
  OP("lp_vfb",psp102_ask_lp_vfb,IF_REAL,"Local parameter VFB after T-scaling and clipping"),
  OP("lp_stvfb",psp102_ask_lp_stvfb,IF_REAL,"Local parameter STVFB after clipping"),
  OP("lp_tox",psp102_ask_lp_tox,IF_REAL,"Local parameter TOX after clipping"),
  OP("lp_epsrox",psp102_ask_lp_epsrox,IF_REAL,"Local parameter EPSROX after clipping"),
  OP("lp_neff",psp102_ask_lp_neff,IF_REAL,"Local parameter NEFF after clipping"),
  OP("lp_vnsub",psp102_ask_lp_vnsub,IF_REAL,"Local parameter VNSUB after clipping"),
  OP("lp_nslp",psp102_ask_lp_nslp,IF_REAL,"Local parameter NSLP after clipping"),
  OP("lp_dnsub",psp102_ask_lp_dnsub,IF_REAL,"Local parameter DNSUB after clipping"),
  OP("lp_dphib",psp102_ask_lp_dphib,IF_REAL,"Local parameter DPHIB after clipping"),
  OP("lp_np",psp102_ask_lp_np,IF_REAL,"Local parameter NP after clipping"),
  OP("lp_ct",psp102_ask_lp_ct,IF_REAL,"Local parameter CT after clipping"),
  OP("lp_toxov",psp102_ask_lp_toxov,IF_REAL,"Local parameter TOXOV after clipping"),
  OP("lp_toxovd",psp102_ask_lp_toxovd,IF_REAL,"Local parameter TOXOVD after clipping"),
  OP("lp_nov",psp102_ask_lp_nov,IF_REAL,"Local parameter NOV after clipping"),
  OP("lp_novd",psp102_ask_lp_novd,IF_REAL,"Local parameter NOVD after clipping"),
  OP("lp_cf",psp102_ask_lp_cf,IF_REAL,"Local parameter CF after clipping"),
  OP("lp_cfb",psp102_ask_lp_cfb,IF_REAL,"Local parameter CFB after clipping"),
  OP("lp_betn",psp102_ask_lp_betn,IF_REAL,"Local parameter BETN after T-scaling and clipping"),
  OP("lp_stbet",psp102_ask_lp_stbet,IF_REAL,"Local parameter STBET after clipping"),
  OP("lp_mue",psp102_ask_lp_mue,IF_REAL,"Local parameter MUE after T-scaling and clipping"),
  OP("lp_stmue",psp102_ask_lp_stmue,IF_REAL,"Local parameter STMUE after clipping"),
  OP("lp_themu",psp102_ask_lp_themu,IF_REAL,"Local parameter THEMU after T-scaling and clipping"),
  OP("lp_stthemu",psp102_ask_lp_stthemu,IF_REAL,"Local parameter STTHEMU after clipping"),
  OP("lp_cs",psp102_ask_lp_cs,IF_REAL,"Local parameter CS after T-scaling and clipping"),
  OP("lp_stcs",psp102_ask_lp_stcs,IF_REAL,"Local parameter STCS after clipping"),
  OP("lp_xcor",psp102_ask_lp_xcor,IF_REAL,"Local parameter XCOR after T-scaling and clipping"),
  OP("lp_stxcor",psp102_ask_lp_stxcor,IF_REAL,"Local parameter STXCOR after clipping"),
  OP("lp_feta",psp102_ask_lp_feta,IF_REAL,"Local parameter FETA after clipping"),
  OP("lp_rs",psp102_ask_lp_rs,IF_REAL,"Local parameter RS after T-scaling and clipping"),
  OP("lp_strs",psp102_ask_lp_strs,IF_REAL,"Local parameter STRS after clipping"),
  OP("lp_rsb",psp102_ask_lp_rsb,IF_REAL,"Local parameter RSB after clipping"),
  OP("lp_rsg",psp102_ask_lp_rsg,IF_REAL,"Local parameter RSG after clipping"),
  OP("lp_thesat",psp102_ask_lp_thesat,IF_REAL,"Local parameter THESAT after T-scaling and clipping"),
  OP("lp_stthesat",psp102_ask_lp_stthesat,IF_REAL,"Local parameter STTHESAT after clipping"),
  OP("lp_thesatb",psp102_ask_lp_thesatb,IF_REAL,"Local parameter THESATB after clipping"),
  OP("lp_thesatg",psp102_ask_lp_thesatg,IF_REAL,"Local parameter THESATG after clipping"),
  OP("lp_ax",psp102_ask_lp_ax,IF_REAL,"Local parameter AX after clipping"),
  OP("lp_alp",psp102_ask_lp_alp,IF_REAL,"Local parameter ALP after clipping"),
  OP("lp_alp1",psp102_ask_lp_alp1,IF_REAL,"Local parameter ALP1 after clipping"),
  OP("lp_alp2",psp102_ask_lp_alp2,IF_REAL,"Local parameter ALP2 after clipping"),
  OP("lp_vp",psp102_ask_lp_vp,IF_REAL,"Local parameter VP after clipping"),
  OP("lp_a1",psp102_ask_lp_a1,IF_REAL,"Local parameter A1 after clipping"),
  OP("lp_a2",psp102_ask_lp_a2,IF_REAL,"Local parameter A2 after T-scaling and clipping"),
  OP("lp_sta2",psp102_ask_lp_sta2,IF_REAL,"Local parameter STA2 after clipping"),
  OP("lp_a3",psp102_ask_lp_a3,IF_REAL,"Local parameter A3 after clipping"),
  OP("lp_a4",psp102_ask_lp_a4,IF_REAL,"Local parameter A4 after clipping"),
  OP("lp_gco",psp102_ask_lp_gco,IF_REAL,"Local parameter GCO after clipping"),
  OP("lp_iginv",psp102_ask_lp_iginv,IF_REAL,"Local parameter IGINV after T-scaling and clipping"),
  OP("lp_igov",psp102_ask_lp_igov,IF_REAL,"Local parameter IGOV after T-scaling and clipping"),
  OP("lp_igovd",psp102_ask_lp_igovd,IF_REAL,"Local parameter IGOVD after T-scaling and clipping"),
  OP("lp_stig",psp102_ask_lp_stig,IF_REAL,"Local parameter STIG after clipping"),
  OP("lp_gc2",psp102_ask_lp_gc2,IF_REAL,"Local parameter GC2 after clipping"),
  OP("lp_gc3",psp102_ask_lp_gc3,IF_REAL,"Local parameter GC3 after clipping"),
  OP("lp_chib",psp102_ask_lp_chib,IF_REAL,"Local parameter CHIB after clipping"),
  OP("lp_agidl",psp102_ask_lp_agidl,IF_REAL,"Local parameter AGIDL after clipping"),
  OP("lp_agidld",psp102_ask_lp_agidld,IF_REAL,"Local parameter AGIDLD after clipping"),
  OP("lp_bgidl",psp102_ask_lp_bgidl,IF_REAL,"Local parameter BGIDL after T-scaling and clipping"),
  OP("lp_bgidld",psp102_ask_lp_bgidld,IF_REAL,"Local parameter BGIDLD after T-scaling and clipping"),
  OP("lp_stbgidl",psp102_ask_lp_stbgidl,IF_REAL,"Local parameter STBGIDL after clipping"),
  OP("lp_stbgidld",psp102_ask_lp_stbgidld,IF_REAL,"Local parameter STBGIDLD after clipping"),
  OP("lp_cgidl",psp102_ask_lp_cgidl,IF_REAL,"Local parameter CGIDL after clipping"),
  OP("lp_cgidld",psp102_ask_lp_cgidld,IF_REAL,"Local parameter CGIDLD after clipping"),
  OP("lp_cox",psp102_ask_lp_cox,IF_REAL,"Local parameter COX after clipping"),
  OP("lp_cgov",psp102_ask_lp_cgov,IF_REAL,"Local parameter CGOV after clipping"),
  OP("lp_cgovd",psp102_ask_lp_cgovd,IF_REAL,"Local parameter CGOVD after clipping"),
  OP("lp_cgbov",psp102_ask_lp_cgbov,IF_REAL,"Local parameter CGBOV after clipping"),
  OP("lp_cfr",psp102_ask_lp_cfr,IF_REAL,"Local parameter CFR after clipping"),
  OP("lp_cfrd",psp102_ask_lp_cfrd,IF_REAL,"Local parameter CFRD after clipping"),
  OP("lp_fnt",psp102_ask_lp_fnt,IF_REAL,"Local parameter FNT after clipping"),
  OP("lp_fntexc",psp102_ask_lp_fntexc,IF_REAL,"Local parameter FNTEXC after clipping"),
  OP("lp_nfa",psp102_ask_lp_nfa,IF_REAL,"Local parameter NFA after clipping"),
  OP("lp_nfb",psp102_ask_lp_nfb,IF_REAL,"Local parameter NFB after clipping"),
  OP("lp_nfc",psp102_ask_lp_nfc,IF_REAL,"Local parameter NFC after clipping"),
  OP("lp_ef",psp102_ask_lp_ef,IF_REAL,"Local parameter EF after clipping"),
  OP("lp_rg",psp102_ask_lp_rg,IF_REAL,"Local parameter RG after clipping"),
  OP("lp_rbulk",psp102_ask_lp_rbulk,IF_REAL,"Local parameter RBULK after clipping"),
  OP("lp_rwell",psp102_ask_lp_rwell,IF_REAL,"Local parameter RWELL after clipping"),
  OP("lp_rjuns",psp102_ask_lp_rjuns,IF_REAL,"Local parameter RJUNS after clipping"),
  OP("lp_rjund",psp102_ask_lp_rjund,IF_REAL,"Local parameter RJUND after clipping"),
  OP("tk",psp102_ask_tk,IF_REAL,"Device Temperature"),
  OP("cjosbot",psp102_ask_cjosbot,IF_REAL,"Bottom component of total zero-bias source junction capacitance at device temperature"),
  OP("cjossti",psp102_ask_cjossti,IF_REAL,"STI-edge component of total zero-bias source junction capacitance at device temperature"),
  OP("cjosgat",psp102_ask_cjosgat,IF_REAL,"Gate-edge component of total zero-bias source junction capacitance at device temperature"),
  OP("vbisbot",psp102_ask_vbisbot,IF_REAL,"Built-in voltage of source-side bottom junction at device temperature"),
  OP("vbissti",psp102_ask_vbissti,IF_REAL,"Built-in voltage of source-side STI-edge junction at device temperature"),
  OP("vbisgat",psp102_ask_vbisgat,IF_REAL,"Built-in voltage of source-side gate-edge junction at device temperature"),
  OP("idsatsbot",psp102_ask_idsatsbot,IF_REAL,"Total source-side bottom junction saturation current"),
  OP("idsatssti",psp102_ask_idsatssti,IF_REAL,"Total source-side STI-edge junction saturation current"),
  OP("idsatsgat",psp102_ask_idsatsgat,IF_REAL,"Total source-side gate-edge junction saturation current"),
  OP("cjosbotd",psp102_ask_cjosbotd,IF_REAL,"Bottom component of total zero-bias drain junction capacitance at device temperature"),
  OP("cjosstid",psp102_ask_cjosstid,IF_REAL,"STI-edge component of total zero-bias drain junction capacitance at device temperature"),
  OP("cjosgatd",psp102_ask_cjosgatd,IF_REAL,"Gate-edge component of total zero-bias drain junction capacitance at device temperature"),
  OP("vbisbotd",psp102_ask_vbisbotd,IF_REAL,"Built-in voltage of drain-side bottom junction at device temperature"),
  OP("vbisstid",psp102_ask_vbisstid,IF_REAL,"Built-in voltage of drain-side STI-edge junction at device temperature"),
  OP("vbisgatd",psp102_ask_vbisgatd,IF_REAL,"Built-in voltage of drain-side gate-edge junction at device temperature"),
  OP("idsatsbotd",psp102_ask_idsatsbotd,IF_REAL,"Total drain-side bottom junction saturation current"),
  OP("idsatsstid",psp102_ask_idsatsstid,IF_REAL,"Total drain-side STI-edge junction saturation current"),
  OP("idsatsgatd",psp102_ask_idsatsgatd,IF_REAL,"Total drain-side gate-edge junction saturation current"),
};
IFparm psp102mPTable[] = {
 IOP("level",psp102_model_LEVEL,IF_REAL,"LEVEL"),
 IOP("type",psp102_model_TYPE,IF_INTEGER,"TYPE"),
 IOP("nmos",psp102_model_nmos,IF_INTEGER,"nmos"),
 IOP("pmos",psp102_model_pmos,IF_INTEGER,"pmos"),
 IOP("tr",psp102_model_TR,IF_REAL,"TR"),
 IOP("swigate",psp102_model_SWIGATE,IF_REAL,"SWIGATE"),
 IOP("swimpact",psp102_model_SWIMPACT,IF_REAL,"SWIMPACT"),
 IOP("swgidl",psp102_model_SWGIDL,IF_REAL,"SWGIDL"),
 IOP("swjuncap",psp102_model_SWJUNCAP,IF_REAL,"SWJUNCAP"),
 IOP("swjunasym",psp102_model_SWJUNASYM,IF_REAL,"SWJUNASYM"),
 IOP("qmc",psp102_model_QMC,IF_REAL,"QMC"),
 IOP("lvaro",psp102_model_LVARO,IF_REAL,"LVARO"),
 IOP("lvarl",psp102_model_LVARL,IF_REAL,"LVARL"),
 IOP("lvarw",psp102_model_LVARW,IF_REAL,"LVARW"),
 IOP("lap",psp102_model_LAP,IF_REAL,"LAP"),
 IOP("wvaro",psp102_model_WVARO,IF_REAL,"WVARO"),
 IOP("wvarl",psp102_model_WVARL,IF_REAL,"WVARL"),
 IOP("wvarw",psp102_model_WVARW,IF_REAL,"WVARW"),
 IOP("wot",psp102_model_WOT,IF_REAL,"WOT"),
 IOP("dlq",psp102_model_DLQ,IF_REAL,"DLQ"),
 IOP("dwq",psp102_model_DWQ,IF_REAL,"DWQ"),
 IOP("vfbo",psp102_model_VFBO,IF_REAL,"VFBO"),
 IOP("vfbl",psp102_model_VFBL,IF_REAL,"VFBL"),
 IOP("vfbw",psp102_model_VFBW,IF_REAL,"VFBW"),
 IOP("vfblw",psp102_model_VFBLW,IF_REAL,"VFBLW"),
 IOP("stvfbo",psp102_model_STVFBO,IF_REAL,"STVFBO"),
 IOP("stvfbl",psp102_model_STVFBL,IF_REAL,"STVFBL"),
 IOP("stvfbw",psp102_model_STVFBW,IF_REAL,"STVFBW"),
 IOP("stvfblw",psp102_model_STVFBLW,IF_REAL,"STVFBLW"),
 IOP("toxo",psp102_model_TOXO,IF_REAL,"TOXO"),
 IOP("epsroxo",psp102_model_EPSROXO,IF_REAL,"EPSROXO"),
 IOP("nsubo",psp102_model_NSUBO,IF_REAL,"NSUBO"),
 IOP("nsubw",psp102_model_NSUBW,IF_REAL,"NSUBW"),
 IOP("wseg",psp102_model_WSEG,IF_REAL,"WSEG"),
 IOP("npck",psp102_model_NPCK,IF_REAL,"NPCK"),
 IOP("npckw",psp102_model_NPCKW,IF_REAL,"NPCKW"),
 IOP("wsegp",psp102_model_WSEGP,IF_REAL,"WSEGP"),
 IOP("lpck",psp102_model_LPCK,IF_REAL,"LPCK"),
 IOP("lpckw",psp102_model_LPCKW,IF_REAL,"LPCKW"),
 IOP("fol1",psp102_model_FOL1,IF_REAL,"FOL1"),
 IOP("fol2",psp102_model_FOL2,IF_REAL,"FOL2"),
 IOP("vnsubo",psp102_model_VNSUBO,IF_REAL,"VNSUBO"),
 IOP("nslpo",psp102_model_NSLPO,IF_REAL,"NSLPO"),
 IOP("dnsubo",psp102_model_DNSUBO,IF_REAL,"DNSUBO"),
 IOP("dphibo",psp102_model_DPHIBO,IF_REAL,"DPHIBO"),
 IOP("dphibl",psp102_model_DPHIBL,IF_REAL,"DPHIBL"),
 IOP("dphiblexp",psp102_model_DPHIBLEXP,IF_REAL,"DPHIBLEXP"),
 IOP("dphibw",psp102_model_DPHIBW,IF_REAL,"DPHIBW"),
 IOP("dphiblw",psp102_model_DPHIBLW,IF_REAL,"DPHIBLW"),
 IOP("npo",psp102_model_NPO,IF_REAL,"NPO"),
 IOP("npl",psp102_model_NPL,IF_REAL,"NPL"),
 IOP("cto",psp102_model_CTO,IF_REAL,"CTO"),
 IOP("ctl",psp102_model_CTL,IF_REAL,"CTL"),
 IOP("ctlexp",psp102_model_CTLEXP,IF_REAL,"CTLEXP"),
 IOP("ctw",psp102_model_CTW,IF_REAL,"CTW"),
 IOP("ctlw",psp102_model_CTLW,IF_REAL,"CTLW"),
 IOP("toxovo",psp102_model_TOXOVO,IF_REAL,"TOXOVO"),
 IOP("toxovdo",psp102_model_TOXOVDO,IF_REAL,"TOXOVDO"),
 IOP("lov",psp102_model_LOV,IF_REAL,"LOV"),
 IOP("lovd",psp102_model_LOVD,IF_REAL,"LOVD"),
 IOP("novo",psp102_model_NOVO,IF_REAL,"NOVO"),
 IOP("novdo",psp102_model_NOVDO,IF_REAL,"NOVDO"),
 IOP("cfl",psp102_model_CFL,IF_REAL,"CFL"),
 IOP("cflexp",psp102_model_CFLEXP,IF_REAL,"CFLEXP"),
 IOP("cfw",psp102_model_CFW,IF_REAL,"CFW"),
 IOP("cfbo",psp102_model_CFBO,IF_REAL,"CFBO"),
 IOP("uo",psp102_model_UO,IF_REAL,"UO"),
 IOP("fbet1",psp102_model_FBET1,IF_REAL,"FBET1"),
 IOP("fbet1w",psp102_model_FBET1W,IF_REAL,"FBET1W"),
 IOP("lp1",psp102_model_LP1,IF_REAL,"LP1"),
 IOP("lp1w",psp102_model_LP1W,IF_REAL,"LP1W"),
 IOP("fbet2",psp102_model_FBET2,IF_REAL,"FBET2"),
 IOP("lp2",psp102_model_LP2,IF_REAL,"LP2"),
 IOP("betw1",psp102_model_BETW1,IF_REAL,"BETW1"),
 IOP("betw2",psp102_model_BETW2,IF_REAL,"BETW2"),
 IOP("wbet",psp102_model_WBET,IF_REAL,"WBET"),
 IOP("stbeto",psp102_model_STBETO,IF_REAL,"STBETO"),
 IOP("stbetl",psp102_model_STBETL,IF_REAL,"STBETL"),
 IOP("stbetw",psp102_model_STBETW,IF_REAL,"STBETW"),
 IOP("stbetlw",psp102_model_STBETLW,IF_REAL,"STBETLW"),
 IOP("mueo",psp102_model_MUEO,IF_REAL,"MUEO"),
 IOP("muew",psp102_model_MUEW,IF_REAL,"MUEW"),
 IOP("stmueo",psp102_model_STMUEO,IF_REAL,"STMUEO"),
 IOP("themuo",psp102_model_THEMUO,IF_REAL,"THEMUO"),
 IOP("stthemuo",psp102_model_STTHEMUO,IF_REAL,"STTHEMUO"),
 IOP("cso",psp102_model_CSO,IF_REAL,"CSO"),
 IOP("csl",psp102_model_CSL,IF_REAL,"CSL"),
 IOP("cslexp",psp102_model_CSLEXP,IF_REAL,"CSLEXP"),
 IOP("csw",psp102_model_CSW,IF_REAL,"CSW"),
 IOP("cslw",psp102_model_CSLW,IF_REAL,"CSLW"),
 IOP("stcso",psp102_model_STCSO,IF_REAL,"STCSO"),
 IOP("xcoro",psp102_model_XCORO,IF_REAL,"XCORO"),
 IOP("xcorl",psp102_model_XCORL,IF_REAL,"XCORL"),
 IOP("xcorw",psp102_model_XCORW,IF_REAL,"XCORW"),
 IOP("xcorlw",psp102_model_XCORLW,IF_REAL,"XCORLW"),
 IOP("stxcoro",psp102_model_STXCORO,IF_REAL,"STXCORO"),
 IOP("fetao",psp102_model_FETAO,IF_REAL,"FETAO"),
 IOP("rsw1",psp102_model_RSW1,IF_REAL,"RSW1"),
 IOP("rsw2",psp102_model_RSW2,IF_REAL,"RSW2"),
 IOP("strso",psp102_model_STRSO,IF_REAL,"STRSO"),
 IOP("rsbo",psp102_model_RSBO,IF_REAL,"RSBO"),
 IOP("rsgo",psp102_model_RSGO,IF_REAL,"RSGO"),
 IOP("thesato",psp102_model_THESATO,IF_REAL,"THESATO"),
 IOP("thesatl",psp102_model_THESATL,IF_REAL,"THESATL"),
 IOP("thesatlexp",psp102_model_THESATLEXP,IF_REAL,"THESATLEXP"),
 IOP("thesatw",psp102_model_THESATW,IF_REAL,"THESATW"),
 IOP("thesatlw",psp102_model_THESATLW,IF_REAL,"THESATLW"),
 IOP("stthesato",psp102_model_STTHESATO,IF_REAL,"STTHESATO"),
 IOP("stthesatl",psp102_model_STTHESATL,IF_REAL,"STTHESATL"),
 IOP("stthesatw",psp102_model_STTHESATW,IF_REAL,"STTHESATW"),
 IOP("stthesatlw",psp102_model_STTHESATLW,IF_REAL,"STTHESATLW"),
 IOP("thesatbo",psp102_model_THESATBO,IF_REAL,"THESATBO"),
 IOP("thesatgo",psp102_model_THESATGO,IF_REAL,"THESATGO"),
 IOP("axo",psp102_model_AXO,IF_REAL,"AXO"),
 IOP("axl",psp102_model_AXL,IF_REAL,"AXL"),
 IOP("alpl",psp102_model_ALPL,IF_REAL,"ALPL"),
 IOP("alplexp",psp102_model_ALPLEXP,IF_REAL,"ALPLEXP"),
 IOP("alpw",psp102_model_ALPW,IF_REAL,"ALPW"),
 IOP("alp1l1",psp102_model_ALP1L1,IF_REAL,"ALP1L1"),
 IOP("alp1lexp",psp102_model_ALP1LEXP,IF_REAL,"ALP1LEXP"),
 IOP("alp1l2",psp102_model_ALP1L2,IF_REAL,"ALP1L2"),
 IOP("alp1w",psp102_model_ALP1W,IF_REAL,"ALP1W"),
 IOP("alp2l1",psp102_model_ALP2L1,IF_REAL,"ALP2L1"),
 IOP("alp2lexp",psp102_model_ALP2LEXP,IF_REAL,"ALP2LEXP"),
 IOP("alp2l2",psp102_model_ALP2L2,IF_REAL,"ALP2L2"),
 IOP("alp2w",psp102_model_ALP2W,IF_REAL,"ALP2W"),
 IOP("vpo",psp102_model_VPO,IF_REAL,"VPO"),
 IOP("a1o",psp102_model_A1O,IF_REAL,"A1O"),
 IOP("a1l",psp102_model_A1L,IF_REAL,"A1L"),
 IOP("a1w",psp102_model_A1W,IF_REAL,"A1W"),
 IOP("a2o",psp102_model_A2O,IF_REAL,"A2O"),
 IOP("sta2o",psp102_model_STA2O,IF_REAL,"STA2O"),
 IOP("a3o",psp102_model_A3O,IF_REAL,"A3O"),
 IOP("a3l",psp102_model_A3L,IF_REAL,"A3L"),
 IOP("a3w",psp102_model_A3W,IF_REAL,"A3W"),
 IOP("a4o",psp102_model_A4O,IF_REAL,"A4O"),
 IOP("a4l",psp102_model_A4L,IF_REAL,"A4L"),
 IOP("a4w",psp102_model_A4W,IF_REAL,"A4W"),
 IOP("gcoo",psp102_model_GCOO,IF_REAL,"GCOO"),
 IOP("iginvlw",psp102_model_IGINVLW,IF_REAL,"IGINVLW"),
 IOP("igovw",psp102_model_IGOVW,IF_REAL,"IGOVW"),
 IOP("igovdw",psp102_model_IGOVDW,IF_REAL,"IGOVDW"),
 IOP("stigo",psp102_model_STIGO,IF_REAL,"STIGO"),
 IOP("gc2o",psp102_model_GC2O,IF_REAL,"GC2O"),
 IOP("gc3o",psp102_model_GC3O,IF_REAL,"GC3O"),
 IOP("chibo",psp102_model_CHIBO,IF_REAL,"CHIBO"),
 IOP("agidlw",psp102_model_AGIDLW,IF_REAL,"AGIDLW"),
 IOP("agidldw",psp102_model_AGIDLDW,IF_REAL,"AGIDLDW"),
 IOP("bgidlo",psp102_model_BGIDLO,IF_REAL,"BGIDLO"),
 IOP("bgidldo",psp102_model_BGIDLDO,IF_REAL,"BGIDLDO"),
 IOP("stbgidlo",psp102_model_STBGIDLO,IF_REAL,"STBGIDLO"),
 IOP("stbgidldo",psp102_model_STBGIDLDO,IF_REAL,"STBGIDLDO"),
 IOP("cgidlo",psp102_model_CGIDLO,IF_REAL,"CGIDLO"),
 IOP("cgidldo",psp102_model_CGIDLDO,IF_REAL,"CGIDLDO"),
 IOP("cgbovl",psp102_model_CGBOVL,IF_REAL,"CGBOVL"),
 IOP("cfrw",psp102_model_CFRW,IF_REAL,"CFRW"),
 IOP("cfrdw",psp102_model_CFRDW,IF_REAL,"CFRDW"),
 IOP("fnto",psp102_model_FNTO,IF_REAL,"FNTO"),
 IOP("fntexcl",psp102_model_FNTEXCL,IF_REAL,"FNTEXCL"),
 IOP("nfalw",psp102_model_NFALW,IF_REAL,"NFALW"),
 IOP("nfblw",psp102_model_NFBLW,IF_REAL,"NFBLW"),
 IOP("nfclw",psp102_model_NFCLW,IF_REAL,"NFCLW"),
 IOP("efo",psp102_model_EFO,IF_REAL,"EFO"),
 IOP("lintnoi",psp102_model_LINTNOI,IF_REAL,"LINTNOI"),
 IOP("alpnoi",psp102_model_ALPNOI,IF_REAL,"ALPNOI"),
 IOP("dta",psp102_model_DTA,IF_REAL,"DTA"),
 IOP("kvthoweo",psp102_model_KVTHOWEO,IF_REAL,"KVTHOWEO"),
 IOP("kvthowel",psp102_model_KVTHOWEL,IF_REAL,"KVTHOWEL"),
 IOP("kvthowew",psp102_model_KVTHOWEW,IF_REAL,"KVTHOWEW"),
 IOP("kvthowelw",psp102_model_KVTHOWELW,IF_REAL,"KVTHOWELW"),
 IOP("kuoweo",psp102_model_KUOWEO,IF_REAL,"KUOWEO"),
 IOP("kuowel",psp102_model_KUOWEL,IF_REAL,"KUOWEL"),
 IOP("kuowew",psp102_model_KUOWEW,IF_REAL,"KUOWEW"),
 IOP("kuowelw",psp102_model_KUOWELW,IF_REAL,"KUOWELW"),
 IOP("rgo",psp102_model_RGO,IF_REAL,"RGO"),
 IOP("rbulko",psp102_model_RBULKO,IF_REAL,"RBULKO"),
 IOP("rwello",psp102_model_RWELLO,IF_REAL,"RWELLO"),
 IOP("rjunso",psp102_model_RJUNSO,IF_REAL,"RJUNSO"),
 IOP("rjundo",psp102_model_RJUNDO,IF_REAL,"RJUNDO"),
 IOP("rint",psp102_model_RINT,IF_REAL,"RINT"),
 IOP("rvpoly",psp102_model_RVPOLY,IF_REAL,"RVPOLY"),
 IOP("rshg",psp102_model_RSHG,IF_REAL,"RSHG"),
 IOP("dlsil",psp102_model_DLSIL,IF_REAL,"DLSIL"),
 IOP("saref",psp102_model_SAREF,IF_REAL,"SAREF"),
 IOP("sbref",psp102_model_SBREF,IF_REAL,"SBREF"),
 IOP("wlod",psp102_model_WLOD,IF_REAL,"WLOD"),
 IOP("kuo",psp102_model_KUO,IF_REAL,"KUO"),
 IOP("kvsat",psp102_model_KVSAT,IF_REAL,"KVSAT"),
 IOP("tkuo",psp102_model_TKUO,IF_REAL,"TKUO"),
 IOP("lkuo",psp102_model_LKUO,IF_REAL,"LKUO"),
 IOP("wkuo",psp102_model_WKUO,IF_REAL,"WKUO"),
 IOP("pkuo",psp102_model_PKUO,IF_REAL,"PKUO"),
 IOP("llodkuo",psp102_model_LLODKUO,IF_REAL,"LLODKUO"),
 IOP("wlodkuo",psp102_model_WLODKUO,IF_REAL,"WLODKUO"),
 IOP("kvtho",psp102_model_KVTHO,IF_REAL,"KVTHO"),
 IOP("lkvtho",psp102_model_LKVTHO,IF_REAL,"LKVTHO"),
 IOP("wkvtho",psp102_model_WKVTHO,IF_REAL,"WKVTHO"),
 IOP("pkvtho",psp102_model_PKVTHO,IF_REAL,"PKVTHO"),
 IOP("llodvth",psp102_model_LLODVTH,IF_REAL,"LLODVTH"),
 IOP("wlodvth",psp102_model_WLODVTH,IF_REAL,"WLODVTH"),
 IOP("stetao",psp102_model_STETAO,IF_REAL,"STETAO"),
 IOP("lodetao",psp102_model_LODETAO,IF_REAL,"LODETAO"),
 IOP("scref",psp102_model_SCREF,IF_REAL,"SCREF"),
 IOP("web",psp102_model_WEB,IF_REAL,"WEB"),
 IOP("wec",psp102_model_WEC,IF_REAL,"WEC"),
 IOP("imax",psp102_model_IMAX,IF_REAL,"IMAX"),
 IOP("trj",psp102_model_TRJ,IF_REAL,"TRJ"),
 IOP("cjorbot",psp102_model_CJORBOT,IF_REAL,"CJORBOT"),
 IOP("cjorsti",psp102_model_CJORSTI,IF_REAL,"CJORSTI"),
 IOP("cjorgat",psp102_model_CJORGAT,IF_REAL,"CJORGAT"),
 IOP("vbirbot",psp102_model_VBIRBOT,IF_REAL,"VBIRBOT"),
 IOP("vbirsti",psp102_model_VBIRSTI,IF_REAL,"VBIRSTI"),
 IOP("vbirgat",psp102_model_VBIRGAT,IF_REAL,"VBIRGAT"),
 IOP("pbot",psp102_model_PBOT,IF_REAL,"PBOT"),
 IOP("psti",psp102_model_PSTI,IF_REAL,"PSTI"),
 IOP("pgat",psp102_model_PGAT,IF_REAL,"PGAT"),
 IOP("phigbot",psp102_model_PHIGBOT,IF_REAL,"PHIGBOT"),
 IOP("phigsti",psp102_model_PHIGSTI,IF_REAL,"PHIGSTI"),
 IOP("phiggat",psp102_model_PHIGGAT,IF_REAL,"PHIGGAT"),
 IOP("idsatrbot",psp102_model_IDSATRBOT,IF_REAL,"IDSATRBOT"),
 IOP("idsatrsti",psp102_model_IDSATRSTI,IF_REAL,"IDSATRSTI"),
 IOP("idsatrgat",psp102_model_IDSATRGAT,IF_REAL,"IDSATRGAT"),
 IOP("csrhbot",psp102_model_CSRHBOT,IF_REAL,"CSRHBOT"),
 IOP("csrhsti",psp102_model_CSRHSTI,IF_REAL,"CSRHSTI"),
 IOP("csrhgat",psp102_model_CSRHGAT,IF_REAL,"CSRHGAT"),
 IOP("xjunsti",psp102_model_XJUNSTI,IF_REAL,"XJUNSTI"),
 IOP("xjungat",psp102_model_XJUNGAT,IF_REAL,"XJUNGAT"),
 IOP("ctatbot",psp102_model_CTATBOT,IF_REAL,"CTATBOT"),
 IOP("ctatsti",psp102_model_CTATSTI,IF_REAL,"CTATSTI"),
 IOP("ctatgat",psp102_model_CTATGAT,IF_REAL,"CTATGAT"),
 IOP("mefftatbot",psp102_model_MEFFTATBOT,IF_REAL,"MEFFTATBOT"),
 IOP("mefftatsti",psp102_model_MEFFTATSTI,IF_REAL,"MEFFTATSTI"),
 IOP("mefftatgat",psp102_model_MEFFTATGAT,IF_REAL,"MEFFTATGAT"),
 IOP("cbbtbot",psp102_model_CBBTBOT,IF_REAL,"CBBTBOT"),
 IOP("cbbtsti",psp102_model_CBBTSTI,IF_REAL,"CBBTSTI"),
 IOP("cbbtgat",psp102_model_CBBTGAT,IF_REAL,"CBBTGAT"),
 IOP("fbbtrbot",psp102_model_FBBTRBOT,IF_REAL,"FBBTRBOT"),
 IOP("fbbtrsti",psp102_model_FBBTRSTI,IF_REAL,"FBBTRSTI"),
 IOP("fbbtrgat",psp102_model_FBBTRGAT,IF_REAL,"FBBTRGAT"),
 IOP("stfbbtbot",psp102_model_STFBBTBOT,IF_REAL,"STFBBTBOT"),
 IOP("stfbbtsti",psp102_model_STFBBTSTI,IF_REAL,"STFBBTSTI"),
 IOP("stfbbtgat",psp102_model_STFBBTGAT,IF_REAL,"STFBBTGAT"),
 IOP("vbrbot",psp102_model_VBRBOT,IF_REAL,"VBRBOT"),
 IOP("vbrsti",psp102_model_VBRSTI,IF_REAL,"VBRSTI"),
 IOP("vbrgat",psp102_model_VBRGAT,IF_REAL,"VBRGAT"),
 IOP("pbrbot",psp102_model_PBRBOT,IF_REAL,"PBRBOT"),
 IOP("pbrsti",psp102_model_PBRSTI,IF_REAL,"PBRSTI"),
 IOP("pbrgat",psp102_model_PBRGAT,IF_REAL,"PBRGAT"),
 IOP("cjorbotd",psp102_model_CJORBOTD,IF_REAL,"CJORBOTD"),
 IOP("cjorstid",psp102_model_CJORSTID,IF_REAL,"CJORSTID"),
 IOP("cjorgatd",psp102_model_CJORGATD,IF_REAL,"CJORGATD"),
 IOP("vbirbotd",psp102_model_VBIRBOTD,IF_REAL,"VBIRBOTD"),
 IOP("vbirstid",psp102_model_VBIRSTID,IF_REAL,"VBIRSTID"),
 IOP("vbirgatd",psp102_model_VBIRGATD,IF_REAL,"VBIRGATD"),
 IOP("pbotd",psp102_model_PBOTD,IF_REAL,"PBOTD"),
 IOP("pstid",psp102_model_PSTID,IF_REAL,"PSTID"),
 IOP("pgatd",psp102_model_PGATD,IF_REAL,"PGATD"),
 IOP("phigbotd",psp102_model_PHIGBOTD,IF_REAL,"PHIGBOTD"),
 IOP("phigstid",psp102_model_PHIGSTID,IF_REAL,"PHIGSTID"),
 IOP("phiggatd",psp102_model_PHIGGATD,IF_REAL,"PHIGGATD"),
 IOP("idsatrbotd",psp102_model_IDSATRBOTD,IF_REAL,"IDSATRBOTD"),
 IOP("idsatrstid",psp102_model_IDSATRSTID,IF_REAL,"IDSATRSTID"),
 IOP("idsatrgatd",psp102_model_IDSATRGATD,IF_REAL,"IDSATRGATD"),
 IOP("csrhbotd",psp102_model_CSRHBOTD,IF_REAL,"CSRHBOTD"),
 IOP("csrhstid",psp102_model_CSRHSTID,IF_REAL,"CSRHSTID"),
 IOP("csrhgatd",psp102_model_CSRHGATD,IF_REAL,"CSRHGATD"),
 IOP("xjunstid",psp102_model_XJUNSTID,IF_REAL,"XJUNSTID"),
 IOP("xjungatd",psp102_model_XJUNGATD,IF_REAL,"XJUNGATD"),
 IOP("ctatbotd",psp102_model_CTATBOTD,IF_REAL,"CTATBOTD"),
 IOP("ctatstid",psp102_model_CTATSTID,IF_REAL,"CTATSTID"),
 IOP("ctatgatd",psp102_model_CTATGATD,IF_REAL,"CTATGATD"),
 IOP("mefftatbotd",psp102_model_MEFFTATBOTD,IF_REAL,"MEFFTATBOTD"),
 IOP("mefftatstid",psp102_model_MEFFTATSTID,IF_REAL,"MEFFTATSTID"),
 IOP("mefftatgatd",psp102_model_MEFFTATGATD,IF_REAL,"MEFFTATGATD"),
 IOP("cbbtbotd",psp102_model_CBBTBOTD,IF_REAL,"CBBTBOTD"),
 IOP("cbbtstid",psp102_model_CBBTSTID,IF_REAL,"CBBTSTID"),
 IOP("cbbtgatd",psp102_model_CBBTGATD,IF_REAL,"CBBTGATD"),
 IOP("fbbtrbotd",psp102_model_FBBTRBOTD,IF_REAL,"FBBTRBOTD"),
 IOP("fbbtrstid",psp102_model_FBBTRSTID,IF_REAL,"FBBTRSTID"),
 IOP("fbbtrgatd",psp102_model_FBBTRGATD,IF_REAL,"FBBTRGATD"),
 IOP("stfbbtbotd",psp102_model_STFBBTBOTD,IF_REAL,"STFBBTBOTD"),
 IOP("stfbbtstid",psp102_model_STFBBTSTID,IF_REAL,"STFBBTSTID"),
 IOP("stfbbtgatd",psp102_model_STFBBTGATD,IF_REAL,"STFBBTGATD"),
 IOP("vbrbotd",psp102_model_VBRBOTD,IF_REAL,"VBRBOTD"),
 IOP("vbrstid",psp102_model_VBRSTID,IF_REAL,"VBRSTID"),
 IOP("vbrgatd",psp102_model_VBRGATD,IF_REAL,"VBRGATD"),
 IOP("pbrbotd",psp102_model_PBRBOTD,IF_REAL,"PBRBOTD"),
 IOP("pbrstid",psp102_model_PBRSTID,IF_REAL,"PBRSTID"),
 IOP("pbrgatd",psp102_model_PBRGATD,IF_REAL,"PBRGATD"),
 IOP("swjunexp",psp102_model_SWJUNEXP,IF_REAL,"SWJUNEXP"),
 IOP("vjunref",psp102_model_VJUNREF,IF_REAL,"VJUNREF"),
 IOP("fjunq",psp102_model_FJUNQ,IF_REAL,"FJUNQ"),
 IOP("vjunrefd",psp102_model_VJUNREFD,IF_REAL,"VJUNREFD"),
 IOP("fjunqd",psp102_model_FJUNQD,IF_REAL,"FJUNQD")
};


char *psp102names[] = { "D",
 "G",
 "S",
 "B"
};

int psp102nSize = NUMELEMS(psp102names);
int psp102pTSize = NUMELEMS(psp102pTable);
int psp102mPTSize = NUMELEMS(psp102mPTable);
int psp102iSize = sizeof(psp102instance);
int psp102mSize = sizeof(psp102model);
